<?php
class MC_Bundle_Controller
{
	public function __construct()
	{
		add_filter( 'display_post_states', function ( $states, $post ) {
			  	if ( intval( get_option( '_mc_class_bundle_page_id' ) ) === $post->ID ) {
			        $states[] = __( 'MC Bundle Package Page' );
			    }

			    return $states;
			}, 10, 2 );
	}
	public static function display_bundle_html(){
		$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
		if( empty($mc_cls_bundle_package_product) ){
			echo "<span class='class-makr-bundle-missing'>Bundle package product is missing.</span>";
			return;
		}

		$mc_cls_bundle_title = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
		//$mc_cls_bundle_price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : 'FREE';
		$mc_cls_bundle_price = get_option('mc_cls_bundle_price') ? 'FREE' : 'FREE';
		$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : '';
        $currency_arr = explode("-",$currency);
        $mc_cls_bundle_price_txt = get_option('mc_cls_bundle_price_txt') ? get_option('mc_cls_bundle_price_txt') : 'Get access to all classes';

		?>
		<div class="mcContFull78">
			<?php
			$mc_nav_on_pages = (get_option('mc_nav_on_pages')) ? get_option('mc_nav_on_pages') : 'disable';
			if( is_user_logged_in() && $mc_nav_on_pages == 'enable' ){
				global $current_user;
				$img_url = Common_Functions_Controller::get_avatar_img_url( $current_user->user_email );
		    	
				?>
				<div class="mcUserAccNavUL mcUserAccNavUL-front">
					<div class="mcUserAccNavLILogon"><img src="<?php echo $img_url; ?>" />Hello <?php echo $current_user->display_name; ?></div>
					<div class="mcUserAccNavLI"><a href="<?php echo site_url();?>/mc-dashboard" target="_blank;">My Dashboard</a></div>
					<div class="mcUserAccNavLI"><a href="<?php echo wp_logout_url( home_url().'/mc-login/?logout=success' );?>">Logout</a></div>
				</div>
				<?php
			}

			?>
			<div class="mcContMain78">
				<div id="term-bundle" class="mc_class_cat_box">
					<div class="mc_class_title mc_class_H2"><?php echo $mc_cls_bundle_title; ?></div>
					<div class="mcClassAccessBtn">
						<?php //echo $mc_cls_bundle_price_txt; ?>
			     		<?php if( $mc_cls_bundle_price != 'FREE' ){ ?>
     						<a href="<?php echo site_url().'/mc-registration/?proType=bundle&classId='. base64_encode(get_option( '_mc_class_bundle_id' )); ?>"><?php echo  $mc_cls_bundle_price_txt.' '.$term_meta['mc_cat_price_btn_txt_term_meta'].' '.$currency_arr[1].$mc_cls_bundle_price; ?></a>
     					<?php }else{ ?>
     						<a href="<?php echo site_url().'/mc-registration/?proType=bundle&classId='. base64_encode(get_option( '_mc_class_bundle_id' )); ?>"><?php echo $term_meta['mc_cat_price_btn_txt_term_meta'].' '.$mc_cls_bundle_price; ?></a>
     					<?php } ?>
			     	</div>
			     	<?php
					if( get_option('mc_cls_bundle_desc') ){
						echo '<div class="mcLessonCount">'.stripslashes(get_option('mc_cls_bundle_desc')).'</div>';
					}
					?>
			    </div>
			    <div class="mc_class_all_posts">
			    	<div class="mc_class_UL">
			    		<?php

			    			$count = 1;
		    				foreach ($mc_cls_bundle_package_product as $class)
		    				{
		    					$class_details = get_term_by('id', $class, 'mc-class-category');
		    					$term_id = $class_details->term_id;
		    					$term_meta = get_option( "taxonomy_$term_id" );
		    					$term_long_desc = stripslashes($term_meta['mc_long_desc_term_meta']);
		    					?>
		    					<div class="mc_class_LI">
		    						<!-- <span class="mc_class_post-count"><?php //echo str_pad($count, 2, '0', STR_PAD_LEFT); ?></span> -->
		    						<span class="mc_class_post-title"><?php echo $class_details->name; ?></span>
		    						<div class="mc_class_P"><?php echo strlen(strip_tags($term_long_desc)) > 250 ? substr(strip_tags($term_long_desc),0,250)."..." : strip_tags($term_long_desc); ?></div>
		    						<div class="mc_class_P">
			    						<?php
			    							$url = get_term_link( $class_details->slug, $class_details->taxonomy );
			    						?>
			    						<a href="<?php echo $url; ?>" class="mc_class_button alt" value="Place order">View Class</a>
			    					</div>
		    					</div>
		    					<?php
		    					$count++;
		    				}
		    			?>
			    	</div>
			    </div>
		    </div>
	    </div>
		<?php
	}
	
}