<?php
class Common_Functions_Controller
{	
	public function __construct()
	{
		add_action( 'wp_head',array($this, 'add_custom_style'));
		add_action( 'wp_footer', [$this,'astra_footer_align_bottom'] );
		add_action('wp_footer',[$this,'scrolltoClass']);
		add_action( 'admin_footer', array($this,'change_class_type' ));
		add_filter( 'wp_mail_from', array($this, 'change_mail_form' ));
		add_filter( 'wp_mail_from_name', array($this, 'change_mail_form_name' ));
		add_action( 'after_setup_theme', array($this,'remove_admin_bar'));
		add_action( 'admin_notices', [$this,'elementorreferelNotice'] );
		add_filter( 'wp_nav_menu_items', [$this,'add_loginout_link'], 10, 2 );

	}
	public static function sendMainMail($to,$subject,$body,$header)
	{
	    $mailData=array('to'=>$to,'subject'=>$subject,'body'=>$body,'header'=>$header);
	    $url=get_site_url(1).'/wp-json/class-makr/v1/mail-service/';
        $request = wp_remote_post($url, array(
                'method' => 'POST',
                'headers' => array('Content-Type' => 'application/json; charset=utf-8'),
                'httpversion' => '1.0',
                'sslverify' => false,
                'body' => json_encode(array('mail_data'=>$mailData))
        ));
	}
	public function add_loginout_link( $items, $args )
	{
	    $my_account_link=home_url().'/mc-dashboard';
	    if (is_user_logged_in()) {
	        $items .= '<li><a href="'.$my_account_link.'">My Account</a></li>';
            $items .= '<li><a href="'.wp_logout_url(home_url().'/mc-login/?logout=success').'">Log Out</a></li>';
	    }
	    else
	    {
	        $loginLink=home_url()."/mc-login/?login=success";
	        $items .= '<li><a href="'.$my_account_link.'">My Account</a></li>';
	        $items .= '<li><a href="'.$loginLink.'">Log In</a></li>';
	    }
	    return $items;
	}
	public function scrolltoClass()
	{
	    if(is_tax( 'mc-class-category' ) && wp_get_referer())
	    {
    	   $referer=wp_get_referer();
    	   $check=get_permalink(get_option('_mc_class_account_page_id'));
    	   if($referer==$check)
    	   {
    	       ?>
    	       <script>
    	           jQuery(function($){
        	            $(document).ready(function () {
                            $('html, body').animate({
                                scrollTop: $('.mc_class_title').offset().top
                            }, 'slow');
                        });
    	           });
    	       </script>
    	       <?php
    	   }
    	    
	    }
	    
	}
	public static function userDisplayName($userId)
	{
		$authorData=get_user_by('id',$userId);
        $author=$authorData->display_name;
         return $author;
	}
	public static function lessonLiveStatus($postId)
	{
	    $status='not-active'; 
	    $vid_type = get_post_meta($postId,'_mc_lesson_tutorial_video_type',true);
	    $vid_type=(strlen($vid_type)>0?$vid_type:'youtube');
        $scheduleType=get_post_meta($postId,'_schedule_live_video_class_makr',true);
        $scheduleType=(strlen($scheduleType)>0?$scheduleType:'');
        $scheduleTime=get_post_meta($postId,'_schedule_live_video_class_makr_time',true);
        $scheduleTime=(strlen($scheduleTime)>0?$scheduleTime:'');
        if($vid_type=='youtube-live')
	    {
	        if(strlen($scheduleType)>0)
	        {
	            if (time() >= $scheduleTime) 
	            {
	                $status='active';      
	            }
	            else
	            {
	                 $status='not-active'; 
	            }
	        }
	        else
	        {
	            $status='not-active';
	        }
	    }
	    else
	    {
	        $status='not-active';
	    }
        return $status;
        
	}
	public function astra_footer_align_bottom()
	{
	    $currentTheme=get_option('stylesheet');
	    if($currentTheme=='astra')
	    {
	        ?>
	        <script type="text/javascript">
        		document.addEventListener(
        			"DOMContentLoaded",
        			function() {
        				fullHeight();
        			},
        			false
        			);
        		function fullHeight() {
        			var headerHeight = document.querySelector("header").clientHeight;
        			var footerHeight = document.querySelector("footer").clientHeight;
        			var headerFooter = headerHeight + footerHeight;
        			var content = document.querySelector("#content");
        			content.style.minHeight = "calc( 100vh - " + headerFooter + "px )";
        		}
        	</script>
	        <?php
	    }
	}
	public static function classLessonAccessLink($subscribed,$classId,$lessonId){
	   if( !is_user_logged_in() ){
	       $url=site_url().'/mc-registration/?classId='. base64_encode($classId);
	   }
	   else
	   {
	       $user = wp_get_current_user();
		   $roles=(array) $user->roles;
		   if (! in_array( 'administrator', (array) $user->roles ) ) {
		        if( $subscribed ){
		            $url = get_permalink($lessonId);
		        }
		        else
		        {
		            $url=site_url().'/mc-registration/?classId='. base64_encode($classId);
		        }
		   }
		   else
		   {
		       $url = get_permalink($lessonId);
		   }
	   }
        return $url;
	}
	public static function classTransactionMailReceipt($orderID)
	{
	    $receipt = '';
	    
	    $mc_cls_currency = get_post_meta( $orderID, '_mc_pay_currency', true ) ? get_post_meta( $orderID, '_mc_pay_currency', true ) : 'usd-$';
	   	$currency_arr 	 = explode( "-", $mc_cls_currency);
        $currency 		 = strtoupper($currency_arr[0]);
	    
	    
        $receipt .= '<h2 style="font-weight:400;font-style:normal"><b>Payment Details</b></h2>';
        $receiptInfo=array('Date'=>get_the_date( "l F j, Y, @ h:m:s", $orderID ),
                           'Payment Through'=>get_post_meta( $orderID, "_mc_pay_through", true ),
                           'Transacion ID'=>get_post_meta( $orderID, "_mc_pay_system_tran_id", true ),
                           );
	    
	    if( get_post_meta( $orderID, '_mc_pay_coupon_code', true ) != '' ){
			$receiptInfo['Coupon Code']=get_post_meta( $orderID, "_mc_pay_coupon_code", true);
			$receiptInfo['Subtotal']=$currency_arr[1].''.get_post_meta( $orderID, "_mc_pay_actual_price", true ).' '.$currency;
			$receiptInfo['Coupon Amount']=$currency_arr[1].''.get_post_meta( $orderID, "_mc_pay_discount_amount", true ).' '.$currency;
		}
		$payThrough=get_post_meta( $orderID, '_mc_pay_through', true );
		if($payThrough == 'Stripe'){
            $receiptAmount=$currency_arr[1].''.get_post_meta( $orderID, '_mc_pay_total_amount', true )/100.;
            $receiptInfo['Amount']=$receiptAmount.' '.$currency;
        }
        elseif($payThrough=='Authorize.NET')
        {
            $payType=get_post_meta($orderID,'_mc_pay_unit',true);
            $payTypeTxt=array('months'=>'/month','years'=>'/year','one-time'=>'');
            $receiptAmount=$currency_arr[1].''.get_post_meta( $orderID, '_mc_pay_total_amount', true ).$payTypeTxt[$payType];
            $receiptInfo['Amount']=$receiptAmount.' '.$currency;
        }
        else{
            $receiptAmount=$currency_arr[1].''.get_post_meta( $orderID, '_mc_pay_total_amount', true );
            $receiptInfo['Amount']=$receiptAmount.' '.$currency;
        }
		
		foreach($receiptInfo as $receiptKey=>$receiptVal)
		{
		    $receipt .= '<h2><span style="font-size:14px">'.$receiptKey.'</span><span style="font-weight:400;font-size:14px">:&nbsp;</span>
		            <span style="font-weight:400;font-style:normal;font-size:14px">'.$receiptVal.'</span></h2>';
		}
		return $receipt;
	}
	public static function classMakrCancelAuthoriseSubscription($orderId)
	{
	    $subscription_id = get_post_meta( $orderId, '_mc_subscription_id', true ) ? get_post_meta( $orderId, '_mc_subscription_id', true ) : false;
        if($subscription_id )
        {
            $auth_loginId 	= get_option('mc_cls_auth_api_login_id');
    		$auth_tran_key 	= get_option('mc_cls_auth_tran_key');
    		$auth_mode 		= get_option('mc_cls_auth_mode') ? get_option('mc_cls_auth_mode') : 'sandbox';
    		if($auth_mode=='live')
			{
				$subscription = new AuthnetARB($auth_loginId, $auth_tran_key,'','','','',AuthnetARB::USE_PRODUCTION_SERVER);
			}
			else
			{
				$subscription = new AuthnetARB($auth_loginId, $auth_tran_key,'','','','',AuthnetARB::USE_DEVELOPMENT_SERVER);
			}
			$subscription->setParameter('subscrId', $subscription_id);
            $subscription->deleteAccount(); 
            if(($subscription->isSuccessful()) == 1){
                update_post_meta($orderId,'_mc_order_payment_status','cancelled');
            }
        }
	}
	public static function classLessonGrade($subscribed,$classId,$lessonId)
	{
	    $html='';
	    if( is_user_logged_in() ){
	        $user = wp_get_current_user();
		    $roles=(array) $user->roles;
		    if (! in_array( 'administrator', (array) $user->roles ) ) {
		        if( $subscribed ){
		            $term_meta = get_option( "taxonomy_".$classId );
		            $grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
        		    if( !$grad && $grad == 'none' )
        			    return $html;
        			switch ($grad) {
            			case 'mcq':
            				$key = 'mc_score_for_'.$lessonId.'_based_on_mcq';
            	    		$value = get_user_meta(get_current_user_id(),$key,true );
            	    		$value=($value>0?'<li class="mc_class_persent">'.$value.'%</li>':'');
            				break;
            			case 'confident':
            				$key = 'mc_score_for_'.$lessonId.'_based_on_confident';
            	    		$value = get_user_meta(get_current_user_id(),$key,true );
            	    		$value=($value>0?'<li class="mc_class_persent">'.$value.'%</li>':'');
            				break;
            			case 'checkmark':
            				$key = 'mc_score_for_'.$lessonId.'_based_on_checkmark';
            	    		$value = get_user_meta(get_current_user_id(),$key,true );
            	    		$value=($value=='yes'?'<li class="mc_class_tick"><img src="'.MC_IMG.'/tick.jpg" alt="class-amkr-check"></li>':'');
            				break;
            
            			default:
            				# code...
            				break;
            		}
            		if($value)
            		{
            		    $html='<ul>'.$value.'</ul>';
            		}
		        }
		   }
	    }
	    return $html;
	}
	public static function remove_admin_bar(){
	    if (!current_user_can('administrator') && !is_admin()) {
            show_admin_bar(false);
        }
	}
	public static function change_mail_form_name( $name ){
		return get_bloginfo('name');
	}
	public static function change_mail_form( $email ) {
	    return get_option('admin_email');
	}
	public static function change_class_type(){
		?>
		<script type="text/javascript">
			jQuery("#mc-class-categorychecklist input, #mc-class-categorychecklist-pop input").each(function(){this.type="radio"}); 
			jQuery("#mc-class-category-add-toggle").remove();
		</script>
		<?php


	}
	public function elementorreferelNotice()
	{
	    if(!is_plugin_active( 'elementor-pro/elementor-pro.php' )){
	    ?>
        <div class="error">
	        <div style="padding: 5px;">
	        	<img src="<?php echo MC_IMG;?>/icon.png" style="float:left;padding: 2px;width: 30px;" alt="class-makr">
	        	<p style="text-transform: uppercase;font-weight: 600;"> &nbsp; Want to have access to more beautiful page templates and designs ? 
	        	Upgrade to <a href="https://elementor.com/?ref=9481" target="_blank">Elementor Pro</a></p></div>
	    </div>
        <?php
	    }
	}
	public static function add_custom_style(){
		$mc_acc_nav_clr = get_option('mc_acc_nav_clr') ? get_option('mc_acc_nav_clr') : "#29748A";
		$mc_nav_on_pages = (get_option('mc_nav_on_pages')) ? get_option('mc_nav_on_pages') : 'disable';
		if( $mc_nav_on_pages == 'enable' ){
			$display_status = 'block';
		}else{
			$display_status = 'hide';
		}
		?>
		<style type="text/css">
			.mcUserAccNavUL{
				border-bottom-color: <?php echo $mc_acc_nav_clr; ?> !important;
			}
			.mcUserAccNavUL.mcUserAccNavUL-front .mcUserAccNavLI a, .mcUserAccNavLI{
				color: <?php echo $mc_acc_nav_clr; ?> !important;
			}
			.mcUserAccNavUL.mcUserAccNavUL-front .mcUserAccNavLI a:hover{
				color: <?php echo $mc_acc_nav_clr; ?> !important;
			}
			.mcUserAccNavLI:after{
				background-color: <?php echo $mc_acc_nav_clr; ?> !important;
			}
			
		</style>
		<?php
	}
	public static function get_avatar_img_url( $user_email ) {
	  $authorData=get_user_by('email',$user_email);
	  $avatarID = get_user_meta( $authorData->ID, '_classmakr_avatar_id' , true );
	  $gravatar_url = ($avatarID!=NULL?wp_get_attachment_image_src( $avatarID, 'class-makr-avatar')[0]:MC_IMG.'/default.jpeg');
	  return $gravatar_url;
	}

	public static function generate_iframe($url,$type){
		switch ($type) {
			case 'youtube':
				preg_match("/^(?:http(?:s)?:\/\/)?(?:www\.)?(?:m\.)?(?:youtu\.be\/|youtube\.com\/(?:(?:watch)?\?(?:.*&)?v(?:i)?=|(?:embed|v|vi|user)\/))([^\?&\"'>]+)/", $url, $matches);
				return 'https://www.youtube.com/embed/'.$matches[1];
				break;

			case 'vimeo':
				preg_match('#(?:https?://)?(?:www.)?(?:player.)?vimeo.com/(?:[a-z]*/)*([0-9]{6,11})[?]?.*#', $url, $m);
				return 'https://player.vimeo.com/video/' .$m[1];
				break;

			case 'whistia':
			    $link_array = explode('/',$url);
			    return $id = end($link_array);
				//return "//fast.wistia.net/embed/iframe/".$id;
				break;
			
			default:
				# code...
				break;
		}
	}
	public static function humanTiming ($time)
    {

        $time = time() - $time; // to get the time since that moment
        $time = ($time<1)? 1 : $time;
        $tokens = array (
            31536000 => 'year',
            2592000 => 'month',
            604800 => 'week',
            86400 => 'day',
            3600 => 'hour',
            60 => 'minute',
            1 => 'second'
        );

        foreach ($tokens as $unit => $text) {
            if ($time < $unit) continue;
            $numberOfUnits = floor($time / $unit);
            return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
        }

    }
    public static function generate_video_url($type,$url){
    	switch ($type) {
    		case 'youtube':
    			preg_match("/^(?:http(?:s)?:\/\/)?(?:www\.)?(?:m\.)?(?:youtu\.be\/|youtube\.com\/(?:(?:watch)?\?(?:.*&)?v(?:i)?=|(?:embed|v|vi|user)\/))([^\?&\"'>]+)/", $url, $matches);
				return $matches[1];
    			break;
    		
    		case 'youtube-live':
    			preg_match("/^(?:http(?:s)?:\/\/)?(?:www\.)?(?:m\.)?(?:youtu\.be\/|youtube\.com\/(?:(?:watch)?\?(?:.*&)?v(?:i)?=|(?:embed|v|vi|user)\/))([^\?&\"'>]+)/", $url, $matches);
				return $matches[1];
    			break;

    		case 'vimeo':
    			preg_match('#(?:https?://)?(?:www.)?(?:player.)?vimeo.com/(?:[a-z]*/)*([0-9]{6,11})[?]?.*#', $url, $m);
				return $m[1];
    			break;

    		case 'dropbox':
    			//https://dl.dropboxusercontent.com/s/yaecnvm2wulz6ao/test.mp4?dl=0
    			return str_replace('www.dropbox.com','dl.dropboxusercontent.com',$url);
    			break;

    		case 'googledrive':
    			//https://drive.google.com/uc?export=download&id=0B_w6KZmZrs5gZkM1Y0J2M1F2S2c
    			$url_array = explode("/",$url);
    			return $final_url = 'https://drive.google.com/uc?export=download&id='.$url_array[5];
    			break;

    		case 'amazons3':
    			return $url;
    			break;

    		default:
    			return $url;
    			break;

    		
    	}
    }
}