<?php
class MC_Coupon_Controller
{
	public function __construct()
	{

		add_filter( 'manage_mc_class_coupon_posts_columns', array($this,'set_custom_coupon_columns' ));
		add_action( 'manage_mc_class_coupon_posts_custom_column' , array($this,'get_custom_coupon_column_value'), 10, 2 );

		add_action( 'wp_ajax_check_mc_coupon_code', array($this, 'check_mc_coupon_code_callback' ));
		add_action( 'wp_ajax_nopriv_check_mc_coupon_code', array($this, 'check_mc_coupon_code_callback' ));

		add_action( 'wp_ajax_apply_mc_coupon_code', array($this, 'apply_mc_coupon_code_callback' ));
		add_action( 'wp_ajax_nopriv_apply_mc_coupon_code', array($this, 'apply_mc_coupon_code_callback' ));
	}
	
	public function set_custom_coupon_columns( $old_columns ){
		$new_columns['cb'] = '';
		$new_columns['title'] = __( 'Title', 'wordpress' );
		$new_columns['mc_coupon_code'] = __( 'Code', 'wordpress' );
		$new_columns['mc_coupon_amount'] = __( 'Amount', 'wordpress' );
		

		$column = array_merge( $new_columns,$old_columns );

    	return $column;
	}

	public function get_custom_coupon_column_value( $column, $post_id ){
		switch ( $column ) {


	       	case 'mc_coupon_code':
	       		echo get_post_meta( $post_id, '_mc_coupon_code', true );
	       		break;
	       	case 'mc_coupon_amount':
	       		echo get_post_meta( $post_id, '_mc_coupon_amount', true );
	       		break;

	    }
	}

	public static function check_mc_coupon_code_callback(){
		if( !trim($_POST['code']) ){
			echo "error";
			die;
		}
		$all_coupon = MC_Coupon_Controller::list_meta_values( '_mc_coupon_code' );
		if( in_array($_POST['code'], $all_coupon)){
			echo "success";
			die;
		}else{
			echo "error";
			die;
		}
		
	}

	public static function apply_mc_coupon_code_callback(){
		//echo "<pre>"; print_r($_POST); echo "</pre>"; die;
		if( !trim($_POST['code']) &&  !trim($_POST['id']) ){
			echo "error";
			die;
		}
		$all_coupon = MC_Coupon_Controller::list_meta_values( '_mc_coupon_code' );
		if( in_array($_POST['code'], $all_coupon)){
			
			global $wpdb;
			$r = $wpdb->get_col( $wpdb->prepare( "
		        SELECT post_id
		        FROM $wpdb->postmeta
		        WHERE meta_value = '%s' AND meta_key = '_mc_coupon_code'
		    ", $_POST['code'] ) );
		    $post_id = $r[0];
		    $coupon_amount = get_post_meta( $post_id, '_mc_coupon_amount', true );
		    $coupon_type = get_post_meta( $post_id, '_mc_coupon_type', true );



		    $courseid = $_POST['id'];

		    
		    $bundle_id = get_option( '_mc_class_bundle_id' );

	    	if( $courseid == $bundle_id ){
	    		//$selected_price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : 'FREE';
	    		$selected_price = get_option('mc_cls_bundle_price') ? 'FREE' : 'FREE';
	    		$courseid = $bundle_id;
	    	}else{
	    		$term_meta = get_option( "taxonomy_$courseid" );
				//$selected_price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : 'FREE';
				$selected_price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? 'FREE' : 'FREE';
	    	}

		 //    $selected_term_meta = get_option( "taxonomy_$courseid" );
			// $selected_price = esc_attr( $selected_term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $selected_term_meta['mc_cat_price_term_meta'] ) : 'FREE';

			if( $selected_price != 'FREE'){
				
				if( $coupon_type == 'percentage' ){
					$coupon_amount = ($selected_price*$coupon_amount)/100;
					$final_amount = $selected_price-$coupon_amount;
				}else{
					if( $coupon_amount > $selected_price ){
						echo "error";
						die;
					}
					$final_amount = $selected_price-$coupon_amount;
				}
				$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : '';
            	$currency_arr = explode("-",$currency);
            	echo $final_amount;
				die;
			}else{
				echo "error";
				die;
			}
		}else{
			echo "error";
			die;
		}
		
	}
	public static function list_meta_values( $key ) {
	    global $wpdb;
	    if( empty( $key ) ) return;
	    $r = $wpdb->get_col( $wpdb->prepare( "
	        SELECT DISTINCT pm.meta_value
	        FROM {$wpdb->postmeta} as pm, {$wpdb->posts} as p
	        WHERE p.ID = pm.post_id AND pm.meta_key = '%s' AND p.post_status = 'publish'
	    ", $key ) );
	    return $r;
	}
}

