<?php
class Master_Email_API_Controller
{
	
	public function __construct()
	{
		add_action('admin_menu', array($this,'add_email_api_menu'));
		add_action( "admin_init", array($this,"reg_mc_email_api_settings"));

		add_action( 'wp_ajax_mc_mailchimp_get_list_id', array($this,'mc_mailchimp_get_list_id_callback' ));
		add_action( 'wp_ajax_mc_icontact_get_list_id', array($this,'mc_icontact_get_list_id_callback'));

	}
	public static function add_email_api_menu(){
		add_submenu_page('edit.php?post_type=mc-class', __('Email Campaign API', 'mc-lan'), __('Email Campaign API', 'mc-lan'), 'manage_options', 'master-class-email-api', array('Master_Email_API_Controller', 'email_settings_html'));
	}

	public static function reg_mc_email_api_settings(){
		add_settings_section("mc-class-email-api-section", "Class Makr Email API Settings", null, "mc-class-email-api-options");

		register_setting("mc-class-email-api-section", "mc-mailchimp-status");
		register_setting("mc-class-email-api-section", "mc-mailchimp-api-key");
		register_setting("mc-class-email-api-section", "mc-mailchimp-list-id");

		register_setting("mc-class-email-api-section", "mc-cc-status");
		register_setting("mc-class-email-api-section", "mc-cc-token-key");
		register_setting("mc-class-email-api-section", "mc-cc-api-key");

		register_setting("mc-class-email-api-section", "mc-ic-status");
		register_setting("mc-class-email-api-section", "mc-ic-api-key");
		register_setting("mc-class-email-api-section", "mc-ic-user-name");
		register_setting("mc-class-email-api-section", "mc-ic-app-pass");
		register_setting("mc-class-email-api-section", "mc-ic-list-id");

		register_setting("mc-class-email-api-section", "mc-sg-status");
		register_setting("mc-class-email-api-section", "mc-sg-api-key");
	}

	public static function mc_mailchimp_get_list_id_callback(){
		require MC_DIR.'requires/support/api/MCAPI.class.php';
		$result = array();
		$api_key = trim($_POST['api_key']);
		$selected_list_id = get_option("mc-mailchimp-list-id");
	 
		// Query String Perameters are here
		// for more reference please vizit http://developer.mailchimp.com/documentation/mailchimp/reference/lists/
		$data = array(
			'fields' => 'lists', // total_items, _links
			'count' => 'all', // the number of lists to return, default - all
			'before_date_created' => '3020-01-01 10:30:50', // only lists created before this date
			'after_date_created' => '1000-02-05' // only lists created after this date
		);
		 
		$url = 'https://' . substr($api_key,strpos($api_key,'-')+1) . '.api.mailchimp.com/3.0/lists/';


		$result = json_decode( matrix_mailchimp_curl_connect( $url, 'GET', $api_key, $data) );

		$lists = $result->lists;
		foreach($lists as $value){
			$id = $value->id;
			$name = $value->name;
			if( $selected_list_id == $id ){
				echo "<option selected=selected value='".$id."'>".$name."</option>";
			}else{
				echo "<option value='".$id."'>".$name."</option>";
			}
			
		}
		exit;
	}
	public function mc_icontact_get_list_id_callback(){
		require MC_DIR.'requires/support/api/icontact.php';
		$result = array();
		$appid = trim($_POST['api_key']);
		$apiusername = trim($_POST['user_name']);
		$apipassword = trim($_POST['app_pass']);
		$result = icontact_getlists($appid, $apiusername, $apipassword);
		$selected_list_id = get_option('mc-ic-list-id');
		foreach($result as $key=>$value){
			if( $selected_list_id == $key ){
				echo "<option value='".$key."' selected>".$value."</option>";
			}else{
				echo "<option value='".$key."'>".$value."</option>";
			}
			
		}
		exit;
	}

	public static function email_settings_html(){
		?>
		<form method="post" action="options.php">
			<?php
				settings_fields("mc-class-email-api-section");
	            do_settings_sections("mc-class-email-api-options");
	            settings_errors();
	        ?>
	        <input type="hidden" name="_mc_class_payment" id="_mc_class_payment" value="<?php echo $_mc_class_payment; ?>" />
	       
	  		<div class="tabordion">
				<section id="section1">
					<input type="radio" name="sections" id="option1" checked>
					<label for="option1">Mailchimp</label>
					<article>
					  	<h2>Mailchimp</h2>
					  	<p>
					    	<h4>Status</h4>
					    	<select name="mc-mailchimp-status">
					    		<option value="enable" <?php if( get_option('mc-mailchimp-status') == 'enable'){ echo "selected=selected";} ?>>Enable</option>
					    		<option value="disable" <?php if( get_option('mc-mailchimp-status') == 'disable'){ echo "selected=selected";} ?>>Disable</option>
					    	</select>
					    	<h4>API Key, <span>Create API keys from <a target="_blank" href="https://us4.admin.mailchimp.com/account/api/">https://us4.admin.mailchimp.com/account/api/</a> and put in below.</span></h4>
					    	

					    	<input type="text" name="mc-mailchimp-api-key" id="mc-mailchimp-api-key" value="<?php echo get_option('mc-mailchimp-api-key'); ?>"/>
					    	<h4>List ID, <span>Please fill the above details to get the Lists of your MailChimp account. Its an auto-generated list.</span></h4>
					    	<select name="mc-mailchimp-list-id" id="mc-mailchimp-list-id" disabled="disabled">
					    		<option>Select List Name</option>
					    	</select>
				    	</p>
					  	<?php 
							submit_button();
						?>
					</article>
					<script type="text/javascript">
						mc_mailchimpgetlist();
						jQuery( "#mc-mailchimp-api-key" ).keyup(function(){
							mc_mailchimpgetlist();
						});
						function mc_mailchimpgetlist(){
							if(!jQuery( "#mc-mailchimp-api-key" ).val())
								return;

							var data = {
							  'action': 'mc_mailchimp_get_list_id',
							  'dataType': "html",
							  'api_key': jQuery( "#mc-mailchimp-api-key" ).val(),
							};
							jQuery('.loader-div').show();
							jQuery.post(ajaxurl, data, function(response) {
							    jQuery('#mc-mailchimp-list-id').empty();
							    jQuery("#mc-mailchimp-list-id").append(response);
							    jQuery("#mc-mailchimp-list-id").removeAttr("disabled");
							});
						}
					</script>
				</section>
				<section id="section2">
					<input type="radio" name="sections" id="option2">
					<label for="option2">Constant Contact</label>
					<article>
					  	<h2>Constant Contact</h2>
					  	<p>
					  		<h4>Status</h4>
					    	<select name="mc-cc-status">
					    		<option value="enable" <?php if( get_option('mc-cc-status') == 'enable'){ echo "selected=selected";} ?>>Enable</option>
					    		<option value="disable" <?php if( get_option('mc-cc-status') == 'disable'){ echo "selected=selected";} ?>>Disable</option>
					    	</select>
					  		<h4>
					  			<span>Register a normal users account from <a target="_blank" href="https://ui.constantcontact.com/">https://ui.constantcontact.com/</a></span>
			    				<br />
			    				<span>Create a developers account to create App, from <a target="_blank" href="https://constantcontact.mashery.com">https://constantcontact.mashery.com</a></span>
			    			</h4>
			    			<h4>
			    				API Key, <span>Register Apps and get the API key from <a target="_blank" href="https://constantcontact.mashery.com/apps/">https://constantcontact.mashery.com/apps/</a> and put in below.</span>
			    			</h4>
			    			<input type="text" name="mc-cc-api-key" id="mc-cc-api-key" value="<?php echo get_option('mc-cc-api-key'); ?>"/>
					    	<h4>Access Token Key, <span>Get the Access Token from <a target="_blank" href="https://constantcontact.mashery.com/io-docs">https://constantcontact.mashery.com/io-docs</a> and put in below.</span>
					    	</h4>
					    	<input type="text" name="mc-cc-token-key" id="mc-cc-token-key" value="<?php echo get_option('mc-cc-token-key'); ?>"/>

					  	</p>
					  	<?php 
							submit_button();
						?>
					</article>
				</section>
				
				<section id="section4">
					<input type="radio" name="sections" id="option4">
					<label for="option4">iContact</label>
					<article>
					  	<h2>iContact</h2>
					  	<p>
					  		<h4>Status</h4>
					    	<select name="mc-ic-status">
					    		<option value="enable" <?php if( get_option('mc-ic-status') == 'enable'){ echo "selected=selected";} ?>>Enable</option>
					    		<option value="disable" <?php if( get_option('mc-ic-status') == 'disable'){ echo "selected=selected";} ?>>Disable</option>
					    	</select>
						  	<h4>
				    		<span>Create a normal users account and register your App from <a target="_blank" href="https://app.icontact.com/icp/core/">https://app.icontact.com/icp/core/</a>(Free trial only for 30 days.)</span>
					    	</h4>
					    	<h4>API Key, <span>Goto Settings and Billing(Right top corner), Click on iContact API. Also you can click <a href="https://app.icontact.com/icp/core/registerapp" target="_blank">https://app.icontact.com/icp/core/registerapp</a> to get API key</span>
					    	</h4>
					    	<input type="text" name="mc-ic-api-key" id="mc-ic-api-key" value="<?php echo get_option('mc-ic-api-key'); ?>"/>
					    	<h4>Username, <span>Your accounts username.</span>
					    	</h4>
					    	<input type="text" name="mc-ic-user-name" id="mc-ic-user-name" value="<?php echo get_option('mc-ic-user-name'); ?>"/>
					    	<h4>Password<span>Your API password. Goto Settings and Billing(Right top corner), Click on iContact API. Click on "Change your API password for this AppId." and set password.</span>
					    	</h4>
					    	<input type="password" name="mc-ic-app-pass" id="mc-ic-app-pass" value="<?php echo get_option('mc-ic-app-pass'); ?>"/>

					    	<h4>List, <span>Please fill the above details to get the Lists of your iContant account. Its an auto-generated list.</h4>
					    	</h4>
					    	<select name="mc-ic-list-id" id="mc-ic-list-id" disabled="disabled">
					    		<option>Select List ID | Name</option>
					    	</select>

					    	<h4><span>You can see the subscribed email list from, <b>Contacts</b>(Left Panel)--><b>Browse</b>(Top Panel).</span></h4>
					  	</p>
					  <?php 
							submit_button();
						?>
					</article>
					<script type="text/javascript">
						icontactgetlist();
						jQuery( "#mc-ic-api-key" ).keyup(function() {
						    icontactgetlist();
						});
						jQuery( "#mc-ic-user-name" ).keyup(function() {
						    icontactgetlist();
						});
						jQuery( "#mc-ic-app-pass" ).keyup(function() {
						    icontactgetlist();
						});
						function icontactgetlist(){
						  if(!jQuery( "#mc-ic-api-key" ).val())
						    return;
						  if(!jQuery( "#mc-ic-user-name" ).val())
						    return;
						  if(!jQuery( "#mc-ic-app-pass" ).val())
						    return;
						  var data = {
						      'action': 'mc_icontact_get_list_id',
						      'dataType': "html",
						      'api_key': jQuery( "#mc-ic-api-key" ).val(),
						      'user_name': jQuery( "#mc-ic-user-name" ).val(),
						      'app_pass': jQuery( "#mc-ic-app-pass" ).val(),
						    };
						    jQuery.post(ajaxurl, data, function(response) {
						        jQuery('#mc-ic-list-id').empty();
						        jQuery("#mc-ic-list-id").append(response);
						        jQuery("#mc-ic-list-id").removeAttr("disabled");
						    });
						}
					</script>
				</section>

				<section id="section12">
					<input type="radio" name="sections" id="option12">
					<label for="option12">SendGrid</label>
					<article>
					  	<h2>SendGrid</h2>
					  	<p>
					  		<h4>Status</h4>
					    	<select name="mc-sg-status" style="width: 172%;">
					    		<option value="enable" <?php if( get_option('mc-sg-status') == 'enable'){ echo "selected=selected";} ?>>Enable</option>
					    		<option value="disable" <?php if( get_option('mc-sg-status') == 'disable'){ echo "selected=selected";} ?>>Disable</option>
					    	</select>
					  		<h4><span>In your account from Settings tab, goto API Keys, you can get <b>API Key</b>.</span></h4>
					    	<h4>API Key, <span>Copy 'Key' and paste below.</span></h4>
					    	
					  	</p>
					  	<p><input type="text" name="mc-sg-api-key" id="mc-sg-api-key" value="<?php echo get_option('mc-sg-api-key'); ?>"  style="width: 172%;"/></p>
					  	<?php 
							submit_button();
						?>
					</article>
				</section>
				
			</div>
	    	
	    	
	    </form>
	    <style type="text/css">
	    	p.submit{
	    		text-align: center;
	    	}
	    </style>
	    <?php
	}

	public function save_to_campaign($email,$first_name){
		$mailchimp_status = get_option('mc-mailchimp-status') ? get_option('mc-mailchimp-status') : 'disable';
		$cc_status = get_option('mc-cc-status') ? get_option('mc-cc-status') : 'disable';
		$ic_status = get_option('mc-ic-status') ? get_option('mc-ic-status') : 'disable';
		$sg_status = get_option('mc-sg-status') ? get_option('mc-sg-status') : 'disable';

		if( $mailchimp_status == 'enable' ){
			require MC_DIR.'requires/support/api/MCAPI.class.php';
			$api_key = get_option('mc-mailchimp-api-key');
			$selected_list_id = get_option("mc-mailchimp-list-id");
		 
			$postData = array(
			    "email_address" => $email, 
			    "status" => "subscribed", 
			    "merge_fields" => array("NAME"=> $first_name)
			);

			// Setup cURL
			$ch = curl_init('https://us4.api.mailchimp.com/3.0/lists/'.$selected_list_id.'/members/');
			curl_setopt_array($ch, array(
	            CURLOPT_POST => TRUE,
	            CURLOPT_RETURNTRANSFER => TRUE,
	            CURLOPT_HTTPHEADER => array(
	                'Authorization: apikey '.$api_key,
	                'Content-Type: application/json'
	            ),
	            CURLOPT_POSTFIELDS => json_encode($postData)
        	));
        	// Send the request
	        $response = curl_exec($ch);
	        curl_close($ch);
			//return;
			// $response_arr = json_decode($response);
			// print_r($response_arr);
		}

		if( $cc_status == 'enable' ){
			require_once MC_DIR.'requires/support/api/constantcontact.php';
			$api_key   = get_option('mc-cc-api-key');
			$token_key = get_option('mc-cc-token-key');
          	$result = subscribe($api_key,$token_key,$email,$first_name);
          	//return;
		}

		if( $sg_status == 'enable' ){
			$apikey = get_option('mc-sg-api-key');
	        $parts = explode("@", $email);
			$fname = $parts[0];	
			$name   = ($first_name !='') ? $first_name : $fname;

    		$params = array ('contacts' => array ( array (
              'email' => $email,
              'first_name' => $name,
              'last_name' => '',
            )));

	        $json_post_fields = json_encode($params);
	        $curl = curl_init();
	        curl_setopt_array($curl, array(
	          CURLOPT_URL => "https://api.sendgrid.com/v3/marketing/contacts",
	          CURLOPT_RETURNTRANSFER => true,
	          CURLOPT_ENCODING => "",
	          CURLOPT_MAXREDIRS => 10,
	          CURLOPT_TIMEOUT => 30,
	          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	          CURLOPT_CUSTOMREQUEST => "PUT",
	          CURLOPT_POSTFIELDS => $json_post_fields,
	          CURLOPT_HTTPHEADER => array(
	            "authorization: Bearer $apikey",
	            "content-type: application/json"
	          ),
	        ));
	        $response = curl_exec($curl);
	        $err = curl_error($curl);

	        curl_close($curl);
	        $res  = json_decode($response);
	        //return;
		}

		if( $ic_status == 'enable' ){
			require_once MC_DIR.'requires/support/api/icontact.php';
			$ic_user_name = get_option('mc-ic-user-name');
			$ic_app_pass  = get_option('mc-ic-app-pass');
			$ic_app_key   = get_option('mc-ic-api-key');
			$ic_list_id   = get_option('mc-ic-list-id');
			$result = ic_subscribe($email,$first_name,$ic_user_name,$ic_app_pass,$ic_app_key,$ic_list_id);
	        //print_r($result); die;
	        // return;
		}

		return;
	}

}