<?php
class Master_General_Settings_Controller
{
	
	public function __construct()
	{
		add_action('admin_menu', array($this,'add_reg_mc_settings_page'));
		add_action( "admin_init", array($this,"reg_mc_settings"));
		add_action( 'admin_footer', array($this,'add_css_js'), 11 );
	}
	public static function add_reg_mc_settings_page(){
		add_submenu_page('edit.php?post_type=mc-class', __('General Settings', 'mc-lan'), __('General Settings', 'mc-lan'), 'manage_options', 'master-class-settings', array('Master_General_Settings_Controller', 'settings_html'));

	}
	public static function add_css_js(){
		wp_enqueue_style( 'wp-color-picker' );
		wp_register_script( 'mc-color-picker', MC_JS.'/jquery.color.js', array( 'jquery', 'wp-color-picker' ), '', true  );
		wp_enqueue_script('mc-color-picker');
	}

	public static function reg_mc_settings(){
		add_settings_section("mc-class-option-section", "Class Makr General Settings", null, "mc-class-options");

		register_setting("mc-class-option-section", "mc_cls_pagination_class");
		register_setting("mc-class-option-section", "mc_cls_pagination_lesson");
		register_setting("mc-class-option-section", "mc_cls_user_comments_lesson");
		register_setting("mc-class-option-section", "mc_image_on_checkout");
		register_setting("mc-class-option-section", "mc_nav_on_pages");

		register_setting("mc-class-option-section", "mc_cls_currency");

		register_setting("mc-class-option-section", "mc_cls_paypal_standard_status");
		register_setting("mc-class-option-section", "mc_cls_paypal_standard_mode");
		register_setting("mc-class-option-section", "mc_cls_paypal_standard_email");

		register_setting("mc-class-option-section", "mc_cls_square_status");
		register_setting("mc-class-option-section", "mc_cls_square_mode");
		register_setting("mc-class-option-section", "mc_cls_square_app_id");
		register_setting("mc-class-option-section", "mc_cls_square_loc_id");
		register_setting("mc-class-option-section", "mc_cls_square_access_token");

		register_setting("mc-class-option-section", "mc_cls_stripe_status");
		register_setting("mc-class-option-section", "mc_cls_stripe_publish_key");
		register_setting("mc-class-option-section", "mc_cls_stripe_private_key");

		register_setting("mc-class-option-section", "mc_cls_auth_status");
		register_setting("mc-class-option-section", "mc_cls_auth_api_login_id");
		register_setting("mc-class-option-section", "mc_cls_auth_tran_key");
		register_setting("mc-class-option-section", "mc_cls_auth_mode");

		register_setting("mc-class-option-section", "mc_cls_bundle_on_class_listing");
		register_setting("mc-class-option-section", "mc_cls_bundle_on_class_details");
		register_setting("mc-class-option-section", "mc_cls_bundle_package_product");
		//register_setting("mc-class-option-section", "mc_cls_bundle_price");
		register_setting("mc-class-option-section", "mc_cls_bundle_price_txt");
		register_setting("mc-class-option-section", "mc_cls_bundle_title");
		register_setting("mc-class-option-section", "mc_cls_bundle_desc");
		register_setting("mc-class-option-section", "mc_cls_bundle_desc_checkout");
		register_setting("mc-class-option-section", "mc_cls_bundle_image");

		register_setting("mc-class-option-section", "mc_gen_button_bck");
		register_setting("mc-class-option-section", "mc_gen_button_hover_bck");
		register_setting("mc-class-option-section" , "mc_gen_button_text");
		register_setting("mc-class-option-section", "mc_price_button_bck");
		register_setting("mc-class-option-section", "mc_price_button_hover_bck");
		register_setting("mc-class-option-section", "mc_price_button_txt");
		register_setting("mc-class-option-section", "mc_eml_temp_bck_clr");

		register_setting("mc-class-option-section", "mc_tag_bck_clr");
		register_setting("mc-class-option-section", "mc_acc_nav_clr");
		register_setting("mc-class-option-section", "mc_acc_text_clr");
		register_setting("mc-class-option-section", "mc_acc_text_h3_clr");
		register_setting("mc-class-option-section", "mc_acc_text_h2_clr");
		register_setting("mc-class-option-section", "mc_acc_text_h1_clr");


		register_setting("mc-class-option-section", "mc_player_theme");
		register_setting("mc-class-option-section", "mc_player_autoplay");
		register_setting("mc-class-option-section", "mc_player_color_acent");
		register_setting("mc-class-option-section", "mc_player_color_acent_back");
		register_setting("mc-class-option-section", "mc_player_shadow_effect");
		register_setting("mc-class-option-section", "mc_player_text_orientation");
		register_setting("mc-class-option-section", "mc_player_rewind");

		register_setting("mc-class-option-section", "mc_cls_pp_url");
		register_setting("mc-class-option-section", "mc_cls_pp_desc");

	}

	public static function settings_html(){

		$mc_cls_pagination_lesson = (get_option('mc_cls_pagination_lesson')) ? get_option('mc_cls_pagination_lesson') : 'enable';
		$mc_cls_pagination_class = (get_option('mc_cls_pagination_class')) ? get_option('mc_cls_pagination_class') : 'enable';
		$mc_cls_user_comments_lesson = (get_option('mc_cls_user_comments_lesson')) ? get_option('mc_cls_user_comments_lesson') : 'enable';
		$mc_nav_on_pages = (get_option('mc_nav_on_pages')) ? get_option('mc_nav_on_pages') : 'disable';

		$mc_cls_currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
		?>
		<form method="post" action="options.php" id="submit-class-makr-general-payment">
			<?php
				settings_fields("mc-class-option-section");
	            do_settings_sections("mc-class-options");
	            settings_errors();
	        ?>
	        <input type="hidden" name="_mc_class_payment" id="_mc_class_payment" value="<?php echo $_mc_class_payment; ?>" />
	       
	  		<main class="mc-gen-set-tab">
	  
			  	<input id="tab1" class="tab-radio" type="radio" name="tabs" checked>
			  	<label for="tab1" class="tab-radio-label" >Payment</label>
			    
			  	<input id="tab2" class="tab-radio" type="radio" name="tabs">
			  	<label for="tab2" class="tab-radio-label" >Global</label>

			  	<input id="tab3" class="tab-radio" type="radio" name="tabs">
			  	<label for="tab3" class="tab-radio-label" >Bundle Packaging</label>

			  	<input id="tab4" class="tab-radio" type="radio" name="tabs">
			  	<label for="tab4" class="tab-radio-label" >Comments</label>

			  	<input id="tab5" class="tab-radio" type="radio" name="tabs">
			  	<label for="tab5" class="tab-radio-label" >Color Options</label>

			  	<input id="tab6" class="tab-radio" type="radio" name="tabs">
			  	<label for="tab6" class="tab-radio-label" >Video Player</label>

			  	<input id="tab7" class="tab-radio" type="radio" name="tabs">
			  	<label for="tab7" class="tab-radio-label" >Privacy Policy</label>

			  	<section id="content1">
			  		<div class="master-class-payment-box">
						  <!-- <div class="master-class-payment-pop">
						    <p>Charge your users for your classes by getting the <a href="https://classmakr.com/" target="_blank">Pro version</a></p>
				          </div> -->
				        <div class="payment_block">
							<div class="error" style="margin: 0;">
								<div style="padding: 5px;">
									<img src="<?php echo MC_IMG.'/icon_lock.png;'?>" style="float:left;padding: 2px;width:30px;" alt="master-class"><p style="line-height: 34px;margin: 0 0 2px 0;padding: 0 0 0 0;text-transform: uppercase;font-weight: 600;border:0;"> &nbsp; Want to charge your users? Unlock this feature by getting the <a href="https://classmakr.com/" target="_blank">Pro version</a></p>
								</div>
							</div>
				        </div>
			  		<?php // echo Master_General_Settings_Controller::blockArea();?>
			  		<p style="margin-bottom: 20px;padding-bottom: 10px;border-bottom: 1px solid #cccccc26;background-color: white;">
			  			<label>Currency</label>
			  			<select name="mc_cls_currency">
			  				<option value="0">Select Currency</option>
			  				<option value="USD-$" <?php if($mc_cls_currency=='USD-$'){ echo "selected=selected";} ?>>United States (US) dollar ($)</option>
			  				<option value="EUR-€" <?php if($mc_cls_currency=='EUR-€'){ echo "selected=selected";} ?>>Euro (€)</option>
			  				<option value="AUD-$" <?php if($mc_cls_currency=='AUD-$'){ echo "selected=selected";} ?>>Australian dollar ($)</option>
			  				<option value="INR-₹" <?php if($mc_cls_currency=='INR-₹'){ echo "selected=selected";} ?>>Indian rupee (₹)</option>
			  			</select>
			  		</p>
			   			<h2 id="class-makr-square">Square <span style="font-size: 12px; font-weight: 100; margin-left: 4px;">Don't have a Square account? <a href="https://prf.hn/click/camref:1101l48kX/creativeref:1100l22433" target="_blank;">Get a Square Account Here</a></span></h2>
				      	<p>
				      		<label>Status</label>
				      		<select name="mc_cls_square_status">
				      		    <option value="disable" <?php if( get_option('mc_cls_square_status') == 'disable'){ echo 'selected=selected';} ?>>Disable</option>
				      			<option value="enable" <?php if( get_option('mc_cls_square_status') == 'enable'){ echo 'selected=selected';} ?>>Enable</option>
				      		</select>
				      	</p>
				      	<p>
				      		<label>Mode</label>
				      		<select name="mc_cls_square_mode">
				      			<option value="sandbox" <?php if( get_option('mc_cls_square_mode') == 'sandbox'){ echo 'selected=selected';} ?>>SandBox</option>
				      			<option value="live" <?php if( get_option('mc_cls_square_mode') == 'live'){ echo 'selected=selected';} ?>>Live</option>
				      		</select>
				      	</p>
				      	<p>
				      		<label>Access Token</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_square_access_token'); ?>" name="mc_cls_square_access_token" />
				      	</p>
				      	<p>
				      		<label>Application ID</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_square_app_id'); ?>" name="mc_cls_square_app_id" />
				      	</p>
				      	<p>
				      		<label>Location ID</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_square_loc_id'); ?>" name="mc_cls_square_loc_id" />
				      	</p>

				      	<h2 id="class-makr-paypal">PayPal Standard</h2>
				      	<p>
				      		<label>Status</label>
				      		<select name="mc_cls_paypal_standard_status">
				      			<option value="disable" <?php if( get_option('mc_cls_paypal_standard_status') == 'disable'){ echo 'selected=selected';} ?>>Disable</option>
				      			<option value="enable" <?php if( get_option('mc_cls_paypal_standard_status') == 'enable'){ echo 'selected=selected';} ?>>Enable</option>
				      		</select>
				      	</p>
				      	<p>
				      		<label>Mode</label>
				      		<select name="mc_cls_paypal_standard_mode">
				      			<option value="sandbox" <?php if( get_option('mc_cls_paypal_standard_mode') == 'sandbox'){ echo 'selected=selected';} ?>>Sandbox</option>
				      			<option value="live" <?php if( get_option('mc_cls_paypal_standard_mode') == 'live'){ echo 'selected=selected';} ?>>Live</option>
				      		</select>
				      	</p>
				      	<p>
				      		<label>PayPal Account's Email</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_paypal_standard_email'); ?>" name="mc_cls_paypal_standard_email" />
				      	</p>
				      	
				      	<h2 id="class-makr-stripe">Stripe</h2>
				      	<p>
				      		<label>Status</label>
				      		<select name="mc_cls_stripe_status">
				      		    <option value="disable" <?php if( get_option('mc_cls_stripe_status') == 'disable'){ echo 'selected=selected';} ?>>Disable</option>
				      			<option value="enable" <?php if( get_option('mc_cls_stripe_status') == 'enable'){ echo 'selected=selected';} ?>>Enable</option>
				      		</select>
				      	</p>
				      	<p>
				      		<label>Publishable Key</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_stripe_publish_key'); ?>" name="mc_cls_stripe_publish_key" />
				      	</p>
				      	<p>
				      		<label>Secret Key</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_stripe_private_key'); ?>" name="mc_cls_stripe_private_key" />
				      	</p>
				      	<h2 id="class-makr-authorize">Authorize.NET</h2>
				      	<p>
				      		<label>Status</label>
				      		<select name="mc_cls_auth_status">
				      		    <option value="disable" <?php if( get_option('mc_cls_auth_status') == 'disable'){ echo 'selected=selected';} ?>>Disable</option>
				      			<option value="enable" <?php if( get_option('mc_cls_auth_status') == 'enable'){ echo 'selected=selected';} ?>>Enable</option>
				      		</select>
				      	</p>
				      	<p>
				      		<label>API Login ID</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_auth_api_login_id'); ?>" name="mc_cls_auth_api_login_id" />
				      	</p>
				      	<p>
				      		<label>Transaction Key</label>
				      		<input type="text" value="<?php echo get_option('mc_cls_auth_tran_key'); ?>" name="mc_cls_auth_tran_key" />
				      	</p>
				      	<p>
				      		<label>Mode</label>
				      		<select name="mc_cls_auth_mode">
				      			<option value="sandbox" <?php if( get_option('mc_cls_auth_mode') == 'sandbox'){ echo 'selected=selected';} ?>>Sandbox</option>
				      			<option value="live" <?php if( get_option('mc_cls_auth_mode') == 'live'){ echo 'selected=selected';} ?>>Live</option>
				      		</select>
				      	</p>
				      	</div>
			  		</section>
			  	<script type="text/template" id="block-overlay">
			  		
			  	</script>
			  	<script>
			  	// 	jQuery(function($){
			  	// 		$('.box').fadeTo('slow',.6);
						// $('.box').append($("#block-overlay").html());
			  	// 	});
			  	</script>

			  	<section id="content2">
			  		<!-- <p>
			  			<label>Previous / Next Button on Class pages</label>
			  			<select name="mc_cls_pagination_class">
				      		<option value="enable" <?php //if( $mc_cls_pagination_class == 'enable' ){ echo 'selected=selected';} ?>>Enable</option>
				      		<option value="disable" <?php //if( $mc_cls_pagination_class == 'disable' ){ echo 'selected=selected';} ?>>Disable</option>
				      	</select>
				    </p> -->

				    <p>
			  			<label>Previous / Next Button on Lesson pages</label>
			  			<select name="mc_cls_pagination_lesson">
				      		<option value="enable"  <?php if( $mc_cls_pagination_lesson == 'enable' ){ echo 'selected=selected';} ?>>Enable</option>
				      		<option value="disable"  <?php if( $mc_cls_pagination_lesson == 'disable' ){ echo 'selected=selected';} ?>>Disable</option>
				      	</select>
				    </p>

				    <p>
			  			<label>User Comments on Lessons</label>
			  			<select name="mc_cls_user_comments_lesson">
				      		<option value="enable"  <?php if( $mc_cls_user_comments_lesson == 'enable' ){ echo 'selected=selected';} ?>>Enable</option>
				      		<option value="disable"  <?php if( $mc_cls_user_comments_lesson == 'disable' ){ echo 'selected=selected';} ?>>Disable</option>
				      	</select>
				    </p>
				    <p>
			      		<label>Show class image within the checkout page</label>
			      		<select name="mc_image_on_checkout">
			      			<option value="enable" <?php if( get_option('mc_image_on_checkout') == 'enable'){ echo 'selected=selected';} ?>>Enable</option>
			      			<option value="disable" <?php if( get_option('mc_image_on_checkout') == 'disable'){ echo 'selected=selected';} ?>>Disable</option>
			      		</select>
			      	</p>
			      	<p>
			      		<label>Show account navigation on pages</label>
			      		<select name="mc_nav_on_pages">
			      			<option value="enable" <?php if( $mc_nav_on_pages == 'enable'){ echo 'selected=selected';} ?>>Enable</option>
			      			<option value="disable" <?php if( $mc_nav_on_pages == 'disable'){ echo 'selected=selected';} ?>>Disable</option>
			      		</select>
			      	</p>
			  	</section>
			    
			 	<section id="content3">
				    <p><label style="width:100%; float: right;">When you enable bundle packaging users will have the ability to access all of your courses at one price point.</label></p>
				    <p>
			  			<label>Bundle package on class listing page</label>
			  			<?php 
			  				$mc_cls_bundle_on_class_listing = get_option('mc_cls_bundle_on_class_listing') ? get_option('mc_cls_bundle_on_class_listing') : 'disable';
			  			?>
			  			<select name="mc_cls_bundle_on_class_listing">
				      		<option value="enable" <?php if( $mc_cls_bundle_on_class_listing == 'enable' ){ echo 'selected=selected';} ?>>Enable</option>
				      		<option value="disable" <?php if( $mc_cls_bundle_on_class_listing == 'disable' ){ echo 'selected=selected';} ?>>Disable</option>
				      	</select>
				    </p>
				    <p>
			  			<label>Bundle package on class details page</label>
			  			<?php
			  				$mc_cls_bundle_on_class_details = get_option('mc_cls_bundle_on_class_details') ? get_option('mc_cls_bundle_on_class_details') : 'disable';
			  			?>
			  			<select name="mc_cls_bundle_on_class_details">
				      		<option value="enable" <?php if( $mc_cls_bundle_on_class_details == 'enable' ){ echo 'selected=selected';} ?>>Enable</option>
				      		<option value="disable" <?php if( $mc_cls_bundle_on_class_details == 'disable' ){ echo 'selected=selected';} ?>>Disable</option>
				      	</select>
				    </p>
				    <p>
			  			<label>Bundle package included class(es)</label>
			  			<?php
			  			    $mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
				      		$wcatTerms = get_terms('mc-class-category', array('hide_empty' => 0));
			  			?>
			  			<select name="mc_cls_bundle_package_product[]" multiple <?php echo (count($wcatTerms)<2?'disabled':'');?>>
				      		<?php
				      			
				      			foreach($wcatTerms as $wcatTerm){
				      				$t_id = $wcatTerm->term_id;
				      				?>
				      				<option value="<?php echo $t_id; ?>" <?php if(in_array($t_id,$mc_cls_bundle_package_product)){ echo 'selected=selected'; } ?>>
				      					<?php echo $wcatTerm->name; ?>
				      				</option>
				      				<?php
				      			}
				      		?>

				      	</select>
				    </p>
				    <p>
			  			<label>Bundle package price</label>
			  			<input type="number" readonly min="0" step="any" name="mc_cls_bundle_price" id="mc_cls_bundle_price" value="<?php echo get_option('mc_cls_bundle_price'); ?>" />
			  		</p>
			  		<p>
			  			<label>Bundle purchase button text</label>
			  			<input type="text" name="mc_cls_bundle_price_txt" id="mc_cls_bundle_price_txt" value="<?php echo get_option('mc_cls_bundle_price_txt') ? get_option('mc_cls_bundle_price_txt') : 'Get access to all classes'; ?>" />
			  		</p>
			  		<p>
			  			<label>Bundle package title</label>
			  			<input type="text" name="mc_cls_bundle_title" id="mc_cls_bundle_title" value="<?php echo get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ; ?>" />
			  		</p>

			  		<p>
			  			<label>Bundle package general description</label>
			  			<?php wp_editor( get_option('mc_cls_bundle_desc'), 'mc_cls_bundle_desc', $settings = array('textarea_rows'=> '10') ); ?>
			  		</p>

			  		<p>
			  			<label>Bundle package checkout description</label>
			  			<?php wp_editor( get_option('mc_cls_bundle_desc_checkout'), 'mc_cls_bundle_desc_checkout', $settings = array('textarea_rows'=> '10') ); ?>
			  		</p>
			  		<p>
			  			<label>Bundle package checkout image</label>
			  			<a href="javascript:void(0);" id="mc-bundle-package-upload-button" class="button button-secondary">Upload</a>
			  			<div id="mc_cls_bundle_image_prev" style="text-align: center;">
				  			<?php if( get_option('mc_cls_bundle_image') ){ ?>
						  			<a href=<?php echo wp_get_attachment_url(get_option('mc_cls_bundle_image')); ?> download><?php echo get_the_title(get_option('mc_cls_bundle_image')); ?> </a>
			                    	<span onclick="deleteFeaturedImage()" class="dashicons dashicons-no-alt" style="color: red;cursor: pointer;display: inline-block;text-decoration: none;"></span>
		                    <?php } ?>
		                 </div>

	                    <input type="hidden" name="mc_cls_bundle_image" id="mc_cls_bundle_image" value="<?php echo get_option('mc_cls_bundle_image'); ?>"/>
			  		</p>
			  		<script type="text/javascript">
			            function deleteFeaturedImage(){
			                if (confirm('Do you want to remove the image?')) {
			                    jQuery("#mc_cls_bundle_image_prev").html('');
			                    jQuery("#mc_cls_bundle_image").val('');
			                }
			            }
			        </script>
			  	</section>
			  	<section id="content4">
			  		<p><label style="width: 100%;">Go to the <a href="<?php echo admin_url( 'edit-comments.php' ); ?>" target="_blank">WordPress Comments</a> section to Edit, Approve, Disapprove, Trash all comments.</label></p>
			  	</section>
			  	<section id="content5">
			  		<p>
			  			<label>General button background color</label>
			  			<input type="text" name="mc_gen_button_bck" value="<?php echo get_option('mc_gen_button_bck') ? get_option('mc_gen_button_bck') : '#dd0808'; ?>" id="mc_gen_button_bck_clr" />
			  		</p>
			  		<p>
			  			<label>General button hover background color</label>
			  			<input type="text" name="mc_gen_button_hover_bck" value="<?php echo get_option('mc_gen_button_hover_bck') ? get_option('mc_gen_button_hover_bck') : '#bc0000'; ?>" id="mc_gen_button_hover_bck_clr" />
			  		</p>
			  		<p>
			  			<label>General button text color</label>
			  			<input type="text" name="mc_gen_button_text" value="<?php echo get_option('mc_gen_button_text') ? get_option('mc_gen_button_text') : '#ffffff'; ?>" id="mc_gen_button_text" />
			  		</p>
			  		<p>
			  			<label>Price button background color</label>
			  			<input type="text" name="mc_price_button_bck" value="<?php echo get_option('mc_price_button_bck') ? get_option('mc_price_button_bck') : '#dd0808'; ?>" id="mc_price_button_bck_clr" />
			  		</p>
			  		<p>
			  			<label>Price button hover background color</label>
			  			<input type="text" name="mc_price_button_hover_bck" value="<?php echo get_option('mc_price_button_hover_bck') ? get_option('mc_price_button_hover_bck') : '#bc0000'; ?>" id="mc_price_button_hover_bck_clr" />
			  		</p>
			  		<p>
			  			<label>Price button text color</label>
			  			<input type="text" name="mc_price_button_txt" value="<?php echo get_option('mc_price_button_txt') ? get_option('mc_price_button_txt') : '#ffffff'; ?>" id="mc_price_button_txt" />
			  		</p>
			  		<p>
			  			<label>Email template background color</label>
			  			<input type="text" name="mc_eml_temp_bck_clr" value="<?php echo get_option('mc_eml_temp_bck_clr') ? get_option('mc_eml_temp_bck_clr') : "#eaf1f9"; ?>" id="mc_eml_temp_bck_clr" />
			  		</p>
			  		<p>
			  			<label>Tag/Flag background color</label>
			  			<input type="text" name="mc_tag_bck_clr" value="<?php echo get_option('mc_tag_bck_clr') ? get_option('mc_tag_bck_clr') : '#dd0808'; ?>" id="mc_tag_bck_clr" />
			  		</p>
			  		<p>
			  			<label>Account Navigation color</label>
			  			<input type="text" name="mc_acc_nav_clr" value="<?php echo get_option('mc_acc_nav_clr') ? get_option('mc_acc_nav_clr') : '#000000'; ?>" id="mc_acc_nav_clr" />
			  		</p>
			  		<p>
			  			<label>Theme H1 color</label>
			  			<input type="text" name="mc_acc_text_h1_clr" value="<?php echo get_option('mc_acc_text_h1_clr') ? get_option('mc_acc_text_h1_clr') : '#000'; ?>" id="mc_acc_text_h1_clr" />
			  		</p>
			  		<style type="text/css">
			  			.wp-picker-container{
			  				width: 50%;
			  				display: inline-block;
			  				margin-left: 50px;
			  			}
			  		</style>
			  		<p>
			  			<label>Theme H2 color</label>
			  			<input type="text" name="mc_acc_text_h2_clr" value="<?php echo get_option('mc_acc_text_h2_clr') ? get_option('mc_acc_text_h2_clr') : '#000'; ?>" id="mc_acc_text_h2_clr" />
			  		</p>
			  		<style type="text/css">
			  			.wp-picker-container{
			  				width: 50%;
			  				display: inline-block;
			  				margin-left: 50px;
			  			}
			  		</style>
			  		<p>
			  			<label>Theme H3 color</label>
			  			<input type="text" name="mc_acc_text_h3_clr" value="<?php echo get_option('mc_acc_text_h3_clr') ? get_option('mc_acc_text_h3_clr') : '#000'; ?>" id="mc_acc_text_h3_clr" />
			  		</p>
			  		<style type="text/css">
			  			.wp-picker-container{
			  				width: 50%;
			  				display: inline-block;
			  				margin-left: 50px;
			  			}
			  		</style>
			  		<p>
			  			<label>Text color</label>
			  			<input type="text" name="mc_acc_text_clr" value="<?php echo get_option('mc_acc_text_clr') ? get_option('mc_acc_text_clr') : '#2b2b2b'; ?>" id="mc_acc_text_clr" />
			  		</p>
			  		<style type="text/css">
			  			.wp-picker-container{
			  				width: 50%;
			  				display: inline-block;
			  				margin-left: 50px;
			  			}
			  		</style>
			  	
			  	</section>

			  	<section id="content6">
			  		<!-- <h2>[MASTER_CLASS]</h2>Produce grid of all class category.
			  		<h2>[MASTERCLASS_LOGIN]</h2>Class Makr Login Page.
			  		<h2>[MASTERCLASS_REGISTRATION]</h2>Class Makr Registration Page.
			  		<h2>[MASTERCLASS_DASHBOARD]</h2>Class Makr My Dashboard Page. -->
			  		<p>
			  			<?php $mc_player_theme = get_option( 'mc_player_theme' ) ? get_option( 'mc_player_theme' ) : 'light'; ?>
			  			<label>Theme</label>
			  			<select name="mc_player_theme">
			  				<option value="dark" <?php if( $mc_player_theme == 'dark' ){ echo 'selected=selected';} ?>>Dark</option>
			  				<option value="light" <?php if( $mc_player_theme == 'light' ){ echo 'selected=selected';} ?>>Light</option>
			  			</select>
			  		</p>
			  		<p>
			  			<?php $mc_player_autoplay = get_option( 'mc_player_autoplay' ) ? get_option( 'mc_player_autoplay' ) : 'false'; ?>
			  			<label>Autoplay</label>
			  			<select name="mc_player_autoplay">
			  				<option value="false" <?php if( $mc_player_autoplay == 'false' ){ echo 'selected=selected';} ?>>Disable</option>
			  				<option value="true" <?php if( $mc_player_autoplay == 'true' ){ echo 'selected=selected';} ?>>Enable</option>
			  			</select>
			  		</p>
			  		<p>
			  			<label>Accent Color</label>
			  			<input type="text" name="mc_player_color_acent" value="<?php echo get_option('mc_player_color_acent') ? get_option('mc_player_color_acent') : '#ff0000'; ?>" id="mc_player_color_acent_clr" />
			  		</p>
			  		<p>
			  			<label>Play Button Background Color</label>
			  			<input type="text" name="mc_player_color_acent_back" value="<?php echo get_option('mc_player_color_acent_back') ? get_option('mc_player_color_acent_back') : '#000'; ?>" id="mc_player_color_acent_back" />
			  		</p>
			  		<p>
			  			<?php $mc_player_shadow_effect = get_option( 'mc_player_shadow_effect' ) ? get_option( 'mc_player_shadow_effect' ) : 'effect1'; ?>
			  			<label>Shadow Effect</label>
			  			<select name="mc_player_shadow_effect">
			  				<option value="effect1" <?php if( $mc_player_shadow_effect == 'effect1' ){ echo 'selected=selected';} ?>>Effect 1</option>
			  				<option value="effect2" <?php if( $mc_player_shadow_effect == 'effect2' ){ echo 'selected=selected';} ?>>Effect 2</option>
			  				<option value="effect3" <?php if( $mc_player_shadow_effect == 'effect3' ){ echo 'selected=selected';} ?>>Effect 3</option>
			  				<option value="effect4" <?php if( $mc_player_shadow_effect == 'effect4' ){ echo 'selected=selected';} ?>>Effect 4</option>
			  				<option value="effect5" <?php if( $mc_player_shadow_effect == 'effect5' ){ echo 'selected=selected';} ?>>Effect 5</option>
			  				<option value="effect6" <?php if( $mc_player_shadow_effect == 'effect6' ){ echo 'selected=selected';} ?>>Effect 6</option>
			  				<option value="off" <?php if( $mc_player_shadow_effect == 'off' ){ echo 'selected=selected';} ?>>Off</option>
			  			</select>
			  		</p>
			  		<p>
			  			<?php $mc_player_rewind = get_option( 'mc_player_rewind' ) ? get_option( 'mc_player_rewind' ) : 'true'; ?>
			  			<label>Rewind</label>
			  			<select name="mc_player_rewind">
			  				<option value="false" <?php if( $mc_player_rewind == 'false' ){ echo 'selected=selected';} ?>>Disable</option>
			  				<option value="true" <?php if( $mc_player_rewind == 'true' ){ echo 'selected=selected';} ?>>Enable</option>
			  			</select>
			  		</p>
			  		<p>
			  			<?php $mc_player_text_orientation = get_option( 'mc_player_text_orientation' ) ? get_option( 'mc_player_text_orientation' ) : 'false'; ?>
			  			<label>Video Title</label>
			  			<select name="mc_player_text_orientation">
			  				<option value="LTR" <?php if( $mc_player_text_orientation == 'LTR' ){ echo 'selected=selected';} ?>>Left to Right</option>
			  				<option value="RTL" <?php if( $mc_player_text_orientation == 'RTL' ){ echo 'selected=selected';} ?>>Right to Left</option>
			  			</select>
			  		</p>
			  	</section>
			  	 <section id="content7">
	    	<h3><label style="width:100%; color: #000; font-weight: 500;">Enter details for the Privacy Policy.</label></h3>
	
	    	<p><label>Privacy Policy Description</label></p>

	    	<?php $mc_iagree = (get_option('mc_cls_pp_desc') != '') ? get_option('mc_cls_pp_desc') : '<p>I have read and agree to the website terms and conditions</p>'; ?>
			<?php //echo stripslashes($mc_iagree); ?>


	    	<?php wp_editor( $mc_iagree, 'mc_cls_pp_desc', $settings = array('textarea_rows'=> '10') ); ?>

	    </section>
			</main>
	    	<p class="submit"><input type="submit" name="submit" id="submit-class-makr-general-payment-action" class="button button-primary" value="Save Changes"></p>
	    	<?php 
				//submit_button();
			?>
	    </form>
	    <script>
	        jQuery(function($){
	            $("#submit-class-makr-general-payment").submit(function(e){
	                var flag=0;
	                $("input").attr("style","");
	                $("h2").removeClass("class-makr-error-found");
	                var squareStat=$("select[name='mc_cls_square_status'] :selected").val();
	                if(squareStat!='disable')
	                {
	                    var accesstoken=$("input[name='mc_cls_square_access_token']").val();
	                    if(accesstoken.length<1)
	                    {
	                        $("input[name='mc_cls_square_access_token']").css("border","2px solid red");
	                        flag++;
	                    }
	                    var appId=$("input[name='mc_cls_square_app_id']").val();
	                    if(appId.length<1)
	                    {
	                        $("input[name='mc_cls_square_app_id']").css("border","2px solid red");
	                        flag++;
	                    }
	                    var locId=$("input[name='mc_cls_square_loc_id']").val();
	                    if(locId.length<1)
	                    {
	                        $("input[name='mc_cls_square_loc_id']").css("border","2px solid red");
	                         flag++;
	                    }
	                    if(accesstoken.length<1 || appId.length<1 || locId.length<1)
	                    {
	                       $("#class-makr-square").addClass("class-makr-error-found");
	                    }
	                    	                        
	                }
	                
	                
	                var paypalStat=$("select[name='mc_cls_paypal_standard_status'] :selected").val();
	                if(paypalStat!='disable')
	                {
	                    var paypalEmail=$("input[name='mc_cls_paypal_standard_email']").val();
	                    if(paypalEmail.length<1)
	                    {
	                        $("input[name='mc_cls_paypal_standard_email']").css("border","2px solid red");
	                         flag++;
	                        $("#class-makr-paypal").addClass("class-makr-error-found");
	                    }
	                }
	                
	                
	                var stripeStat=$("select[name='mc_cls_stripe_status'] :selected").val();
	                if(stripeStat!='disable')
	                {
	                    var publishKey=$("input[name='mc_cls_stripe_publish_key']").val();
	                    if(publishKey.length<1)
	                    {
	                        $("input[name='mc_cls_stripe_publish_key']").css("border","2px solid red");
	                         flag++;
	                    }
	                    var secretKey=$("input[name='mc_cls_stripe_private_key']").val();
	                    if(secretKey.length<1)
	                    {
	                        $("input[name='mc_cls_stripe_private_key']").css("border","2px solid red");
	                        flag++;
	                        
	                    }
	                    if(publishKey.length<1 || secretKey.length<1)
	                    {
	                      $("#class-makr-stripe").addClass("class-makr-error-found");
	                      flag++;
	                    }
	                }
	                
	                
	                var authorizeStat=$("select[name='mc_cls_auth_status'] :selected").val();
	                if(authorizeStat!='disable')
	                {
	                    var loginId=$("input[name='mc_cls_auth_api_login_id']").val();
	                    if(loginId.length<1)
	                    {
	                        $("input[name='mc_cls_auth_api_login_id']").css("border","2px solid red");
	                         flag++;
	                    }
	                    var tranKey=$("input[name='mc_cls_auth_tran_key']").val();
	                    if(tranKey.length<1)
	                    {
	                        $("input[name='mc_cls_auth_tran_key']").css("border","2px solid red");
	                        flag++;
	                        
	                    }
	                    if(loginId.length<1 || tranKey.length<1)
	                    {
	                        $("#class-makr-authorize").addClass("class-makr-error-found");
	                         flag++;
	                       
	                    }
	                }
	                if(flag>0)
	                {
	                    var id=$("body").find(".class-makr-error-found").first().attr("id");
	                    $('html, body').animate({
                                scrollTop: $("#"+id).offset().top
                        }, 2000);
                        return false;
	                }
	               
	                
	            });
	        });
	    </script>
	    <style type="text/css">
	    	p.submit{
	    		text-align: center;
	    	}
	    	.wp-picker-container{
	    		margin-left: 1px;
			}
			
	    </style>

	    <?php
	}
	public static function blockArea()
	{
		ob_start();
		?>
		<style>
			.master-class-payment-box{
				  position:relative;
				  padding:15px;
			}
			.master-class-payment-box:after{
				position:absolute;
				width:100%;
				height:100%;
				top:0;
				left:0;
				content:'';
				background: rgba(232, 232, 232, 0.35);
				color:#fff;
				
			}
			.master-class-payment-pop{
				position:fixed;
				max-width:340px;
				height:200px;
				padding:15px 30px;
				text-align: center;
				top:30%;
				left:50%;
				margin:0 auto;
				background: #fff;
				content:'For Paid Plugins';
				z-index:9;
				display: flex;
				align-items: center;
				justify-content: center;
				font-size:16px;
				text-transform: uppercase;
				font-weight:600;
				border-radius:4px;
				box-shadow: 0px 0px 8px #cfcfcf;
				margin-left:-100px;
			}
			.master-class-payment-pop p{
				padding:0!important;
				border:none!important;
			}
		</style>
		<script>
			
		</script>
		<?php
		$contents = ob_get_clean();
		return $contents;
	}

}