<?php
class Master_Lesson_Before_Content
{

	public function __construct()
	{
		add_filter( 'the_content', array($this,'add_before_content') );

		add_filter('the_title', array($this,'new_title'), 10, 2);
		add_action('wp_enqueue_scripts',array($this,'add_js'));
	}
	public static function add_js(){
		if ( !is_single() && 'mc-class' != get_post_type() )
			return;

		wp_enqueue_script( 'mc-lesson-script', MC_JS . '/mc-front.js', array( 'jquery' ) );

	}
	public static function new_title( $title, $id ){
		if( is_admin() ){
			return $title;
		}
		if('mc-class' == get_post_type($id))
        	$title = '';
    	return $title;
	}

	public static function add_before_content( $content ){
		if ( is_single() && 'mc-class' == get_post_type() ) {
			$pagination = '';
			$iframe_elem = '';
			$all_lesson = Master_Lesson_Before_Content::view_all_lesson();

			$mc_cls_pagination_lesson = (get_option('mc_cls_pagination_lesson')) ? get_option('mc_cls_pagination_lesson') : 'enable';
			if( $mc_cls_pagination_lesson == 'enable' ){
		        $pagination .= Master_Lesson_Before_Content::add_next_pagination(get_the_ID());
		    }

		    if( get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_url',true) ){
		    	$vid_type = get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_type',true) ? get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_type',true) : 'youtube';
		    	$vid_url = get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_url',true);
		    	$img_type = esc_attr( $org_term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) ? esc_attr( $org_term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) : 'default';

				if($img_type == 'default'){
					$posterImg = MC_IMG."/poster.jpg";
				}else{
					$posterImg = wp_get_attachment_url(get_post_meta(get_the_ID(),'_mc_lesson_vid_thumb_image_term_meta',true));
				}
                if(strlen($vid_url)>0):
		    	if( $vid_type == 'whistia' ){
		    		$vid_src = Common_Functions_Controller::generate_iframe( $vid_url, $vid_type ); ?>
					<script>
					window._wq = window._wq || [];
					_wq.push({
					  id: "<?php echo $vid_src; ?>",
					  options: {
					  	smallPlayButton: true,
					    videoFoam: true,
					    playerColor: "ff0000",
					    playButton: true,
					    settingsControl: true,
					    stillUrl: "<?php echo $posterImg; ?>",
					    volumeControl: true,
					    wmode: "transparent",
					    endVideoBehavior: "reset"
					  }
					});
					</script>
					<script charset="ISO-8859-1" src="//fast.wistia.com/assets/external/E-v1.js" async></script>
					<!-- <div class="mcLessonFeaturedVideo mc-class-video-area mcWhistiaVideo wistia_embed wistia_async_<?php echo $vid_src; ?>" style="width:620px;height:340px;"></div> -->
					<?php 
		    		$iframe_elem='<div class="mcLessonFeaturedVideo mc-class-video-area mcWhistiaVideo wistia_embed wistia_async_'.$vid_src.'" style="width:620px;height:340px;"></div>';
		    	
		    	}else{

		    		$iframe_elem = Master_Lesson_Before_Content::video_player( $vid_type, $vid_url );
		    	
		    	}	
		    	endif;
		    }
		    global $post;
            
            $vid_type = get_post_meta($post->ID,'_mc_lesson_tutorial_video_type',true) ? get_post_meta($post->ID,'_mc_lesson_tutorial_video_type',true) : 'youtube';
            $scheduleType=get_post_meta($post->ID,'_schedule_live_video_class_makr',true) ? get_post_meta($post->ID,'_schedule_live_video_class_makr',true) : '';
            $scheduleTime=get_post_meta($post->ID,'_schedule_live_video_class_makr_time',true)? get_post_meta($post->ID,'_schedule_live_video_class_makr_time',true) : '';
		    
		    
		    $title = '<div class="clearfixMCclass"></div><div class="mcLessonBeforeContentTitle">'.$post->post_title;
		    if($vid_type=='youtube-live')
		    {
		        if(strlen($scheduleType)>0)
		        {
		            if (time() < $scheduleTime) 
		            {
		                 $title.=($vid_type=='youtube-live'?'<span class="mc_sedulous_txt"> Scheduled on '.date('m-M d, Y @ H:i',$scheduleTime).' </span</div>':'');       
		            }
		        }
		    }
		  
		    $navigation = '';
		    $mc_nav_on_pages = (get_option('mc_nav_on_pages')) ? get_option('mc_nav_on_pages') : 'disable';
		    if( is_user_logged_in() && $mc_nav_on_pages == 'enable' ){
		    	$current_user = wp_get_current_user();

		    	$img_url = Common_Functions_Controller::get_avatar_img_url( $current_user->user_email );
		    	
		    	$navigation = '<div class="mcUserAccNavUL mcUserAccNavUL-front">
	        							<div class="mcUserAccNavLILogon"><img src="'.$img_url.'" />Hello '.$current_user->display_name.'</div>
										<div class="mcUserAccNavLI"><a href="'.site_url().'/mc-dashboard" target="_blank;">My Dashboard</a></div>
										<div class="mcUserAccNavLI"><a href="'.wp_logout_url( home_url().'/mc-login/?logout=success' ).'">Logout</a></div>
									</div>';
		    }
            $LiveStatus=Common_Functions_Controller::lessonLiveStatus($post->ID);
            if($LiveStatus!='active')
            {
                $before_content = '<div class="mcContMainWrapper">';
    		    $before_content .= '<div class="mcContSubWrapper">';
    
    	        $before_content .= '<div class="mcLessonBeforeContentDiv">
    
    	        	'.$navigation.$all_lesson.$pagination.'<div class="clearfixMCclass"></div>'.$iframe_elem.$title.'</div><div class="mcLessonContentDiv">'.$content.'</div>';
    	        return $before_content;
            }
            else
            {
                $before_content = '<div class="mcContMainWrapper">';
                $before_content .= '<div class="mcContSubWrapper">';
                $before_content .= '<div class="mcLessonBeforeContentDiv">'.$navigation.$all_lesson.$pagination;
                $before_content.='<div class="clearfixMCclass"></div>';
                $before_content.='</div>';
                $before_content.=$title.'</div>';
                $before_content.=$iframe_elem;
                return $before_content;
            }
		    
	    } else {
	        return $content;
	    }
	}

	public static function video_player( $vid_type, $vid_url ){
		ob_start();
		
		$vid_src = Common_Functions_Controller::generate_video_url( $vid_type, $vid_url ); 

		$img_type = get_post_meta( get_the_ID(), '_mc_lesson_vid_thumb_image_type_term_meta', true ) ? get_post_meta( get_the_ID(), '_mc_lesson_vid_thumb_image_type_term_meta', true ) : 'default';

		if($img_type == 'default'){

			$posterImg = MC_IMG."/poster.jpg";

		}else{

			$posterImg = wp_get_attachment_url(get_post_meta(get_the_ID(),'_mc_lesson_vid_thumb_image_term_meta',true));
		}

		if( $vid_type == 'youtube' ){

			$videoType = 'youtube';

		}elseif( $vid_type == 'vimeo' ) {
			
			$videoType = 'vimeo';

		}elseif($vid_type == 'youtube-live'){

			$videoType = 'youtube';
		}
		else
		{
		    $videoType = 'HTML5';
		}
		?>
		<link rel="stylesheet" href="<?php echo MC_CSS; ?>/stellar.css" type="text/css" media="screen"/>
		<link rel="stylesheet" href="<?php echo MC_CSS; ?>/stellar-font-awesome.css" type="text/css">
		<script src="<?php echo MC_JS; ?>/jquery.mCustomScrollbar.js" type="text/javascript"></script> 
		<script src="<?php echo MC_JS; ?>/videoPlayer.js" type="text/javascript"></script>
		<script src="<?php echo MC_JS; ?>/Playlist.js" type="text/javascript"></script>
		<script src="<?php echo MC_JS; ?>/iphone-inline-video.js" type="text/javascript"></script>
		<script src="https://player.vimeo.com/api/player.js"></script>

		<div class="mcLessonFeaturedVideo mc-class-video-area" id="mcLessonFeaturedVideo-stellar-video-player"></div>
		<script type="text/javascript" charset="utf-8">
			(function($){
				$(document).ready(function($)
				{
					videoPlayer = $("#mcLessonFeaturedVideo-stellar-video-player").Video({                       
							instanceName:"player1",
							instanceTheme:"<?php echo get_option( 'mc_player_theme' ) ? get_option( 'mc_player_theme' ) : 'light'; ?>",
							playerLayout: "fixedSize",
							playerOrientation:"<?php echo get_option( 'mc_player_text_orientation' ) ? get_option( 'mc_player_text_orientation' ) : 'false'; ?>",
							autohideControls:3,
							hideControlsOnMouseOut:true,
							videoPlayerWidth:768,
							videoPlayerHeight:432,
							videoRatio: 16/9,
							videoRatioStretch: true,
				            iOSPlaysinline: true,
				            autoplay:<?php echo get_option( 'mc_player_autoplay' ) ? get_option( 'mc_player_autoplay' ) : 'false'; ?>,
							colorAccent:"<?php echo get_option('mc_player_color_acent') ? get_option('mc_player_color_acent') : '#ff0000'; ?>",
							videoAnimationTime: 350,
							playSpecificVideo: 0,
							progressBarThickness: 3,
							progressBarThicknessOnMouseover: 6,
							tooltipFontSize:12,
							videoPlayerShadow:"<?php echo get_option( 'mc_player_shadow_effect' ) ? get_option( 'mc_player_shadow_effect' ) : 'effect1' ;?>",
							loadRandomVideoOnStart:false,
							shuffle:false,
							posterImg:"<?php echo $posterImg; ?>", 
							posterImgOnVideoFinish:"<?php echo $posterImg; ?>",
							onFinish:"Stop video",
							nowPlayingText:true,
							showAllControls:true,
							allowSkipAd:true,
							infoShow:false,
							nextShow:false,
							rewindShow:<?php echo get_option( 'mc_player_rewind' ) ? get_option( 'mc_player_rewind' ) : 'true'; ?>,
							qualityShow:false,
							lightBox:false,
							playlist:"Off",
							playlistBehaviourOnPageload:"opened (default)",				
							vimeoColor:"00adef",
							youtubeControls:"custom controls",
							youtubeSkin:"dark",
							youtubeColor:"white",
							youtubeQuality:"default",
							youtubeShowRelatedVideos:false,
							HTML5VideoQuality:"HD",
							preloadSelfHosted:"none",
							rightClickMenu:false,
							hideVideoSource:true,
							shareShow:false,
							logoShow:false,
							embedShow:false,
							showGlobalPrerollAds: false,
							globalPrerollAds: "url1;url2;url3;url4;url5",
							globalPrerollAdsSkipTimer: 5,
							globalPrerollAdsGotoLink: "https://bsitemaker.com/",
							youtubePlaylistID:"",
							youtubeChannelID:"",
						videos:[
						{
							videoType:"<?php echo $videoType; ?>",
							title:"<?php echo $lesson_details->name; ?>",
							<?php if( $videoType == 'youtube' ){ ?>
							youtubeID: "<?php echo $vid_src; ?>",
							<?php }elseif( $videoType == 'vimeo' ){ ?>
							vimeoID: "<?php echo $vid_src; ?>",
							<?php }else{ ?>
							mp4HD:"<?php echo htmlspecialchars_decode($vid_src); ?>",
							<?php } ?>
							enable_mp4_download:false,
							imageUrl:"<?php echo $posterImg; ?>",
							imageTimer:4,
							thumbImg:"<?php echo $posterImg; ?>",
						},
						
						
			]
						
					});
				});
			})(jQuery)
		</script>
		<?php
		return ob_get_clean();
	}

	public static function add_next_pagination($current){
		ob_start();
		
		if(is_user_logged_in()):
		$category_detail = get_the_terms( $current,'mc-class-category' );
		if($category_detail)
		{
		    $t_id = $category_detail[0]->term_id;
		    $args=array('post_type'=>'mc-class','post_status'=>'publish','fields' => 'ids','posts_per_page'=>-1,'tax_query'=>array(array('taxonomy' => 'mc-class-category',               
                    'field' => 'id',                    
                    'terms' => array($t_id),     
                    'operator' => 'IN'                   
                    )));
            $lessons=get_posts( $args );
            $pos=array_search($current,$lessons);
            
            $lastPos=count($lessons)-1;
            
            $nextPos=(count($lessons)>1 && $pos<$lastPos?$pos+1:false);
            if($nextPos)
            {
                ?>
                <div id="mcTopNavigation" class="mc_pagination">
      				<a href="<?php echo esc_url( get_permalink( $lessons[$nextPos] ) ); ?>">Next Lesson <span class="dashicons dashicons-arrow-right"></span></a>
      			</div>
                <?php
            }
		}
		else
		{
		    return '';
		}
		
  		return ob_get_clean();
  		else:
  		    return '';
  		endif;
	}
    
    public function checkNextPostAccess($nextpost)
	{
	    $subscribed = false;
		$category_detail = get_the_terms( $nextpost,'mc-class-category' );
		$t_id = $category_detail[0]->term_id;

		$args = array(
			'posts_per_page'   => -1,
			'meta_key'         => '_mc_pay_user_id',
			'meta_value'       => get_current_user_id(),
			'post_type'        => 'mc_class_payment',
			'post_status'      => 'publish',
		);
		$payments_array = get_posts( $args );
		foreach ($payments_array as $payment) {
			$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
			$bundle_id = get_option( '_mc_class_bundle_id' );
			if( $term_id == $bundle_id ){
				$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
				if(in_array( $t_id, $mc_cls_bundle_package_product )){
					$subscribed = true;
					break;
				}
			}
			if( $term_id == $t_id ){
				$subscribed = true;
				break;
			}
		}
		return $subscribed;
		
	}
    
	public static function view_all_lesson(){
		ob_start();
		global $post;
  		$category_detail=get_the_terms( $post->ID,'mc-class-category' );
		$term_id = $category_detail[0]->term_id;
		$term_meta = get_option( "taxonomy_".$term_id );
		wp_reset_query();
		$args = array(
		    'post_type' => 'mc-class',
		    'post_status' => 'publish',
		    'posts_per_page' => -1,
		    'tax_query' => array(
		        array(
		            'taxonomy' => 'mc-class-category',
		            'field'    => 'term_id',
		            'terms'    => array( $term_id )
		        )
		    )
		);
		$lessons = get_posts( $args );
		wp_reset_query();
		?>
		<div class="mcTopviewAllLessonDiv">
			<div class="mcTopviewAllLessonTitle">View All Lessons</div>
			<div class="mcTopviewAllLessonUl">
				<div class="mcTopviewAllLessonBeforeLi">
				    <?php if($term_meta['mc_grad_term_meta']=='mcq'):
				            $examCount=0;
				            $examtakencount=0;
				            foreach($lessons as $lesson)
				            {
				                $examSet=get_post_meta($lesson->ID,'_mc_question_answer_set');
				                if(is_array($examSet) && count($examSet)>0)
				                {
				                    $key = 'mc_score_for_'.$lesson->ID.'_based_on_mcq';
	    		                    $value = get_user_meta(get_current_user_id(),$key,true );
	    		                    $examtakencount=($value>0?$examtakencount+1:$examtakencount);
				                    $examCount++;
				                }
				            }
				    ?>
				    <div class="mcTopviewAllLessonBeforeLiTotalCount"><?php echo ($examCount>0?'Lesson quizes completed: '.$examtakencount.'/'.$examCount:'');?></div>
				    <?php endif;?>
					<?php
						foreach ($lessons as $lesson) {
							?>
							<div class="mcTopviewLessonLi <?php if( $lesson->ID == get_the_ID() ){ echo 'mcTopviewLessonLiActive'; } ?>">
								<a href="<?php echo get_permalink($lesson->ID);?>">
									<div class="mcTopviewLessonLih3"><?php echo $lesson->post_title; ?></div>

								</a>
								<div class="mcTopviewLessonLiDesc"><?php echo strlen(strip_tags($lesson->post_content)) > 150 ? substr(strip_tags($lesson->post_content),0,150)."..." : strip_tags($lesson->post_content); ?></div>
								<?php Master_Lesson_Before_Content::get_lesson_score($lesson->ID); ?>
							</div>
							<?php
						}
					?>
				</div>
			</div>

     <div class="mcCloseOverlay"></div>

		</div>
		<script type="text/javascript">
			jQuery(".mcTopviewAllLessonTitle").click(function(){
			  jQuery(".mcTopviewAllLessonUl").toggleClass("whenActive");
				jQuery(".mcCloseOverlay").toggleClass("actWhen");
			});
			jQuery(".mcCloseOverlay").click(function(){
				jQuery(this).toggleClass("actWhen");
				jQuery(".mcTopviewAllLessonUl").toggleClass("whenActive");
			});
		</script>
		<?php

  		return ob_get_clean();
	}
	public static function get_lesson_score($id){
		global $post;
    	setup_postdata($post);
		$category_detail=get_the_terms( $id,'mc-class-category' );
		$cat_id = $category_detail[0]->term_id;
		$term_meta = get_option( "taxonomy_$cat_id" );
		$grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
		if( !$grad && $grad == 'none' )
			return;
		switch ($grad) {
			case 'mcq':
				$key = 'mc_score_for_'.$id.'_based_on_mcq';
	    		$value = get_user_meta(get_current_user_id(),$key,true );
	    		$value=($value>0?$value.'%':'');
				break;
			case 'confident':
				$key = 'mc_score_for_'.$id.'_based_on_confident';
	    		$value = get_user_meta(get_current_user_id(),$key,true );
	    		$value=($value>0?$value.'%':'');
				break;
			case 'checkmark':
				$key = 'mc_score_for_'.$id.'_based_on_checkmark';
	    		$value = get_user_meta(get_current_user_id(),$key,true );
	    		$value=($value=='yes'?'Completed':'');
				break;

			default:
				# code...
				break;
		}
		if( $value )
		{
			?>
			<div class="mcTopviewLessonLiScore">
				<div class="mcTopviewLessonLiScoreText"><?php echo $value; ?></div>
			</div>
			<?php
		}
	}
}
