<?php
class Master_Lesson_Functions
{
	public function __construct()
	{
		add_filter( 'post_class', array($this,'add_mc_post_class'));
		add_filter( 'single_template', array($this,'add_mc_class_single_template'));
		add_action( 'wp_head', array($this,'check_lesson_access' ));
		//add_action( 'template_redirect', array($this,'check_lesson_access' ));
		add_action( 'wp_ajax_mc_learner_comment_update',array($this,'mc_learner_comment_update_callback'));
		add_action( 'wp_ajax_nopriv_mc_learner_comment_update', array($this,'mc_learner_comment_update_callback' ));
		add_action( 'wp_ajax_calculate_user_quiz', array($this, 'calculate_user_quiz_callback' ));
    	add_action( 'wp_ajax_nopriv_calculate_user_quiz', array($this, 'calculate_user_quiz_callback' ));
    	add_action( 'save_post', [$this,'flush_permalink'], 10, 2 );
    	add_action('before_delete_post', [$this,'delete_handler']);
    	add_action( 'current_screen', [$this,'restrict_lesson_creation'] );
    	add_action('admin_head',[$this,'restrict_lesson_creation_button']);
    	add_action('admin_notices',[$this,'masterClass_admin_notice']);
    	add_action( 'delete_term_taxonomy', [$this,'cleanBundleWhenClassGetsDeleted'], 9, 1);
    	
	}
	public function add_mc_class_single_template(){
	    global $post;
	    if ( $post->post_type == 'mc-class' ) {
            if ( file_exists( MC_REQ_CLS.'/single-mc-class.php' ) ) {
                return MC_REQ_CLS.'/single-mc-class.php';
            }
        }

    return $single;
	}
	public function cleanBundleWhenClassGetsDeleted($tt_id) {
        $term = get_term( $tt_id );
        if($term->taxonomy=='mc-class-category')
        {
            $mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
            if(!empty($mc_cls_bundle_package_product))
            {
                foreach($mc_cls_bundle_package_product as $key=>$value)
                {
                    if($value==$tt_id)
                    {
                        unset($mc_cls_bundle_package_product[$key]);
                    }
                }
            }
            if(count($mc_cls_bundle_package_product)<2)
            {
                update_option('mc_cls_bundle_package_product','');
            }
            else
            {
                update_option('mc_cls_bundle_package_product',$mc_cls_bundle_package_product);
            }
        }
    
    }
	public function flush_permalink($id)
	{
		$post_type=get_post_type($id);
		if($post_type==='mc-class')
		{
			$status=get_post_status ( $id );
			if($status!='auto-draft')
			{
				update_option('_master_class_lesson_track_limit_'.$id,1);
			}
			global $wp_rewrite;
			$permalink_structure=get_option('permalink_structure');
			$permalink_structure = sanitize_option( 'permalink_structure', $permalink_structure );
			$wp_rewrite->set_permalink_structure( $permalink_structure );
		}
	}
	public function delete_handler($post_id)
	{
		delete_option('_master_class_lesson_track_limit_'.$post_id);
	}
	public function restrict_lesson_creation()
	{
		global $pagenow;
		global $wpdb;
		$limit=$wpdb->get_var("SELECT count(option_id) FROM `".$wpdb->prefix."options` WHERE option_name like '%_master_class_lesson_track_limit%'");
	    if($pagenow==='post-new.php' && isset($_GET) && isset($_GET['post_type']) && $_GET['post_type']=='mc-class' && $limit>=10)
	    {
	    	$msg='<p style="margin: 20px 0 20px;"><img src="'.MC_IMG.'/icon_lock.png" alt="master-class" style="float:left;padding: 2px;width:30px;"> <span class="master-class-notice" style="margin-top: 5px;display: block;text-transform: uppercase;font-weight: 600;padding-top: 5px;"> &nbsp; To add unlimited lessons you will need to get the <a href="https://classmakr.com/" target="_blank">pro version</a>.</span></p>';
	    	wp_die( $msg );
	    }
	}
	public function restrict_lesson_creation_button()
	{
		global $pagenow;
		global $wpdb;
		$limit=$wpdb->get_var("SELECT count(option_id) FROM `".$wpdb->prefix."options` WHERE option_name like '%_master_class_lesson_track_limit%'");
	    if($pagenow==='post.php' && isset($_GET) && isset($_GET['post']) && get_post_type($_GET['post'])=='mc-class' && $limit>=10)
	    {
	    	?>
	    	<style>
	    		.page-title-action{display: none !important;}
	    	</style>
	    	<?php
	    }
	     if($pagenow==='edit.php' && isset($_GET) && isset($_GET['post_type']) && $_GET['post_type']=='mc-class' && $limit>=10)
	     {
	     	?>
	    	<style>
	    		.page-title-action{display: none !important;}
	    	</style>
	    	<?php
	     }
	}
	public function masterClass_admin_notice()
	{
		global $pagenow;
		global $wpdb;
		$screen = get_current_screen();
		$limit=$wpdb->get_var("SELECT count(option_id) FROM `".$wpdb->prefix."options` WHERE option_name like '%_master_class_lesson_track_limit%'");
	    if($pagenow==='post.php' && isset($_GET) && isset($_GET['post']) && get_post_type($_GET['post'])=='mc-class' && $limit>=10 && $screen->id != 'mc-class_page_email-template-customizer' && $screen->id != 'mc-class_page_master-class-settings' && $screen->id != 'mc-class_page_master-class-email-api')
	    {
	    	?>
	    	<div class="error">
		        <div style="padding: 5px;">
		        	<img src="<?php echo MC_IMG.'/icon_lock.png;'?>" style="float:left;padding: 2px;width: 30px;" alt="master-class"><p style="text-transform: uppercase;font-weight: 600;"> &nbsp; To add unlimited lessons you will need to get the <a href="https://classmakr.com/" target="_blank">Pro version</a></p>
		        </div>
	      	</div>
	    	<?php
	    }
	    if($pagenow==='edit.php' && isset($_GET) && isset($_GET['post_type']) && $_GET['post_type']=='mc-class' && $limit>=10 && $screen->id != 'mc-class_page_email-template-customizer' && $screen->id != 'mc-class_page_master-class-settings' && $screen->id != 'mc-class_page_master-class-email-api')
	    {
	     	?>
	    	<div class="error">
		        <div style="padding: 5px;">
		        	<img src="<?php echo MC_IMG.'/icon_lock.png;'?>" style="float:left;padding: 2px;width:30px;" alt="master-class"><p style="text-transform: uppercase;font-weight: 600;"> &nbsp; To add unlimited lessons you will need to get the <a href="https://classmakr.com/" target="_blank">Pro version</a></p>
		        </div>
	      	</div>
	    	<?php
	    }
	}
	public static function check_lesson_access(){
	       if(is_single() && 'mc-class' == get_post_type())
	       {
	           $flag=true;
	           $redirect=home_url();
	           if( !is_user_logged_in() ){
	               $redirect=home_url()."/mc-login/?login=success";
	               $flag=false;
	           }
	           else{
	               $user = wp_get_current_user();
	               if($user->ID!=1)
				    {
				        $roles=(array) $user->roles;
                        if (! in_array( 'administrator', (array) $user->roles ) ) {
                            $subscribed = false;
            				$category_detail = get_the_terms( get_the_ID(),'mc-class-category' );
            				if($category_detail)
        				    {
        				        $t_id = $category_detail[0]->term_id;
        				        $args = array(
            					'posts_per_page'   => -1,
            					'meta_query' => array(
            					                    'relation' => 'AND',
            					                    array(
                                                         'key' => '_mc_pay_user_id',
                                                         'value' => get_current_user_id(),
                                                         'compare' => '='
                                                       )
            					    ),
            					'post_type'        => 'mc_class_payment',
            					'post_status'      => 'publish',
            				    );
            				    $payments_array = get_posts( $args );
            				    if(count($payments_array)>0){
            				        $subTemp=array();
            				        foreach ($payments_array as $payment) {
                    					$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
                    					$bundle_id = get_option( '_mc_class_bundle_id' );
                    					if( $term_id == $bundle_id ){
                    						$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
                    						if(is_array($mc_cls_bundle_package_product) && in_array( $t_id, $mc_cls_bundle_package_product )){
                    							$subscriFlag = '1';
                    							$stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
                    							if($stat=='cancelled')
                        					    {
                        					        $subscriFlag='0';
                        					    }
                    							array_push($subTemp,$subscriFlag);
                    						}
                    					}
                    					if( $term_id == $t_id ){
                    					    $subscriFlag = '1';
                    					    $stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
                    					    $stat2=get_post_meta($payment->ID,'_mc_order_status',true);
                    					    $orderStat=array();
        				                    
        				                    if(strlen($stat)>0)
                    				        {
                    				            $orderStat[]=$stat;
                    				        }
                    				        
                    				        if(strlen($stat2)>0)
                    				        {
                    				            $orderStat[]=$stat2;
                    				        }
                    					    
                    					    
                    					    if(in_array('cancelled',$orderStat))
                    					    {
                    					        $subscriFlag = '0';
                    					    }
                    					    array_push($subTemp,$subscriFlag);
                    					}
                				    }
                				    if(in_array('1',$subTemp))
        							{
        							    $subscribed=true;
        							}
        							if( !$subscribed ){
                    					 $redirect=home_url()."/mc-dashboard/";
	                                     $flag=false; 
                				    }
            				    }
            				    else
            				    {
            				        $redirect=home_url()."/mc-dashboard/";
	                                $flag=false; 
            				    }
        				    }
        				    else
        				    {
        				       $redirect=home_url()."/mc-dashboard/";
	                           $flag=false; 
        				    }
    				
                        }   
				    }
	           }
	           
	           if(!$flag)
	           {
	               echo '<script> var url="'.$redirect.'";window.location.href=url;</script>';
        	       exit;
	           }
	       }
	}
	public static function add_mc_post_class( $classes ) {
        global $post;
        $classes[] = 'mc-class-lessons';
        return $classes;
    }
    public static function calculate_user_quiz_callback(){
    	//echo "<pre>"; 
		//print_r($searcharray); // Only for print array print_r(parse_str$_POST['serialise']); echo "</pre>";
		parse_str($_POST['serialise'], $parsed_data);

		$lesson_id = $parsed_data['lesson_id'];
		$all_question_answer = get_post_meta( $lesson_id, '_mc_question_answer_set',true);
		$count_question = 1;
		$right = 0;
		foreach( $all_question_answer as $qa ){

			$user_choice_key = 'answer'.$count_question;
			$user_choose = $parsed_data[$user_choice_key];

			$count_answer = 1; 
			foreach( $qa['answer'] as $answer )
			{
				if( $answer['is_right'] == 'yes' && $count_answer == $user_choose ){
					$right++;
				}
				$count_answer++;
			}
			$count_question++;
		}
		$count_question--;
		$score_avg = ($right/$count_question)*100;
		$score_avg = round($score_avg,2);
		?>
		<input type="hidden" name="mcgradCheckMark-score" value="<?php echo $score_avg; ?>" id="mcgradCheckMark-score">
		<?php

    	echo "<span style='font-size:20px;'>Out of ".$count_question." question(s), you answered ".$right." right , and ".($count_question-$right)." wrong.</span>";
    	echo "<br/>Your score is <b><i>".$score_avg."%</i></b>";
    	die;
    }
	public static function get_mcq_gradation(){
		$all_question_answer = get_post_meta( get_the_ID(), '_mc_question_answer_set',true);
		$next_post = get_adjacent_post( true, '', true, 'mc-class-category' );
		//echo "<pre>"; print_r($all_question_answer); echo "</pre>";
		if(!$all_question_answer)
			return;
		?>
		<div class='mcLessonGrad'>
		    <div id="mcLessonMcqgrad">
		<form name="save_confident" action="" method="POST" id="mc_quiz_answer_set">
			<div class='mcLessonh2'>Lesson Quiz</div>
			<div class="mcLessonMcqgradquiz-container">
			  	<div id="mcLessonMcqgradquiz">
			  		<?php 
			  			$radio_count = 1;
			  			$total_slide = count($all_question_answer);
			  			$count_slide = 1;
			  			foreach( $all_question_answer as $qa ){
			  				
			  				?>
			  				<div class="mcLessonMcqgradslide">
			  					<div class="mcLessonMcqgradquestion"><?php echo $count_slide."/".$total_slide." - ".$qa['question']; ?> </div>
			  					<div class="mcLessonMcqgrad-radio-group mcLessonMcqgradanswers">
			  						<?php
			  							$count_answer = 1; 
			  							foreach( $qa['answer'] as $answer )
			  							{ 
			  								if($answer['text']){
				  								?>
					  							<div class="mcLessonMcqgrad-radio-group-item">
										          	<input id="radio-<?php echo $radio_count; ?>" type="radio" name="answer<?php echo $count_slide;?>" value="<?php echo $count_answer; ?>">	
										          	<label for="radio-<?php echo $radio_count; ?>">
										          		<i class="fas fa-check"></i>
										          		<?php echo $answer['text']; ?>
										           </label>
										       	</div>
				  								<?php
				  								$radio_count++;
				  								$count_answer++;
			  								}
			  							} 
			  						?>
			  					</div>
			  				</div>
			  				<?php
			  				$radio_count++;
			  				$count_slide++;
			  			}
			  		?>
			  		<div class="mcLessonMcqgradslide Calculating-slide">
			  			Calculating your score...
			  			<img src="<?php echo MC_IMG; ?>/preloader.gif">
			  		</div>
			  		<div class="mcLessonMcqgradslide result-slide">
						<div id="mcLessonMcqgradResultText"></div>
						<div class="mcLessonMcqgradResult-retake">
							Take the quiz again? <span id="mcLessonMcqgradRetake">Yes</span><?php if (!empty( $next_post )){ ?>
								&nbsp;|&nbsp;<a href="<?php echo esc_url( get_permalink( $next_post->ID ) );?>">No</a>
							<?php } ?> 
						</div> 
						<input id="mcLessonMcqgradMoveNext" class="mcLessonMcqgrad" type="submit" name="submit" value="Submit score" />
					</div>
			  		<input type="hidden" name="total-slide" id="total-slide" value="<?php echo $count_slide; ?>">
			  	</div>
			</div>
			<!-- <a id="mcLessonMcqgradprevious" class="mcLessonMcqgrad">Previous Question</a>
			<a id="mcLessonMcqgradnext" class="mcLessonMcqgrad">Next Question</a> -->

			<input type="hidden" id="MCuserId" name="MCuserId" value="<?php echo get_current_user_id( ); ?>">
			<input type="hidden" id="lesson_id" name="lesson_id" value="<?php echo get_the_ID(); ?>">
			<input type="hidden" id="_mc_grad_is_submit" name="_mc_grad_is_submit" value="yes">
			<input type="hidden" id="Mcgradation" name="Mcgradation" value="mcq">
		<?php 
			$redirect = 'none';
			if (!empty( $next_post )){ 
				$redirect = esc_url( get_permalink( $next_post->ID ) );
			} 
		?>
		<input type="hidden" id="mc_mcq_redirect" name="mc_mcq_redirect" value="<?php echo $redirect; ?>">
		</form>
		    </div>
		</div>
		
		
		<script type="text/javascript">
			jQuery('.mcLessonMcqgradslide:first-child').addClass('mcLessonMcqgradactive-slide');
			jQuery(".mcLessonMcqgrad-radio-group-item input").click(function(){
                //setTimeout(function(){ 
                        var obj=jQuery(this);

                        setTimeout(function(){

                                jQuery(obj).parent().parent().parent().removeClass('mcLessonMcqgradactive-slide');
                                jQuery(obj).parent().parent().parent().next().addClass('mcLessonMcqgradactive-slide');
                             
                                if( jQuery(obj).parent().parent().parent().next().hasClass('Calculating-slide')){
                                     jQuery(obj).parent().parent().parent().next().focus();
                                     var currentFocus = jQuery(obj).parent().parent().parent().next();
                                     var serialise = jQuery("#mc_quiz_answer_set").serialize();
                                     var data = {
                                         'action': 'calculate_user_quiz',
                                         'serialise': serialise
                                     };
                                     var ajaxurl = "<?php echo admin_url( 'admin-ajax.php' ); ?>";
                                        
                                         jQuery.post(ajaxurl, data, function(response) {
                                             jQuery("#mcLessonMcqgradResultText").html(response);
                                             currentFocus.removeClass('mcLessonMcqgradactive-slide');
                                             currentFocus.next().addClass('mcLessonMcqgradactive-slide');
                                     });

                                }

                         },1000);
                  
				
			});
			jQuery("#mcLessonMcqgradRetake").click(function(){
				jQuery('.mcLessonMcqgrad-radio-group-item input').prop('checked', false);
				jQuery(this).parent().parent().removeClass('mcLessonMcqgradactive-slide');
				jQuery('.mcLessonMcqgradslide:first-child').addClass('mcLessonMcqgradactive-slide');
				jQuery("#mcgradCheckMark-score").val();

			});

		</script>
		<?php
			$key = 'mc_score_for_'.get_the_ID().'_based_on_mcq';
			$score = get_user_meta( get_current_user_id(), $key, true );
			if( $score )
			{
		?>
				<div id="mcLessonMcqgradPrevresults" style="padding-top: 20px;">
					Your previous score was <b><i><?php echo $score; ?>%</i></b>
				</div>
		<?php
			}
	}
	public static function get_confident_gradation(){
		?>
		<div class='mcLessonGrad'>
		    <div id="mcLessonConfidentgrad">
		<div class='mcLessonh2'>How confident are you about this lesson?</div>
		<form name="save_confident" action="" method="POST">
			<div class="mcgradCheckMark-radio-group">
				<?php
				$key = 'mc_score_for_'.get_the_ID().'_based_on_confident';
				$score = get_user_meta( get_current_user_id(), $key, true );
				for( $i=0; $i<=100; $i+=25 ){
					
					?>
					<div class="mcLessonMcqgrad-radio-group-item">
						<input type="radio" id="confident_score-<?php echo $i; ?>" name="confident_score" value="<?php echo $i; ?>" <?php if( $score == $i){ echo "checked=checked";} ?> />
						<label for="confident_score-<?php echo $i; ?>"><i class="fas fa-check"></i><?php echo $i.'%'; ?></label>
					</div>
					<?php
				}
				?>
			</div>
			<input type="hidden" id="MCuserId" name="MCuserId" value="<?php echo get_current_user_id(); ?>">
			<input type="hidden" id="lesson_id" name="lesson_id" value="<?php echo get_the_ID(); ?>">
			<input type="hidden" id="_mc_grad_is_submit" name="_mc_grad_is_submit" value="yes">
			<input type="hidden" id="Mcgradation" name="Mcgradation" value="confident">
			<br/>
			<input id="mcLessonCheckMarkgradsubmit" type="submit" name="submit" value="Submit" class="mcLessonMcqgrad" />
			
		</form>
		</div></div>
		<?php

	}
	public static function get_checkmark_gradation(){
        ?>
        <div class='mcLessonGrad'>
            <div id="mcLessonCheckgrad">
        <!--<div class='mcLessonh2'>Are you done with this lesson?</div>-->
        <?php
        	$key = 'mc_score_for_'.get_the_ID().'_based_on_checkmark';
			$score = get_user_meta( get_current_user_id(), $key, true );
        ?>
        <form name="save_checkmark" action="" method="POST" id="mcLessonCheckMarkgradForm">
	        <div class="mcgradCheckMark-radio-group <?php echo ($score!='yes'?'class-makr-lesson-box':'class-makr-lesson-complete')?>">
		        <div class="mcgradCheckMark-radio-group-item class-makr-lesson-complete-item">
			        <label for="mcgradCheckMark-radio1">
			        	<?php echo ($score!='yes'?'Mark this lesson as completed':'You marked this lesson as complete');?>
			        	<input id="mcgradCheckMark-radio1" type="checkbox" value="yes" name="mcgradCheckMark-radio" <?php if( $score == 'yes' ){ echo "checked=checked";} ?>/>
			        	<span class="class-makr-gradation-checkmark"></span>
			        </label>
			        

			    </div>
			    <input type="hidden" id="MCuserId" name="MCuserId" value="<?php echo get_current_user_id(); ?>">
			    <input type="hidden" id="lesson_id" name="lesson_id" value="<?php echo get_the_ID(); ?>">
			    <input type="hidden" id="_mc_grad_is_submit" name="_mc_grad_is_submit" value="yes">
			    <input type="hidden" id="Mcgradation" name="Mcgradation" value="checkmark">
			    
			</div>
		</form>
		</div></div>
		<script>
		    jQuery(function($){
		        $("#mcgradCheckMark-radio1").on('change',function(e){
		            var check=$("#mcgradCheckMark-radio1:checked").val();
		            $("#mcLessonCheckMarkgradForm").submit();
		        });
		    });
		</script>
        <?php
        
	}
	public static function mc_learner_comment_update_callback(){
		//echo "<pre>"; print_r($_POST); echo "</pre>";
		$user_data = get_userdata( $_POST['user_id'] );
		global $wpdb;
		$role='';
		if(is_super_admin($_POST['user_id']))
         {
             $fname = get_user_meta( $_POST['user_id'], 'first_name', true );
             $fname=(strlen($fname)>0?$fname:'');
             $lname = get_user_meta( $_POST['user_id'], 'last_name', true );
             $lname=(strlen($lname)>0?$lname:'');
             $author=$fname.' '.$lname;
         }
         else
         {
             $authorData=get_user_by('id',$_POST['user_id']);
             if(in_array( 'administrator', (array) $authorData->roles ))
	         {
	             $email=$user_data->user_email;
	             $res=$wpdb->get_var("SELECT title FROM `".$wpdb->get_blog_prefix(1)."signups` WHERE user_email='".$email."' order by signup_id desc limit 1");
                 $author=$res;
                 $role='<span class="class-makr-chat-role">Administrator</span>';
	         }
	         else
	         {
	             $author=$user_data->display_name;
	         }
         }
		$commentdata = array(
			'comment_post_ID' => $_POST['lesson_id'], // to which post the comment will show up
			'comment_author' => $user_data->display_name, //fixed value - can be dynamic 
			'comment_author_email' => $user_data->user_email, //fixed value - can be dynamic 
			'comment_author_url' => site_url(), //fixed value - can be dynamic 
			'comment_content' => $_POST['comments'], //fixed value - can be dynamic 
			'comment_type' => 'pingback', //empty for regular comments, 'pingback' for pingbacks, 'trackback' for trackbacks
			'comment_parent' => 0, //0 if it's not a reply to another comment; if it's a reply, mention the parent comment ID here
			'user_id' => $user_data->ID, //passing current user ID or any predefined as per the demand
		);

		//Insert new comment and get the comment ID
 		$comment_id = wp_insert_comment( $commentdata );
        if ( is_wp_error( $comment_id ) ) {
            $error_string = $result->get_error_message();
            echo '<p>' . $error_string . '</p>';
        }
        else
        {
            $gravatar_url = Common_Functions_Controller::get_avatar_img_url($user_data->user_email);
        	wp_set_comment_status($comment_id,'1');
			echo json_encode(array('avatar'=>$gravatar_url,'author'=>$author,'msg'=>$_POST['comments'],'time'=>'Now','role'=>$role));
        }

	
		//echo "<pre>"; print_r($comment_id); echo "</pre>";
		die;
	}
	public static function save_gradation(){
		$user_id = $_POST['MCuserId'];
		$lesson_id = $_POST['lesson_id'];
		$gradation = $_POST['Mcgradation'];

		$key = 'mc_score_for_'.$lesson_id.'_based_on_'.$gradation;
		if( $gradation == 'checkmark' ){
			$value = $_POST['mcgradCheckMark-radio'];
		}
		if( $gradation == 'confident' ){
			$value = $_POST['confident_score'];
		}
		if( $gradation == 'mcq' ){
			$value = $_POST['mcgradCheckMark-score'];
		}
		update_user_meta( $user_id,$key,$value );
		$next_post_id = Navigation_Controller::get_next_post_id( $lesson_id );
		$flag=Master_Lesson_Functions::checkNextPostAccess($next_post_id);
	    if($next_post_id>1 && $flag==true)
		{
		    $next_post_link = get_permalink($next_post_id);
		}
		else
		{
		     $previous=Navigation_Controller::get_previous_post_id( $lesson_id );
		     $flag2=Master_Lesson_Functions::checkNextPostAccess($previous);
			 if($flag2==true)
			 {
			    $next_post_link = get_permalink($previous);
			 }
			 else
			 {
			     $next_post_link=get_permalink($lesson_id);
			 }
		}
		echo'<script>window.location.href="'.$next_post_link.'"</script>';
    	exit;

	}
	public function checkNextPostAccess($nextpost)
	{
	    $subscribed = false;
		$category_detail = get_the_terms( $nextpost,'mc-class-category' );
		$t_id = $category_detail[0]->term_id;

		$args = array(
			'posts_per_page'   => -1,
			'meta_key'         => '_mc_pay_user_id',
			'meta_value'       => get_current_user_id(),
			'post_type'        => 'mc_class_payment',
			'post_status'      => 'publish',
		);
		$payments_array = get_posts( $args );
		foreach ($payments_array as $payment) {
			$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
			$bundle_id = get_option( '_mc_class_bundle_id' );
			if( $term_id == $bundle_id ){
				$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
				if(in_array( $t_id, $mc_cls_bundle_package_product )){
					$subscribed = true;
					break;
				}
			}
			if( $term_id == $t_id ){
				$subscribed = true;
				break;
			}
		}
		return $subscribed;
		
	}

	
}