<?php
class MC_Login_Register_Controller
{

	public function __construct()
	{
		add_action( 'wp_footer', array($this,'add_customize_style'));
		add_action('wp_enqueue_scripts',array($this,'enqueue_font_awesone'));

		if ( isset($_POST['submit'] ) ) {

			if( $_POST['master-class-submit-action'] == '_mc_register_user' || $_POST['master-class-submit-action'] == '_mc_pay_by_user' ){
				if( $_POST['mc_payment_method'] == 'paypal_standard' ){
					if( is_user_logged_in() ){
						$return_url = site_url(). '/mc-dashboard/?payment=true';
					}else{
						$return_url = site_url(). '/mc-login/?payment=true&register=true';
					}
					MC_Login_Register_Controller::process_paypal_standard_payment( $return_url );
				}else{
					//MC_Payment_Controller::process_payment();
					return;
				}
			}
		}

		if (isset($_POST["txn_id"]) && isset($_POST["txn_type"])) {

			update_post_meta( 880, 'paypal_tax_id', $_POST );
			$custom_details = json_decode($_POST['custom']);

			MC_Login_Register_Controller::save_paypal_standard_payment_data( $custom_details->user_id,$custom_details->user_name,$custom_details->user_email, 'none',$_POST["txn_id"],$_POST['item_name'],$_POST['item_number'], $_POST['mc_gross'], $_POST['mc_currency'], $custom_details->coupon_code, $custom_details->actual_price, $custom_details->discount_amount, 'PayPal Standard');
		}

		add_filter( 'display_post_states', function ( $states, $post ) {
		  	if ( intval( get_option( '_mc_class_login_page_id' ) ) === $post->ID ) {
		        $states[] = __( 'MC Login Page' );
		    }

		    if ( intval( get_option( '_mc_class_registration_page_id' ) ) === $post->ID ) {
		        $states[] = __( 'MC Registration Page' );
		    }

		    return $states;
		}, 10, 2 );

		if(isset($_POST) && isset($_POST['submit']) && isset($_POST['master-class-submit-action']) && $_POST['master-class-submit-action'] != '_mc_login_user')
		{
			add_filter('login_redirect', array($this,'redirect_mc_learner'), 10, 3);
			add_action('wp_login_failed', array($this,'login_failed' ));
		}
		
		add_action('wp_authenticate_user', array($this, 'check_learner_account_status'), 10, 2);
		add_action('init',[$this,'classmakrLogin']);
		add_action('init',[$this,'resendActivationmail']);

	}
	public function resendActivationmail()
	{
	    if(isset($_GET) && isset($_GET['resendRqtEx']))
	    {
	        $userId=$_GET['resendRqtEx'];
	        $userId=base64_decode($userId);
	        $user = get_user_by( 'id', $userId );
	      
	        if ( ! empty( $user ) ) {
	            
	            $email=$user->user_login;
	            $first_name=$user->display_name;
	            $user_id=$userId;
	            $add_to_email_campaign = Master_Email_API_Controller::save_to_campaign($email,$first_name);

				$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				$input = $user_id.''.$data['email'].substr(str_shuffle($chars),0,100);
				$code = strtr(base64_encode($input), '+/=@#$%^', '-_,');

				update_user_meta( $user_id, 'mc_is_learner_active', 'no');
				update_user_meta ( $user_id, 'mc_learner_activation_code', $input );

				$body_value = (get_option( 'mc_eml_cust_body_four' )) ? get_option( 'mc_eml_cust_body_four' ) : 'Hi [DISPLAYNAME],<br/><p>Active your account be clicking below link.<br/><b><a href="[ACTURL]">Activate Account</a></b></p><br/>Thanks,<br/>Class Makr.';

				$body_value = str_replace('[ACTURL]',site_url().'/mc-login/?servicename=activateuser&digest='.$code,$body_value);
				$body_value = str_replace('[USERNAME]',$email,$body_value);
				$body_value = str_replace('[USEREMAIL]',$email,$body_value);
				$body_value = str_replace('[DISPLAYNAME]',$first_name,$body_value);

				//$body_value .= '<a href="'.home_url().'/mc-login/?servicename=activateuser&digest='.$code.'" target="_blank;">Click Here To Activate Your Account</a>';

				$to = $email;
				$subject = (get_option( 'mc_eml_cust_sub_four' )) ? get_option( 'mc_eml_cust_sub_four' ) : 'Class Makr Account Activation';

				$subject = str_replace('[USERNAME]',$email,$subject);
				$subject = str_replace('[USEREMAIL]',$email,$subject);
				$subject = str_replace('[DISPLAYNAME]',$first_name,$subject);

				$headers = array('Content-Type: text/html; charset=UTF-8');

				$body = MC_Email_Template_Controller::general_email_template($body_value);

				wp_mail( $to, $subject, $body, $headers );
				$return_url = site_url(). '/mc-login/?payment=true&register=true';
				header('Location: ' . $return_url);
				exit;
	        }
	        else
	        {
	            $return_url=get_site_url();
	            header('Location: ' . $return_url);
	            exit;
	        }
	    }
	}
	public function classmakrLogin()
	{
		if(isset($_POST) && isset($_POST['submit']))
		{
		    if(isset($_POST['master-class-submit-action']) && $_POST['master-class-submit-action'] == '_mc_login_user')
			{
				$login=$_POST['log'];
				$pwd=$_POST['pwd'];
				$rememberme=$_POST['rememberme'];

				$rememberme=($rememberme=='forever'?true:false);
				$redirect_to=stripcslashes($_POST['redirect_to']);
				$creds = array(
			        'user_login'    => $login,
			        'user_password' => $pwd,
			        'remember'      => $rememberme
			    );
			 
			    $user = wp_signon( $creds, false );
			    if ( !is_wp_error( $user ) ) {
			        $redirect=$this->redirect_mc_learner($redirect_to);
			    	wp_redirect($redirect);
			    	exit;
			    }
			}
		}
	}
	public static function add_customize_style(){
		echo'<style>.mcOrderSummaryBox .mcLessonh2{color: #fff !important;}</style>';
		
		$mc_gen_button_bck = get_option('mc_gen_button_bck') ? get_option('mc_gen_button_bck') : '#dd0808';
		if( $mc_gen_button_bck ){
			echo "<style>.mcLessonComments input[type='submit'],.mcAccInvoiceFooter button,.mcAccCancelSubscription,.mcAccCancelSubscription, #mcAccMyBillingTable button, #mcForgotPassForm #mc-forgot-pass-submit, .mcUserAcc .button, .mcRegLoginDiv input[type='submit']{ background-color: ".$mc_gen_button_bck." !important; }</style>";
		}

		
		$mc_gen_button_hover_bck = get_option('mc_gen_button_hover_bck') ? get_option('mc_gen_button_hover_bck') : '#bc0000';

		if( $mc_gen_button_hover_bck ){
			echo "<style>.mcLessonComments input[type='submit']:hover,.mcLessonComments input[type='submit']:focus,.mcAccCancelSubscription input[type='submit']:hover,.mcAccCancelSubscription input[type='submit']:hover,.mcAccCancelSubscription input[type='submit']:focus,.mcAccCancelSubscription input[type='submit']:focus,.mcAccInvoiceFooter button:hover,  #mcForgotPassForm #mc-forgot-pass-submit, #mcAccMyBillingTable button:hover, .mcUserAcc .button:hover, .mcRegLoginDiv input[type='submit']:hover,.mcRegLoginDiv input[type='submit']:focus{ background-color: ".$mc_gen_button_hover_bck." !important; }</style>";
		}

        $mc_gen_button_txt = get_option('mc_gen_button_text') ? get_option('mc_gen_button_text') : '#ffffff';
        if($mc_gen_button_txt)
        {
            echo "<style>.mcLessonComments input[type='submit']:hover,.mcLessonComments input[type='submit']:focus,.mcAccInvoiceFooter button,.mcAccCancelSubscription,.mcAccCancelSubscription, #mcAccMyBillingTable button, #mcForgotPassForm #mc-forgot-pass-submit, .mcUserAcc .button, .mcRegLoginDiv input[type='submit']{ color: ".$mc_gen_button_txt." !important; }</style>";
		    echo "<style>.mcLessonComments input[type='submit'],.mcAccCancelSubscription input[type='submit']:hover,.mcAccCancelSubscription input[type='submit']:hover,.mcAccCancelSubscription input[type='submit']:focus,.mcAccCancelSubscription input[type='submit']:focus,.mcAccInvoiceFooter button:hover,  #mcForgotPassForm #mc-forgot-pass-submit, #mcAccMyBillingTable button:hover, .mcUserAcc .button:hover, .mcRegLoginDiv input[type='submit']:hover,.mcRegLoginDiv input[type='submit']:focus{color: ".$mc_gen_button_txt." !important; }</style>";
		}

		$mc_price_button_bck = get_option('mc_price_button_bck') ? get_option('mc_price_button_bck') : '#dd0808';
		if( $mc_price_button_bck ){
			echo "<style>.mcClassAccessBtn a{ background-color: ".$mc_price_button_bck." !important; }</style>";
		}

		$mc_price_button_hover_bck = get_option('mc_price_button_hover_bck') ? get_option('mc_price_button_hover_bck') : '#bc0000';
		if( $mc_price_button_hover_bck ){
			echo "<style>.mcClassAccessBtn a:hover{ background-color: ".$mc_price_button_hover_bck." !important; }</style>";
		}
        
        $mc_price_button_txt=get_option('mc_price_button_txt') ? get_option('mc_price_button_txt') : '#ffffff';
        if($mc_price_button_txt)
        {
            echo "<style>.mcClassAccessBtn a{ color: ".$mc_price_button_txt." !important; }</style>";
            echo "<style>.mcClassAccessBtn a:hover{ color: ".$mc_price_button_txt." !important; }</style>";
        }


	}
	public static function check_learner_account_status($user, $password){
	    $userID = $user->ID;
	    $roles = $user->roles;
	    if( $roles[0] == 'mc_learner'){
	        $status = get_user_meta($userID, 'mc_is_learner_active', true);

            if($status == 'no') {
                wp_redirect( site_url() . '/mc-login/?login=suspend&resendRqt='.base64_encode($userID) );
	            exit;
            }
	    }
        return $user;


	}
	public static function login_failed( $username ) {
	   $referrer = $_SERVER['HTTP_REFERER'];
	   if ( !empty($referrer) && !strstr($referrer,'wp-login') && !strstr($referrer,'wp-admin') ) {
	        $referre_arr = explode("?",$referrer);

	        if(isset($_POST['class_id'])){
	        	wp_redirect( $referre_arr[0] . '?login=failed&classId='.$_POST['class_id'] );
	        	exit;
	        }

	        if( $referre_arr[1] != 'login=success'){
	            wp_redirect( $referrer );
	            exit;
	        }

	    	wp_redirect( $referre_arr[0] . '?login=failed' );
	    	exit;
	   }
	}

	public static function redirect_mc_learner( $redirect_to){
		global $user;

	    if ( isset( $user->roles ) && is_array( $user->roles ) ) {

	        if ( in_array( 'mc_learner', $user->roles ) ) {

	            if( $redirect_to ){

	            	return $redirect_to;

	            }else{

	            	$dashboard_url = get_option('_mc_class_account_page_id',true);
	            	return get_permalink($dashboard_url);

	            }

	        } else {
	            return home_url();
	        }
	    } else {
	        return $redirect_to;
	    }
	}
	public static function enqueue_font_awesone(){
		wp_enqueue_style('mc-font-awesome-1', MC_CSS . '/mc-font-awesome.css');
	}

	public static function login_register_form_html($show=''){
		echo '<div class="mcContMainWrapper"><div class="mcContSubWrapper">';
		if ( isset($_POST['submit'] ) ) {
			if($_POST['master-class-submit-action'] == '_mc_login_user')
			{
				$login=$_POST['log'];
				$pwd=$_POST['pwd'];
				$rememberme=$_POST['rememberme'];
				$flag=wp_authenticate($login,$pwd);
				if ( is_wp_error( $flag ) ) {
				   $error_string = $flag->get_error_message();
				   echo '<div class="mcErrorUl"><div class="mcErrorLi">'.$error_string.'</div></div>';
				  echo'<style>.mcSuccess-act-acc,.mcSuccessActivationEmail{display:none !important;}</style>';
				}
			}
	        if( $_POST['master-class-submit-action'] == '_mc_register_user' )
	        {

		        MC_Login_Register_Controller::registration_validation(
			        $_POST['email'],
			        $_POST['password'],
			        $_POST['email'],
			        $_POST['fname']
		        );

		        global $username, $password, $email, $website, $first_name;
		        $username   =   sanitize_user( $_POST['email'] );
		        $password   =   esc_attr( $_POST['password'] );
		        $email      =   sanitize_email( $_POST['email'] );
		        $first_name =   sanitize_text_field( $_POST['fname'] );


		        MC_Login_Register_Controller::complete_registration(
			        $username,
			        $password,
			        $email,
			        $first_name
		        );


		    }
		    if( $_POST['master-class-submit-action'] == '_mc_forgot_password_user' )
	        {
	        	if ( !email_exists( $_POST['email'] ) ){
	        		echo '<div class="mcErrorUl"><div class="mcErrorLi"><i><b>'.$_POST['email'].'</b></i> is not registered with us. Please check the email address and try again with new one.</div></div>';
	        	}else{
	        		MC_Login_Register_Controller::reset_password(
				        $_POST['email']
			        );
			        echo '<div class="mcSuccessUl"><div class="mcSuccessLi" style="text-align:center;">Reset password link send to your registered email.</div></div>';
	        	}


	        }

	        if( $_POST['master-class-submit-action'] == '_mc_reset_password_user' )
	        {
	        	$email = $_POST['reset-email-address'];
	        	$password = $_POST['password'];
	        	$user = get_user_by( 'email', $email );
	        	wp_set_password( $password, $user->ID );
	        	$new_url = site_url().'/mc-login/?reset=true';

	        	$body = (get_option( 'mc_eml_cust_body_one' )) ? get_option( 'mc_eml_cust_body_one' ) : 'Hi [DISPLAYNAME],<br/><p>Your account password is updated.</p><p> You can now login with your new password.</p><br/><br/>Thanks,<br/>Class Makr.';

	        	$body = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$body);
	        	$body = str_replace('[USERNAME]',$email,$body);
	        	$body = str_replace('[USEREMAIL]',$email,$body);
	        	$body = str_replace('[DISPLAYNAME]',$user->display_name,$body);

	 			$body = MC_Email_Template_Controller::general_email_template($body);

	 			$to = $email;
	 			$subject = (get_option( 'mc_eml_cust_sub_one' )) ? get_option( 'mc_eml_cust_sub_one' ) : 'Class Makr Account Password Updated';
	 			$subject = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$subject);
	        	$subject = str_replace('[USERNAME]',$email,$subject);
	        	$subject = str_replace('[USEREMAIL]',$email,$subject);
	        	$subject = str_replace('[DISPLAYNAME]',$user->display_name,$subject);

	 			$headers = array('Content-Type: text/html; charset=UTF-8');

	 			wp_mail( $to, $subject, $body, $headers );
			    echo '<div class="mcSuccess">Password is successfully updated. You can now login with your new password. <a href="'.site_url().'/mc-login/?login=success">Click Here To Login</a></div></div>';
			    ?>
				<script>window.history.pushState("data","Title",'<?php echo $new_url;?>');</script>
				<?php

	        }

	        if( $_POST['master-class-submit-action'] == '_mc_pay_by_user' )
	        {

	        	$courseid = $_POST['courseId'];

        		$bundle_id = get_option( '_mc_class_bundle_id' );

		    	if( $courseid == $bundle_id ){
		    		$price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
		    	}else{
		    		$term_meta = get_option( "taxonomy_$courseid" );
					$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
		    	}
		    	$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
				if( $price ){
					if( $_POST['mc_applied_coupon_code'] !='' && $_POST['mc_applied_coupon_amount'] == 0 ){
						MC_Payment_Controller::save_payment_data($_POST['_mc_user_logged_in_id'],'none','none',$courseid,0,$currency,$_POST['mc_applied_coupon_code'],$_POST['mc_actual_price_before_coupon_code'],$_POST['mc_discount_amount'],'Free Purchase');
					}else{
						$post = $_POST;
						MC_Payment_Controller::process_payment($post, $user_id);
					}
				} else {
					

					MC_Payment_Controller::save_payment_data($_POST['_mc_user_logged_in_id'],'none','none',$courseid,0,$currency,'','','','Free Purchase');
				}


	        }
	    }

	    echo "<div class='mcRegLoginDiv'>";
		    if(isset($_GET) && $show != 'registration'){
		    	if( $_GET['payment'] == 'true' && $_GET['register'] == 'true' ){
		    		?>
		    			<div class="mcSuccessActivationEmail" style="width: 100%; display: block; text-align: center; color: black; font-family: Raleway;">
		    				<b style="color: #34C04D; font-weight: 900;"><img src="<?php echo MC_IMG; ?>/email.png" width="5%" style="width: 35px;"> We sent an activation access link to your email address</b>
				        	<span style="display: block" class="class-makr-msg">If you did not get an email, check your spam box.</span>
				        	<?php 
				        	if(isset($_GET) && isset($_GET['payment']) && $_GET['payment']=='true')
				        	{
				        		?>
				        		<span class="class-makr-payment-succ-msg">Your payment has been accepted.</span>
				        		<?php
				        	}
				        	?>
				        </div>
		    		<?php

		    	}
		    	if( $_GET['payment'] == 'false' ){
		    		echo '<div class="mcErrorUl"><div class="mcErrorLi">Error occurred on payment processing.</div></div>';
		    	}

				if( $_GET['login'] == 'failed' ){

					echo '<div class="mcErrorUl"><div class="mcErrorLi">Wrong Username or Password. Do you want to reset password? <a href="'.site_url().'/mc-login/?forgot=true">Click Here</a></div></div>';
                    ?>
					<style type="text/css">.mcRegistrationFormPage{ display: none; } .mcLogInForm{display: block !important;} </style>
					<?php
				}

                if( $_GET['login'] == 'suspend' ){
                	$userID=$_GET['resendRqt'];
					?>
					 <div class="mcErrorUl">
					     <div class="mcErrorLi"><b>It appears your account is not active.</b></div>
					     <div class="mcErrorLi">If you just signed up with us make sure to first activate your account by clicking the email we sent titled “Account Activation.” 
					                            <br>Then click the link within this email to activate your account.</div>
					     <div class="mcErrorLi">If you need us to resend you this email, <b><a href="<?php echo site_url()?>?resendRqtEx=<?php echo $userID;?>">click here</a></b>.</div>
					 </div>
					<style type="text/css">.mcRegistrationFormPage{ display: none; } .mcLogInForm{display: block !important;} </style>
					<?php
				}

				if( $_GET['login'] == 'success' || $show='login'){
					?>
					<script type="text/javascript">jQuery(".mcRegLoginDiv").css('padding','0px 0px 0px 0px');</script>
					<style type="text/css">.mcRegistrationFormPage{ display: none; } .mcLogInForm{display: block !important;} </style>
					<?php
				}

				if( $_GET['forgot'] == 'true' ){
					?>
					<style type="text/css">.mcLogInForm, .mcRegistrationFormPage{ display: none !important; } .mcForgotPasswordForm{display: block !important;} </style>
					<?php
				}

				if( $_GET['reset'] == 'true' ){

					$reset = false;
					if( $_GET['digest'] )
					{
                        $code = $_GET['digest'];
						$input = base64_decode(strtr($code, '-_,', '+/=@#$%^'));

				        global $wpdb;
				        $user_query = new WP_User_Query(
							array(
								'meta_key'	  =>	'mc_learner_reset_code',
								'meta_value'	=>	$input
							)
						);

						$user = $user_query->get_results();
						if( $user[0]->ID )
						{
							$reset = true;
							MC_Login_Register_Controller::reset_password_form( $user[0]->user_email );
							?>
								<style type="text/css">.mcLogInForm, .mcRegistrationFormPage{ display: none; } .mcResetPasswordForm{display: block !important;} </style>
							<?php
						}

					}
					if( !$reset ){
					    echo '<div class="mcErrorUl"><div class="mcErrorLi">Wrong reset request. Please try again.</div></div>';
					    ?>
    					<style type="text/css">.mcLogInForm, .mcRegistrationFormPage{ display: none; } .mcForgotPasswordForm{display: block !important;} </style>
    					<?php
					}
				}

				if($_GET['servicename'] == 'activateuser'){

					MC_Login_Register_Controller::actiavte_user(
				        $_GET['digest']
				    );
				}
				if( $_GET['logout'] == 'success'){
		    		echo '<div class="mcLogoutSuccess">You are successfully logged out.</div>';
		    	}

			}


			MC_Login_Register_Controller::registration_form($username,$password,$email,$first_name);

		    MC_Login_Register_Controller::login_form($username);

		    MC_Login_Register_Controller::forgot_password_form();
	    echo "</div>";
	    echo "</div></div>";
	}
	public static function actiavte_user( $code ){
		if( !$code )
			return;
		$input = base64_decode(strtr($code, '-_,', '+/=@#$%^'));

        global $wpdb;
        $user_query = new WP_User_Query(
			array(
				'meta_key'	  =>	'mc_learner_activation_code',
				'meta_value'	=>	$input
			)
		);

		$user = $user_query->get_results();
		echo "<div class='mcActivationAccountMsg'>";
		if( $user[0]->ID )
		{
			if( get_user_meta( $user[0]->ID, 'mc_is_learner_active',true) == 'yes' ){
				?>
				<div class="mcSuccess mcSuccess-act-acc">
		        	Account is already activated. You can now login from here.
		        </div
				<?php
			}else{
				update_user_meta( $user[0]->ID, 'mc_is_learner_active', 'yes');
				$body = (get_option( 'mc_eml_cust_body_six' )) ? get_option( 'mc_eml_cust_body_six' ) : 'Hi [DISPLAYNAME],<br/> <p>Congratulations on creating an account with us. Kindly find your login details below.</p> <br/>Login with Username: [USERNAME]<br/>Password was created at signup<br/><p><a href="[LOGINURL]" target="_blank;">Login to your account using this link</a></p>Thanks,<br/>Class Makr.';
				$body = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$body);
	        	$body = str_replace('[USERNAME]',$user[0]->user_email,$body);
	        	$body = str_replace('[USEREMAIL]',$user[0]->user_email,$body);
	        	$body = str_replace('[DISPLAYNAME]',$user[0]->display_name,$body);

	 			$body = MC_Email_Template_Controller::general_email_template($body);

	 			$to = $user[0]->user_email;
	 			$subject = (get_option( 'mc_eml_cust_sub_six' )) ? get_option( 'mc_eml_cust_sub_six' ) : 'Class Makr WelCome Email';

	 			$subject = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$subject);
	        	$subject = str_replace('[USERNAME]',$user[0]->user_email,$subject);
	        	$subject = str_replace('[USEREMAIL]',$user[0]->user_email,$subject);
	        	$subject = str_replace('[DISPLAYNAME]',$user[0]->display_name,$subject);
	 			$headers = array('Content-Type: text/html; charset=UTF-8');

	 			wp_mail( $to, $subject, $body, $headers );
	 			?>
	 			<div class="mcSuccess mcSuccess-act-acc">
		        	Successfully activated your account. You can now login from here.
		        </div>
	 			<?php
	 		}

		?>


		<?php
		}else{
			?>
			<div class="mcErrorUl mcErr-act-acc">
				<div class="mcErrorLi mcErr-act-acc">Not a valid activation URL. Please try again.</div>
			</div>
			<?php
		}
		echo "</div>";
		?>
		<style type="text/css">.mcRegistrationFormPage{ display: none; } .mcLogInForm{display: block !important;} </style>
		<?php
	}
	public static function reset_password( $email ){
	    $user = get_user_by( 'email', $email );

		$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

		$input = $user->ID.''.substr(str_shuffle($chars),0,100);
		$code = strtr(base64_encode($input), '+/=@#$%^', '-_,');

		update_user_meta ($user->ID, 'mc_learner_reset_code', $input );

		$body_value = (get_option( 'mc_eml_cust_body_two' )) ? get_option( 'mc_eml_cust_body_two' ) : 'Hi [DISPLAYNAME], <br/><p>Click the below link to reset your account password.<br/><a href="[RESETLINK]"><b>Reset Password</b></a></p><br/>Thanks,<br/>Class Makr.';

		$body_value = str_replace('[RESETLINK]',site_url().'/mc-login/?reset=true&digest='.$code,$body_value);
    	$body_value = str_replace('[USERNAME]',$email,$body_value);
    	$body_value = str_replace('[USEREMAIL]',$email,$body_value);
    	$body_value = str_replace('[DISPLAYNAME]',$user->display_name,$body_value);

		// $body_value .= 'Hi User,';
		// $body_value .= '<a href="'.home_url().'/mc-login/?reset=true&digest='.$code.'" target="_blank;">Click Here To Activate Your Account</a>';

		$body = MC_Email_Template_Controller::general_email_template($body_value);
		$headers = array('Content-Type: text/html; charset=UTF-8');

		$subject = (get_option( 'mc_eml_cust_sub_two' )) ? get_option( 'mc_eml_cust_sub_two' ) : 'Class Makr Account Password Reset';

    	$subject = str_replace('[USERNAME]',$email,$subject);
    	$subject = str_replace('[USEREMAIL]',$email,$subject);
    	$subject = str_replace('[DISPLAYNAME]',$user->display_name,$subject);

		wp_mail( $email, $subject, $body, $headers);
	}
	public static function complete_registration() {
	    global $reg_errors, $username, $password, $email,  $first_name;
	    $daa = $reg_errors->get_error_messages();



	    if ( 1 > count( $reg_errors->get_error_messages() ) ) {
	        $userdata = array(
		        'user_login'    =>   $username,
		        'user_email'    =>   $email,
		        'user_pass'     =>   $password,
		        'first_name'    =>   $first_name,
		        'role'			=>   'mc_learner'
	        );
	        $user_id = wp_insert_user( $userdata );

	        if( !is_wp_error( $user_id ) )
			{
				$add_to_email_campaign = Master_Email_API_Controller::save_to_campaign($email,$first_name);

				$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				$input = $user_id.''.$data['email'].substr(str_shuffle($chars),0,100);
				$code = strtr(base64_encode($input), '+/=@#$%^', '-_,');

				update_user_meta( $user_id, 'mc_is_learner_active', 'no');
				update_user_meta ( $user_id, 'mc_learner_activation_code', $input );

				$body_value = (get_option( 'mc_eml_cust_body_four' )) ? get_option( 'mc_eml_cust_body_four' ) : 'Hi [DISPLAYNAME],<br/><p>Active your account be clicking below link.<br/><b><a href="[ACTURL]">Activate Account</a></b></p><br/>Thanks,<br/>Class Makr.';

				$body_value = str_replace('[ACTURL]',site_url().'/mc-login/?servicename=activateuser&digest='.$code,$body_value);
				$body_value = str_replace('[USERNAME]',$email,$body_value);
				$body_value = str_replace('[USEREMAIL]',$email,$body_value);
				$body_value = str_replace('[DISPLAYNAME]',$first_name,$body_value);

				//$body_value .= '<a href="'.home_url().'/mc-login/?servicename=activateuser&digest='.$code.'" target="_blank;">Click Here To Activate Your Account</a>';

				$to = $email;
				$subject = (get_option( 'mc_eml_cust_sub_four' )) ? get_option( 'mc_eml_cust_sub_four' ) : 'Class Makr Account Activation';

				$subject = str_replace('[USERNAME]',$email,$subject);
				$subject = str_replace('[USEREMAIL]',$email,$subject);
				$subject = str_replace('[DISPLAYNAME]',$first_name,$subject);

				$headers = array('Content-Type: text/html; charset=UTF-8');

				$body = MC_Email_Template_Controller::general_email_template($body_value);

				wp_mail( $to, $subject, $body, $headers );
				?>
		        <!-- <div class="mcSuccessActivationEmail" style="width: 100%; display: block; text-align: center; color: black; font-family: Raleway;">
    				<p><img src="<?php //echo MC_IMG; ?>/email.png" width="5%"></p>
		        	<b style="color: #34C04D; font-weight: 900;">We sent an activation email to your registered email address</b>
		        	<br/>
		        	Kindly activate your account from that email.<br/>
		        	If you did not get an email, let us know.<br/>
		        	<span style="font-size: 20px; font-weight: 400;">Your payment has been accepted (error).</span>
		        </div> -->
		        <?php
		        	if( $_POST['mc_payment_method'] == 'paypal_standard' )
		        		return;

		        	if( $_POST['courseId'] ){
		        		$_POST['_mc_user_logged_in_id'] = $user_id;


        		//$mc_applied_ca = $_POST['mc_applied_coupon_amount'] ? $_POST['mc_applied_coupon_amount'] : '';
        		//$mc_ccode = $_POST['mc_applied_coupon_code'] : $_POST['mc_applied_coupon_code'] : '';
        		//$mc_acode = $_POST['mc_actual_price_before_coupon_code'] : $_POST['mc_actual_price_before_coupon_code'] : '';
        		//$mc_damount = $_POST['mc_discount_amount'] ? $_POST['mc_discount_amount'] : ''; 

		        		$courseid = $_POST['courseId'];
		        		$bundle_id = get_option( '_mc_class_bundle_id' );

						if( $courseid == $bundle_id ){
							$price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
						}else{
							$term_meta = get_option( "taxonomy_$courseid" );
							$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
						}
						$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
						
						if( $price ){
							if( $_POST['mc_applied_coupon_code'] !='' && $_POST['mc_applied_coupon_amount'] == 0 ){
								MC_Payment_Controller::save_payment_data($_POST['_mc_user_logged_in_id'],'none','none',$courseid,0,$currency,$_POST['mc_applied_coupon_code'], $_POST['mc_actual_price_before_coupon_code'], $_POST['mc_discount_amount'],'Free Purchase');
							}else{
								$post = $_POST;
								MC_Payment_Controller::process_payment($post, $user_id);
							}
						}else{
							MC_Payment_Controller::save_payment_data($_POST['_mc_user_logged_in_id'],'none','none',$courseid,0,$currency,'','','','Free Purchase');
						}
		        	}
			} else {
				 ?>
		        <div class="mcErrorUl">Error Occured! Please try again after sometime</div>
	        <?php
			}
	    }
	}
	public static function registration_validation( $username, $password, $email, $first_name )  {
		global $reg_errors;
		$reg_errors = new WP_Error;

		if ( empty( $password ) || empty( $email ) ) {
		    $reg_errors->add('field', 'Required form field is missing');
		}
		if ( 5 > strlen( $password ) ) {
	        $reg_errors->add( 'password', 'Password length must be greater than 5' );
	    }
	    if ( !is_email( $email ) ) {
		    $reg_errors->add( 'email_invalid', 'Email is not valid' );
		}
		if ( email_exists( $email ) ) {
		    $reg_errors->add( 'email', 'Email Already in use' );
		}
		if ( is_wp_error( $reg_errors ) ) {

		    echo '<div class="mcErrorUl">';
			    foreach ( $reg_errors->get_error_messages() as $error ) {

			        echo '<div class="mcErrorLi">';
			        echo $error;
			        echo '</div>';

			    }
		 	echo "</div>";
		}
	}

	public static function registration_form( $username, $password, $email, $first_name )
	{
	    ?>
	    <div class="mcRegistrationFormPage">
		    <?php
		    	if( is_user_logged_in() ){
		    		global $current_user;
		    		global $wp;
		    		if( isset($_GET['classId']) && $_GET['classId'] != '') {
					    $courseid = $_GET['classId'];
					    $logout_url = wp_logout_url(home_url( $wp->request ).'/?classId='.$courseid);
					}else{
						$logout_url = wp_logout_url(home_url().'/mc-login/?logout=success');
					}
		    		?>
		    			<div class="mcRegFull">
		    				<?php
		    					$mc_nav_on_pages = (get_option('mc_nav_on_pages')) ? get_option('mc_nav_on_pages') : 'disable';
		    					if( is_user_logged_in() && $mc_nav_on_pages == 'enable' ){
		    						$current_user = wp_get_current_user();
							    	$img_url = Common_Functions_Controller::get_avatar_img_url( $current_user->user_email );
		    				?>
				    	  			<div class="mcUserAccNavUL mcUserAccNavUL-front">
	        							<div class="mcUserAccNavLILogon"><img src="<?php echo $img_url; ?>" />Hello <?php echo $current_user->display_name; ?></div>
										<div class="mcUserAccNavLI"><a href="<?php echo site_url();?>/mc-dashboard" target="_blank;">My Dashboard</a></div>
										<div class="mcUserAccNavLI"><a href="<?php echo wp_logout_url(home_url().'/mc-login/?logout=success');?>">Logout</a></div>
									</div>
							<?php } ?>
			    	  	</div>
		    		<?php
		    	} else {
		    	?>
				    <div class="mcRegFull">
			    	  	<div class="mcRegFormTitle">Register</div>
			    	  	<?php

				    	  	if( isset($_GET['classId']) && $_GET['classId'] != '') {
					    		$courseid = $_GET['classId'];
					    		$login_url = site_url().'/mc-login/?login=success&classId='.$courseid;
					    	}else{
					    		$login_url = site_url().'/mc-login/?login=success';
					    	}
				    	?>
			    	  	<div class="mcAlreadyAccount">Already have an account? <a href="<?php echo $login_url; ?>">Login</a></div>
			    	</div>
			<?php
				}

			?>

		    <div class="mcRegForm mcRegForm-left-side">

			    <form id="mcRegForm" action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
				    <?php
				    	if( !is_user_logged_in() )
				    	{
				    ?>
						    <div class="mcRegFormLegend">Basic Info</div>
						    <div class="mcLabelInput">
						    	<input type="text" name="fname" id="reg-name" value="<?php echo isset( $_POST['fname']) ? $first_name : null;?>" placeholder="Name">
						    	<div class="mcLabelInputSpan"></div>
						    	<i class="fas fa-address-card"></i>
						    </div>

						    <div class="mcLabelInput">
						    	<input type="text" placeholder="Email Address" id="reg-username" name="email" value="<?php echo isset( $_POST['email']) ? $email : null; ?>">
						    	<div class="mcLabelInputSpan"></div>
						    	<i class="fas fa-users"></i>
						    </div>

						    <div class="mcLabelInput">
						    	<input type="password" name="password" id="reg-password" value="<?php echo isset( $_POST['password'] ) ? $password : null; ?>" placeholder="Password">
						    	<span class="class-makr-password-strength" style="display: none;color: red">Password Must Have 6 Characters Minimum</span>
						    	<div class="mcLabelInputSpan"></div>
						    	<i class="fas fa-lock"></i>
						    </div>
						    <script type="text/javascript">
						    	jQuery( document ).ready(function($) {
									jQuery("#mc-reg-button").on('click',function(){

										var username = $("#reg-username").val();
									  	var password = $("#reg-password").val();
									  	var name = $("#reg-name").val();

									  	$("#reg-username").removeClass('mc-reg-error-exists');
									  	$("#reg-password").removeClass('mc-reg-error-exists');
									  	$("#reg-name").removeClass('mc-reg-error-exists');
									  	$(".class-makr-password-strength").fadeOut();
									  	$(".class-makr-terms-error").fadeOut();

									  	var emailReg = /^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i;

									    if( !$.trim(name) ){
									      	$("#reg-name").focus();
									      	$("#reg-name").addClass('mc-reg-error-exists');
									      	return false;
									  	}

									    if(!emailReg.test( username ))
									    {
									        $("#reg-username").focus();
									        $("#reg-username").addClass('error-exists');
									        return false;
									    }

									  	if( !$.trim(password) ){
									      	$("#reg-password").focus();
									      	$("#reg-password").addClass('mc-reg-error-exists');
									      	return false;
									  	}

									  	if(password.length < 6)
									    {
									        $("#reg-password").focus();
									      	$("#reg-password").addClass('mc-reg-error-exists');
									      	$(".class-makr-password-strength").fadeIn();
									      	return false;
									    }

									    var checkFlag=$('#mc_iagree:checked').val();

									    //class-makr-terms-error
										if (checkFlag!=undefined) {
											$("#mc_iagree").removeClass('mc-reg-error-exists');
											$('.mc-privacy-message').removeClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeOut();
											return true;
										} else {
											$("#mc_iagree").focus();
											$('.mc-privacy-message').addClass('mc-reg-error-exists');
											$("#mc_iagree").addClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeIn();
											return false;
										}

									});
									jQuery('#mc_iagree').click(function(){
										if($(this).is(':checked')) {
											$('.mc-privacy-message').removeClass('mc-reg-error-exists');
											$("#mc_iagree").removeClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeOut();

										} else {
											$('.mc-privacy-message').addClass('mc-reg-error-exists');
											$("#mc_iagree").addClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeIn();
										}
									});
								});
							</script>
					<?php
						} else {
							global $current_user;
							?>
							<script type="text/javascript">
						    	jQuery( document ).ready(function($) {
									jQuery("#mc-reg-button").on('click',function(){
										var checkFlag=$('#mc_iagree:checked').val();

									    //class-makr-terms-error
										if (checkFlag!=undefined) {
											$("#mc_iagree").removeClass('mc-reg-error-exists');
											$('.mc-privacy-message').removeClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeOut();
											return true;
										} else {
											$("#mc_iagree").focus();
											$('.mc-privacy-message').addClass('mc-reg-error-exists');
											$("#mc_iagree").addClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeIn();
											return false;
										}

									});
									jQuery('#mc_iagree').click(function(){
										if($(this).is(':checked')) {
											$('.mc-privacy-message').removeClass('mc-reg-error-exists');
											$("#mc_iagree").removeClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeOut();

										} else {
											$('.mc-privacy-message').addClass('mc-reg-error-exists');
											$("#mc_iagree").addClass('mc-reg-error-exists');
											$(".class-makr-terms-error").fadeIn();
										}
									});
								});
							</script>
							<input type="hidden" name="_mc_user_logged_in_id" id="_mc_user_logged_in_id_" value="<?php echo $current_user->ID; ?>">
							<?php
						}
					
    	$wcatTerms = get_terms('mc-class-category', array('hide_empty' => 0));
    	if( isset($_GET['classId']) && $_GET['classId'] != '') {
    		$courseid = base64_decode($_GET['classId']);
    	}else{
    		foreach($wcatTerms as $wcatTerm) {
	    		$courseid = $wcatTerm->term_id;
	    		break;
	    	}
    	}
    	$selected_term_meta = get_option( "taxonomy_$courseid" );
    	$selected_price = esc_attr( $selected_term_meta['mc_cat_price_term_meta']) ? esc_attr( $selected_term_meta['mc_cat_price_term_meta'] ) : 'FREE';

    	$bundle_id = get_option( '_mc_class_bundle_id' );
    	if( $courseid == $bundle_id ){
    		$selected_price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : 'FREE';
    	}

		?>
	    <div class="mcLabelInput" style="display:none;">
		    <select name="courseId" id="mccourseId">
		    	<?php
		    		foreach($wcatTerms as $wcatTerm) {
		    			$t_id = $wcatTerm->term_id;
		    			$term_meta = get_option( "taxonomy_$t_id" );
		    			$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
		    	?>
		    			<option data-url="<?php echo site_url().'/mc-registration/?classId='. base64_encode($t_id); ?>" value="<?php echo $t_id; ?>" <?php if( $courseid == $t_id ){ echo 'selected=selected';} ?>>
		    				<?php echo $wcatTerm->name; ?>
		    			</option>
		    	<?php
		    		}
		    		$mc_cls_bundle_on_class_listing = get_option('mc_cls_bundle_on_class_listing') ? get_option('mc_cls_bundle_on_class_listing') : 'disable';
		    		$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');

		    		if( $mc_cls_bundle_on_class_listing == 'enable' && !empty($mc_cls_bundle_package_product) ){
		    			$mc_cls_bundle_title = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
		    			?>
		    			<option data-url="<?php echo site_url().'/mc-registration/?classId='. base64_encode($bundle_id); ?>" <?php if( $courseid == $bundle_id ){ echo 'selected=selected';} ?> value="<?php echo $bundle_id; ?>">
		    				<?php echo $mc_cls_bundle_title; ?>
		    			</option>
		    			<?php
		    		}
		    	?>
		    </select>
		    <i class="fas fa-book-reader"></i>
		</div>
		<?php
		$square = get_option('mc_cls_square_status') ? get_option('mc_cls_square_status') : 'enable';
		$auth = get_option('mc_cls_auth_status') ? get_option('mc_cls_auth_status') : 'enable';
		$stripe = get_option('mc_cls_stripe_status') ? get_option('mc_cls_stripe_status') : 'enable';
		$paypal_standard = get_option('mc_cls_paypal_standard_status') ? get_option('mc_cls_paypal_standard_status') : 'enable';
					

		$checkingenablecount = 0;
		$getenablearray = [];

		if($square == 'enable'){
			$checkingenablecount ++;
			array_push($getenablearray,'$square');
		}
		if($auth == 'enable'){
			$checkingenablecount ++;
			array_push($getenablearray,'$auth');
		}
		if($stripe == 'enable'){
			$checkingenablecount ++;
			array_push($getenablearray,'$stripe');
		}
		if($paypal_standard == 'enable'){
			$checkingenablecount ++;
			array_push($getenablearray,'$paypal_standard');
		}

    	if( !is_user_logged_in() )
    	{
    		$action = '_mc_register_user';
    		if( $selected_price != 'FREE' ){
    			$button_value = 'Register & Pay';
    		}else{
    			$button_value = 'Register & Get Access';
    		}

    	}else{
    		$action = '_mc_pay_by_user';
    		if( $selected_price != 'FREE' ){
    			$button_value = 'Pay & Get Access';
    		}else{
    			$button_value = 'Get Access';
    		}

    	}
		
		$sq = get_option('mc_cls_square_status');
		$pa = get_option('mc_cls_paypal_standard_status');
		$st = get_option('mc_cls_stripe_status');
		$au = get_option('mc_cls_auth_status');
				?>
		<div class="mc-wrap-privacy">
			<input type="checkbox" name="checkbox" value="check" id="mc_iagree" />
			<div class="mc-wrap-desc mc-privacy-message">
				<?php $mc_iagree = (get_option('mc_cls_pp_desc') != '') ? get_option('mc_cls_pp_desc') : '<p>I have read and agree to the website terms and conditions</p>'; ?>
				<?php echo stripslashes($mc_iagree); ?>
				<p class="class-makr-terms-error" style="color: red;display: none;">Please check the above note in order to proceed</p>
			</div>
			<div class="error-message-iagree"></div>
		</div>
	    <input type="hidden" name="master-class-submit-action" value="<?php echo $action; ?>">
	    <div class="mcBtncent">
			<input type="submit" name="submit" value="<?php echo $button_value; ?>" class="mcSquarePayButton" id="mc-reg-button"/>
		</div>
					
		</form>
		<div id="card-errors" style="color: black;border:  1px solid red;padding:  10px;margin-top: 10px; display: none;"></div>
		</div>
			<?php

				$term_details = get_term_by( 'id', $courseid, 'mc-class-category' );
				//print_r($term_details);
            	$price = esc_attr( $selected_term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $selected_term_meta['mc_cat_price_term_meta'] ) : 'FREE';

            	if( $courseid == $bundle_id ){
            		$price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : 'FREE';
            	}
            	$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : '';
            	$currency_arr = explode("-",$currency);

        	?>
			<div class="mcMiscOrderInfo mcRegForm-right-side">

				<div class="mcRegFormLegend"></div>
				<div class="mcOrderSummaryBox">
					<?php
						$checkout_img = get_option('mc_image_on_checkout') ? get_option('mc_image_on_checkout') : 'enable';
						if( $checkout_img == 'enable' )
						{
		      				if( wp_get_attachment_url($selected_term_meta['mc_cat_cover_term_meta']) ){
		      					$img_url = wp_get_attachment_url($selected_term_meta['mc_cat_cover_term_meta']);
		      				}else{
		      					$img_url = MC_IMG.'/image-no.png';
		      				}

		      				if( $courseid == $bundle_id ){
		      					if( get_option('mc_cls_bundle_image') ){
		      						$img_url = wp_get_attachment_url(get_option('mc_cls_bundle_image'));
		      					}else{
		      						$img_url = MC_IMG.'/image-no.png';
		      					}
		      				}


	      			?>

							<img src="<?php echo $img_url; ?>" style="margin-bottom: 5px;">
					<?php
						}
					?>
					<div class="mcLessonh2">
						<?php
							if( $courseid == $bundle_id ){
								echo get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package';
							}else{
								echo $term_details->name;
							}
						?>
					</div>
                	<div class="mcRegRightPriceArea" style="display:inline;">
	                	<?php
	                	if( $price == 'FREE'){
	                		echo $selected_term_meta['mc_cat_price_btn_txt_term_meta'].' '.$price;
	                	}else{
	                		echo $selected_term_meta['mc_cat_price_btn_txt_term_meta'].' '.$currency_arr[1].'<span id="mc_actual_price">'.$price.'</span>';
	                	}?>
	                </div>
				</div>


					<?php
						if( $courseid == $bundle_id ){
							$desc=get_option('mc_cls_bundle_desc_checkout');
							echo (strlen($desc)>0?'<div class="mcOrderSummaryCourseAddtnlDetails">'.$desc.'</div>':'');
						}else{
							if( $selected_term_meta['mc_long_desc_term_meta'] ){
							    $desc=stripslashes($selected_term_meta['mc_long_desc_term_meta']);
								echo (strlen($desc)>0?'<div class="mcOrderSummaryCourseAddtnlDetails">'.$desc.'</div>':'');
							}
						}

					?>

				</div>
			</div>
		</div>
		<script src="https://js.stripe.com/v3/"></script>
		<script type="text/javascript">
			jQuery('#mccourseId').change(function () {
		        var currValue = jQuery(this).find(':selected').attr('data-url');
		        window.location.href = currValue;
		    });


			jQuery(".mcCouponOpenTag").on('click',function(){
				jQuery("#mcCoupon").toggle('slow');
			});

			// jQuery("#mc_coupon_code").on('keypress keyup keydown change',function($){
			// 	var code = jQuery(this).val();

			// 	jQuery(".mcCouponMsg").remove();
			// 	jQuery(".mcCouponInput").after('<div class="mcCouponMsg" style="padding-top: 5px; font-size: 15px; color: #840701f2; font-style: italic;">Coupon validity checking in progress...</div> ');
			// 	var ajaxurl = '<?php //echo admin_url( 'admin-ajax.php' ); ?>';
			// 	var data = {
			//       	action: 'check_mc_coupon_code',
			//       	code: code
			//     };
			//     jQuery.post( ajaxurl, data, function( response ) {
			//     	jQuery(".mcCouponMsg").remove();
			//     	if( response == 'error' ){
			//     		jQuery(".mcCouponInput").after('<div class="mcCouponMsg" style="padding-top: 5px; font-size: 15px; color: red; font-style: italic;">Wrong coupon</div> ');
			//     		jQuery("#mc_coupon_apply").attr("disabled", true);
			//     	}else{

			//     		jQuery(".mcCouponInput").after('<div class="mcCouponMsg" style="padding-top: 5px; font-size: 15px; color: green; font-style: italic;">Valid coupon code, please click Apply Coupon button.</div> ');
			//     		jQuery("#mc_coupon_apply").attr("disabled", false);
			//     	}
			//     });
			// });

			jQuery("#mc_coupon_apply").on('click',function($){
				jQuery(".mcCouponMsg").remove();
				jQuery("#mc_coupon_apply").attr("disabled", true);
				var code = jQuery("#mc_coupon_code").val();
				jQuery(".mcCouponInput").after('<div class="mcCouponMsg" style="padding-top: 5px; font-size: 15px; color: #840701f2; font-style: italic;">Please wait, coupon applying in progress...</div> ');
				var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
				var data = {
			      	action: 'apply_mc_coupon_code',
			      	code: code,
			      	id: jQuery("#mccourseId option:selected").val()
			    };
			    jQuery.post( ajaxurl, data, function( response ) {
			    	jQuery(".mcCouponMsg").remove();
			    	if( response == 'error' ){
			    		jQuery(".mcCouponInput").after('<div class="mcCouponMsg" style="padding-top: 5px; font-size: 15px; color: red; font-style: italic;">Invalid coupon code.</div> ');
			    		jQuery("#mc_coupon_apply").attr("disabled", false);
			    	}else{
			    		var actual_price = jQuery("#mc_actual_price").html();
			    		jQuery("#mcRegForm").append("<input type='hidden' id='mc_applied_coupon_amount' name='mc_applied_coupon_amount' value='"+response+"' />");
			    		jQuery("#mcRegForm").append("<input type='hidden' id='mc_applied_coupon_code' name='mc_applied_coupon_code' value='"+code+"' />");
			    		jQuery("#mcRegForm").append("<input type='hidden' id='mc_actual_price_before_coupon_code' name='mc_actual_price_before_coupon_code' value='"+actual_price+"' />");
			    		if( response == 0){
			    			hidePaymentSystem();
			    		}else{
			    			showPaymentSystem();
			    		}
			    		

			    		var discount_amount = parseInt(actual_price)-parseInt(response);
						jQuery("#mcRegForm").append("<input type='hidden' name='mc_discount_amount' id='mc_discount_amount' value='"+discount_amount+"' />");


			    		var updated_html = '<table id="mcCouponDetailsTable">';
						updated_html +=         '<tr>';
						updated_html +=	            '<td>Subtotal</td>';
						updated_html +=	            '<td><?php echo $currency_arr[1]; ?>'+actual_price+'</td>';
						updated_html +=	         '</tr>';
						updated_html +=	         '<tr>';
						updated_html +=	            '<td>Coupon <b>'+code+'</b><br/><i><a href="javascript:void(0);" id="mc_remove_applied_coupon">[Remove Coupon]</a></i></td>';
						updated_html +=	            '<td><?php echo $currency_arr[1]; ?>'+discount_amount+'</td>';
						updated_html +=	          '</tr>';
						updated_html +=	          '<tr>';
						updated_html +=	            '<td>Total <br/><i>[ <?php echo $selected_term_meta['mc_cat_price_btn_txt_term_meta']; ?> ]</i></td>';
						updated_html +=	            '<td><?php echo $currency_arr[1]; ?>'+response+'</td>';
						updated_html +=	          '</tr>';
						updated_html +=	     '</table>';

						jQuery(".mcRegRightPriceArea").html(updated_html);
			    		jQuery(".mcCouponInput").after('<div class="mcCouponMsg" style="padding-top: 5px; font-size: 15px; color: green; font-style: italic;">Coupon successfully applied.</div> ');
			    		jQuery("#mc_coupon_apply").attr("disabled", true);

			    		jQuery("#mc_remove_applied_coupon").on('click', function(){
			    			showPaymentSystem();
			    			jQuery("#mcCouponDetailsTable").fadeOut('slow');
			    			jQuery("#mcCouponDetailsTable").remove();
			    			var actual_price = jQuery("#mc_actual_price_before_coupon_code").val();
			    			jQuery("#mc_applied_coupon_amount").remove();
			    			jQuery("#mc_applied_coupon_code").remove();
			    			jQuery("#mc_actual_price_before_coupon_code").remove();

			    			var actual_html = '<?php echo $selected_term_meta['mc_cat_price_btn_txt_term_meta'];?> <?php echo $currency_arr[1]; ?><span id="mc_actual_price">'+actual_price+'</span>';

			    			jQuery(".mcRegRightPriceArea").html(actual_html);

			    			jQuery("#mc_coupon_code").val('');
			    			jQuery(".mcCouponMsg").html("Coupon successfully removed.");
			    			jQuery("#mc_coupon_apply").attr("disabled",false);
			    			jQuery("#mc_coupon_code").focus();

			    		});
			    	}
			    });
			    return false;
			});
			function hidePaymentSystem(){
				jQuery(".mcRegFormLegendPaymentInfo").fadeOut('slow');
				jQuery(".mcPaymentMethods").fadeOut('slow');
				jQuery(".mcPaymentMethodsRadio").fadeOut('slow');
				jQuery("#mc-reg-button").val('Get Access');
			}
			function showPaymentSystem(){
				jQuery(".mcRegFormLegendPaymentInfo").fadeIn('slow');
				jQuery(".mc_square_credit_card").fadeIn('slow');
				jQuery(".mcPaymentMethodsRadio").fadeIn('slow');
				jQuery("#mc-reg-button").val('Pay & Get Access');
			}
		</script>

	    <?php
	}
	public static function login_form( $username ){
		
		?>

		<div class="mcLogInForm mcRegLoginDiv" style="display: none;">
			<div class="mcLoginFormTitle">Login</div>
			<div class="mcAlreadyAccount">New User?
				<?php
					if( isset($_GET['classId']) && $_GET['classId'] != '') {

					}
					if( isset($_GET['classId']) && $_GET['classId'] != '') {
			    		$courseid = $_GET['classId'];
			    		$regsiter_url = site_url().'/mc-registration/?classId='.$courseid;
			    		?>
			    		<a href="<?php echo $regsiter_url; ?>">Register & Pay Here.</a>
			    		<?php
			    	}else{
			    		$regsiter_url = site_url().'/mc-registration/';
			    		?>
			    		<a href="<?php echo $regsiter_url; ?>">Register Here.</a>
			    		<?php
			    	}
				?>

			</div>
		    <form id="mcLogInForm" action="" method="post">
			    <div class="mcRegFormLegend">&nbsp;</div>
			    <div class="mcLabelInput">
			    	<input type="text" name="log" id="login-username" value="<?php echo isset( $_POST['username']) ? $username : null; ?>" placeholder="Email Address" required />
			    	<div class="mcLabelInputSpan"></div>
			    	<i class="fas fa-users"></i>
			    </div>

			    <div class="mcLabelInput">
			    	<input type="password" name="pwd" id="login-password" value="" placeholder="Password" required />
			    	<div class="mcLabelInputSpan"></div>
			    	<i class="fas fa-lock"></i>
			    </div>
			    <div class="mcLabelInput mcLabelInputRemember">
			    	<input type="checkbox" name="rememberme" value="forever">
			    	<label for="rememberme">Remember me</label>
			    </div>
			    <div class="mcLabelInput mcLabelInputForgotPass">
			    	<a href="<?php echo site_url().'/mc-login/?forgot=true'; ?>">Forgot Password?</a>
			    </div>
			    <?php
			    	if( isset($_GET['classId']) && $_GET['classId'] != '') {
			    		$courseid = $_GET['classId'];
			    		$redirect_url = site_url().'/mc-login/?classId='.$courseid;
			    		?>
			    		<input type="hidden" name="redirect_to" value="<?php echo $redirect_url; ?>">
			    		<input type="hidden" name="class_id" value="<?php echo $courseid; ?>">
			    		<?php
			    	}else{
			    		?>
			    		<input type="hidden" name="redirect_to" value="<?php echo home_url().'/mc-dashboard'; ?>">
			    		<?php
			    	}

			    ?>
			    <input type="hidden" name="master-class-submit-action" value="_mc_login_user">
				<div class="clearfixMCclass"></div>

				<div class="mcBtncent">
					<input type="submit" name="submit" value="LogIn" id="mc-login-button"/>
				</div>
		    </form>
		</div>
		<script type="text/javascript">
			jQuery("#mc-login-button").on('click',function($){
				var username = $("#login-username").val();
			  	var password = $("#login-password").val();

			 	$("#login-username").removeClass('mc-login-error-exists');
			  	$("#login-password").removeClass('mc-login-error-exists');

				if( !$.trim(username) )
				{
				  	$("#login-username").focus();
				  	$("#login-username").addClass('mc-login-error-exists');
				  	return false;
				}

			  	if( !$.trim(password) ){
			      	$("#login-password").focus();
			      	$("#login-password").addClass('mc-login-error-exists');
			      	return false;
			  	}
			});
		</script>
		<?php
	}

	public static function forgot_password_form(){
		?>
		<div class="mcForgotPasswordForm" style="display: none;">
			<div class="mcLoginFormTitle">Forgot Password</div>
			<form id="mcForgotPassForm" action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
				<div class="mcLabelInput">
					<input type="text" placeholder="Enter your registered email address" id="mc-forgot-pass-email" name="email" value="<?php echo isset( $_POST['email']) ? $email : null; ?>">
					<div class="mcLabelInputSpan"></div>
					<i class="fas fa-users"></i>
				</div>
				<input type="hidden" name="master-class-submit-action" value="_mc_forgot_password_user">
			    <input type="submit" name="submit" value="Submit" id="mc-forgot-pass-submit"/>
			    <a class="mcBackToLogin" href="<?php echo site_url().'/mc-login/?login=success'; ?>">Back To Login</a>
			</form>
		</div>
		<script type="text/javascript">
			jQuery("#mc-forgot-pass-submit").on('click',function($){
				var eml = $("#mc-forgot-pass-email").val();

				$("#mc-forgot-pass-email").removeClass('mc-reg-error-exists');

				var emailReg = /^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i;

			    if(!emailReg.test( eml ))
			    {
			        $("#mc-forgot-pass-email").focus();
			        $("#mc-forgot-pass-email").addClass('error-exists');
			        return false;
			    }

			});
		</script>
		<?php
	}

	public static function reset_password_form( $email ){

		?>
		<div class="mcResetPasswordForm" style="display: none;">
			<div class="mcLoginFormTitle">Reset Password</div>
			<form id="mcResetPasswordForm" action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
				<div class="mcLabelInput">
					<input type="password" placeholder="Password" id="mc-reset-password" name="password" value="">
					<div class="mcLabelInputSpan"></div>
					<i class="fas fa-lock"></i>
				</div>
				<div class="mcLabelInput">
					<input type="password" placeholder="Confirm Password" id="mc-reset-conf-password" name="conf-password" value="">
					<div class="mcLabelInputSpan"></div>
					<i class="fas fa-lock"></i>
				</div>
				<input type="hidden" name="master-class-submit-action" value="_mc_reset_password_user">
				<input type="hidden" name="reset-email-address" value="<?php echo $email; ?>">
			    <input type="submit" name="submit" value="Reset" id="mc-reset-pass-submit"/>
			</form>
		</div>
		<script type="text/javascript">
			jQuery("#mc-reset-pass-submit").on('click',function($){
			  	var password = $("#mc-reset-password").val();
			  	var conf_password = $("#mc-reset-conf-password").val();

			  	$("#mc-reset-password").removeClass('mc-reg-error-exists');
			  	$("#mc-reset-conf-password").removeClass('mc-reg-error-exists');

			  	if( !$.trim(password) ){
			      	$("#mc-reset-password").focus();
			      	$("#mc-reset-password").addClass('mc-reg-error-exists');
			      	return false;
			  	}

			  	if(password.length < 6)
			    {
			        $("#mc-reset-password").focus();
			      	$("#mc-reset-password").addClass('mc-reg-error-exists');
			      	return false;
			    }

			  	if( !$.trim(conf_password) ){
			      	$("#mc-reset-conf-password").focus();
			      	$("#mc-reset-conf-password").addClass('mc-reg-error-exists');
			      	return false;
			  	}
			  	console.log($.trim(conf_password));
			  	console.log($.trim(password));

			  	if( $.trim(conf_password) != $.trim(password) ){
			      	$("#mc-reset-conf-password").focus();
			      	$("#mc-reset-conf-password").addClass('mc-reg-error-exists');

			      	$("#mc-reset-password").focus();
			      	$("#mc-reset-password").addClass('mc-reg-error-exists');
			      	return false;
			  	}


			});
		</script>
		<?php
	}

	public static function process_paypal_standard_payment( $return_url ){

		$mode = get_option('mc_cls_paypal_standard_mode') ? get_option('mc_cls_paypal_standard_mode') : 'sandbox';

		if( $mode == 'sandbox' ){
			$paypalUrl = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
		}else{
			$paypalUrl = 'https://www.paypal.com/cgi-bin/webscr';
		}

		$seller_email = get_option('mc_cls_paypal_standard_email');

		$paypalConfig = [
			'email' => $seller_email,
			'return_url' => $return_url,
			'cancel_url' => site_url(). '/mc-login/?payment=false',
			'notify_url' => site_url()
		];

		$courseid = $_POST['courseId'];

		$bundle_id = get_option( '_mc_class_bundle_id' );

    	if( $courseid == $bundle_id ){
    		$price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
    	}else{
    		$term_meta = get_option( "taxonomy_$courseid" );
			$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
    	}

		global $wpdb;
        $results = $wpdb->get_results(
                    $wpdb->prepare("SELECT name FROM {$wpdb->prefix}terms WHERE term_id=%d", $courseid)
                 );


		$coupon_code = '';
		$actual_price = '';
		$dis_amount = '';
		if( isset($_POST['mc_applied_coupon_amount']) ){
			$price 			= $_POST['mc_applied_coupon_amount'];
			$coupon_code 	= $_POST['mc_applied_coupon_code'];
			$actual_price	= $_POST['mc_actual_price_before_coupon_code'];
			$dis_amount		= $_POST['mc_discount_amount'];
		}

		$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
        $currency_arr = explode( "-", $mc_cls_currency);
        $currency = strtoupper($currency_arr[0]);



        if(!is_user_logged_in() || !$_POST['_mc_user_logged_in_id']){

	        global $reg_errors;
			$reg_errors = new WP_Error;

			if ( email_exists( $_POST['email'] ) ) {
			    $reg_errors->add( 'email', 'Email Already in use' );
			    return;
			}

			$username   =   sanitize_user( $_POST['email'] );
			$password   =   esc_attr( $_POST['password'] );
			$email      =   sanitize_email( $_POST['email'] );
			$first_name =   sanitize_text_field( $_POST['fname'] );


			$user_id = MC_Login_Register_Controller::complete_registration_with_paypal_standard(
				$username,
				$password,
				$email,
				$first_name
			);

        }else{
        	$user_id = $_POST['_mc_user_logged_in_id'];
        }

        if( !$user_id){
        	return;
        }

        $user_info = get_userdata( $user_id );

        $custom_arr = [];
        $custom_arr['user_id'] = $user_id;
        $custom_arr['user_email'] = $user_info->user_email;
        $custom_arr['user_name'] = $user_info->display_name;
        $custom_arr['coupon_code'] 	= $coupon_code;
		$custom_arr['actual_price'] 	= $actual_price;
		$custom_arr['discount_amount'] 	= $dis_amount;


		$data = [];

		$data['business'] = $paypalConfig['email'];

		$data['return'] = stripslashes($paypalConfig['return_url']);
		$data['cancel_return'] = stripslashes($paypalConfig['cancel_url']);
		$data['notify_url'] = stripslashes($paypalConfig['notify_url']);

		$data['item_name'] = $results[0]->name;
		$data['amount'] = $price;
		$data['currency_code'] = $currency;
		$data['cmd'] = '_xclick';
		$data['no_note'] = '1';
		$data['lc'] = 'UK';
		$data['bn'] = 'PP-BuyNowBF:btn_buynow_LG.gif:NonHostedGuest';
		$data['first_name'] 	= $user_info->first_name;
		$data['last_name'] 		= $user_info->last_name;
		$data['payer_email'] 	= $user_info->user_email;
		$data['item_number'] 	= $courseid;
		$data['custom']      	= json_encode($custom_arr);

		$queryString = http_build_query($data);

		header('location:' . $paypalUrl . '?' . $queryString);
		exit();
	}

	public static function save_paypal_standard_payment_data($user_id, $user_name, $user_email, $charge_id='',$tran_id='',$course_name, $course_id, $course_amount,$currency,$coupon_code,$actual_price,$dis_amount,$payment_through=''){
		$post_data = array(
		    'post_title' => 'Class Makr Payment @'.date('l, F d y h:i:s'),
		    'post_name' => 'master-class-payment-'.date('y-m-d-h-m-s'),
		    'post_type' => 'mc_class_payment',
		    'post_status' => 'publish'
		);
		$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
		$post_id = wp_insert_post( $post_data );
		update_post_meta( $post_id, '_mc_pay_user_id', $user_id );
		update_post_meta( $post_id, '_mc_pay_total_amount', $course_amount );
		update_post_meta( $post_id, '_mc_pay_currency', $currency );
		update_post_meta( $post_id, '_mc_pay_course_id', $course_id );
		update_post_meta( $post_id, '_mc_pay_charge_id', $charge_id );
		update_post_meta( $post_id, '_mc_pay_tran_id', $tran_id );
		update_post_meta( $post_id, '_mc_pay_coupon_code', $coupon_code );
		update_post_meta( $post_id, '_mc_pay_actual_price', $actual_price );
		update_post_meta( $post_id, '_mc_pay_discount_amount', $dis_amount );	
		update_post_meta( $post_id, '_mc_pay_through', $payment_through );

		$sys_tran_id = str_replace(' ', '-', strtolower(str_replace(" ", "", $payment_through))).strtotime("now").rand().$post_id;
		update_post_meta( $post_id, '_mc_pay_system_tran_id', $sys_tran_id );

		$admin_email = get_option('admin_email');
        $to = $user_email;



        //$body = 'Hi '.$user_name.', <br/>You successfully subscribed <b>'.$course_name.'</b><br/>Please <a href="'.site_url().'/mc-login/?login=success">login to your account</a> and access your all subscribed classes from "My Courses" section. <br/><br/>Thanks';
        $body = (get_option( 'mc_eml_cust_body_three' )) ? get_option( 'mc_eml_cust_body_three' ) : 'Hi [DISPLAYNAME],<br/>You successfully subscribed <b>[CLASSNAME].</b><br/><p>Kindly <a href="[LOGINURL]">LogIn</a> to your account and access all classes.</p><p>Note that your classes are within the "My Courses" section.</p><br/><br/>Thanks,<br/>Class Makr.';

        $mc_cls_currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
	   	$currency_arr 	 = explode( "-", $mc_cls_currency);
        $currency 		 = strtoupper($currency_arr[0]);

        $receipt = '';
        $receipt .= '<b>Payment Details</b>';
		$receipt .= '<ul>';
		$receipt .= '<li><i>Date:</i>&nbsp;&nbsp;&nbsp; '.get_the_date( "l F j, Y, @ h:m:s", $post_id ).'</li>';
		$receipt .= '<li><i>Payment Through:</i>&nbsp;&nbsp;&nbsp; '.get_post_meta($post_id, "_mc_pay_through", true ).'</li>';
		$receipt .= '<li><i>Transacion ID:</i>&nbsp;&nbsp;&nbsp;'.get_post_meta( $post_id, "_mc_pay_system_tran_id", true ).'</li>';

		if( get_post_meta( $post_id, '_mc_pay_coupon_code', true ) != '' ){
			$receipt .= '<li><i>Coupon Code:</i>&nbsp;&nbsp;&nbsp;'.get_post_meta( $post_id, "_mc_pay_coupon_code", true).'</li>'; 
			$receipt .= '<li><i>Subtotal:</i>&nbsp;&nbsp;&nbsp;'.$currency_arr[1].''.get_post_meta( $post_id, "_mc_pay_actual_price", true ).' '.$currency.'</li>';
			$receipt .= '<li><i>Coupon Amount:</i>&nbsp;&nbsp;&nbsp;'.$currency_arr[1].''.get_post_meta( $post_id, "_mc_pay_discount_amount", true ).' '.$currency.'</li>';
		}
		
		$receipt .=	'<li><i>Amount:</i>&nbsp;&nbsp;&nbsp;';
		if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
            $receipt .= $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
        }else{
            $receipt .= $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true );
        }
		$receipt .= ' '.$currency.'</li>';

		$receipt .=		'</ul>';

        if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
            $amt = $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
        }else{
            $amt = $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true );
        }
        $paidWith=get_post_meta($post_id, "_mc_pay_through", true );
		$date=get_the_date( "l F j, Y, @ h:m:s", $post_id );

	   	$body = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$body);
		$body = str_replace('[USERNAME]',$user_name,$body);
		$body = str_replace('[CLASSNAME]',$course_name,$body);
		$body = str_replace('[USEREMAIL]',$user_email,$body);
		$body = str_replace('[DISPLAYNAME]',$user_name,$body);
		$body = str_replace('[PAYRECEIPT]',$receipt,$body);
        $body = str_replace('[AMOUNT]',$amt,$body);
		$body = str_replace('[PAIDWITH]',$paidWith,$body);
		$body = str_replace('[DATE]',$date,$body);
		$body = str_replace('[INVOICELINK]',home_url().'/mc-dashboard/',$body);
		$body = str_replace('[SITEURL]',get_site_url(),$body);
		$body = str_replace('[DOMAIN]',$_SERVER['SERVER_NAME'],$body);
        
		$body = MC_Email_Template_Controller::general_email_template($body);

		$subject = (get_option( 'mc_eml_cust_sub_three' )) ? get_option( 'mc_eml_cust_sub_three' ) : 'Subscribed Class: [CLASSNAME]';
		$subject = str_replace('[USERNAME]',$user_name,$subject);
		$subject = str_replace('[CLASSNAME]',$course_name,$subject);
		$subject = str_replace('[USEREMAIL]',$user_email,$subject);
		$subject = str_replace('[DISPLAYNAME]',$user_name,$subject);

		$headers = "MIME-Version: 1.0" . "\r\n";
		$headers .= "Content-type:text/html;charset=UTF-8";

		wp_mail( $to, $subject, $body, $headers );

        
        $default='Hi Admin,';
        $default.='<br>Congratulations! A new person has signed up for your class.';
        $default.='<br><strong>Customer name:</strong> [DISPLAYNAME]';
        $default.='<br><strong>Email:</strong> [USEREMAIL]';
        $default.='<br><strong>Class name:</strong> [CLASSNAME]';
        $default.='<br><strong>Amount paid:</strong> [AMOUNT]';
        $default.='<br><strong>Paid with:</strong> [PAIDWITH]';
        $default.='<br>Date [DATE]';
                    
        $default.='<br>Click <a href="[INVOICELINK]">here</a> to see the customer’s details. ';
        $default.='<br><a href="[SITEURL]">[DOMAIN]</a>';
        
        

		$body2 = (get_option( 'mc_eml_cust_body_seven' )) ? get_option( 'mc_eml_cust_body_seven' ) : $default;
		$body2 = str_replace('[USERNAME]',$user_name,$body2);
		$body2 = str_replace('[CLASSNAME]',$course_name,$body2);
		$body2 = str_replace('[USEREMAIL]',$user_email,$body2);
		$body2 = str_replace('[DISPLAYNAME]',$user_name,$body2);
		$body2 = str_replace('[PAYRECEIPT]',$receipt,$body2);
		$body2 = str_replace('[AMOUNT]',$amt,$body2);
		$body2 = str_replace('[PAIDWITH]',$paidWith,$body2);
		$body2 = str_replace('[DATE]',$date,$body2);
		$body2 = str_replace('[INVOICELINK]',get_admin_url().'post.php?post='.$post_id.'&action=edit',$body2);
		$body2 = str_replace('[SITEURL]',get_site_url(),$body2);
		$body2 = str_replace('[DOMAIN]',$_SERVER['SERVER_NAME'],$body2);
		
		

		$body2 = MC_Email_Template_Controller::general_email_template($body2);

		//$subject2 = $course_name.' is subscribed by '.$user_name;

		$subject2 = (get_option( 'mc_eml_cust_sub_seven' )) ? get_option( 'mc_eml_cust_sub_seven' ) : 'Class Makr Subscription Notification';
		$subject2 = str_replace('[USERNAME]',$user_name,$subject2);
		$subject2 = str_replace('[CLASSNAME]',$course_name,$subject2);
		$subject2 = str_replace('[USEREMAIL]',$user_email,$subject2);
		$subject2 = str_replace('[DISPLAYNAME]',$user_name,$subject2);

		$headers2 = "MIME-Version: 1.0" . "\r\n";
		$headers2 .= 'Content-Type: text/html; charset=UTF-8';

		wp_mail( $admin_email, $subject2, $body2, $headers2 );
	}
	public static function complete_registration_with_paypal_standard( $username, $password, $email, $first_name ) {

        $userdata = array(
	        'user_login'    =>   $username,
	        'user_email'    =>   $email,
	        'user_pass'     =>   $password,
	        'first_name'    =>   $first_name,
	        'role'			=>   'mc_learner'
        );
        $user_id = wp_insert_user( $userdata );
        if( !is_wp_error( $user_id ) )
		{
			$add_to_email_campaign = Master_Email_API_Controller::save_to_campaign($email,$first_name);
			$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

			$input = $user_id.''.$email.substr(str_shuffle($chars),0,100);
			$code = strtr(base64_encode($input), '+/=@#$%^', '-_,');

			update_user_meta( $user_id, 'mc_is_learner_active', 'no');
			update_user_meta ( $user_id, 'mc_learner_activation_code', $input );

			$body_value = '';

			$body_value = (get_option( 'mc_eml_cust_body_four' )) ? get_option( 'mc_eml_cust_body_four' ) : 'Hi [DISPLAYNAME],<br/><p>Kindly active your account by clicking below link,<br/><b><u><a href="[ACTURL]">Activate Account</a></u></b></p><br/>Thanks,<br/>Class Makr.';

			$body_value = str_replace('[ACTURL]',site_url().'/mc-login/?servicename=activateuser&digest='.$code,$body_value);
			$body_value = str_replace('[USERNAME]',$email,$body_value);
			$body_value = str_replace('[USEREMAIL]',$email,$body_value);
			$body_value = str_replace('[DISPLAYNAME]',$first_name,$body_value);

			$to = $email;

			$subject = (get_option( 'mc_eml_cust_sub_four' )) ? get_option( 'mc_eml_cust_sub_four' ) : 'Class Makr Account Activation';

			$subject = str_replace('[USERNAME]',$email,$subject);
			$subject = str_replace('[USEREMAIL]',$email,$subject);
			$subject = str_replace('[DISPLAYNAME]',$first_name,$subject);

			$headers = array('Content-Type: text/html; charset=UTF-8');

			$body = MC_Email_Template_Controller::general_email_template($body_value);

			wp_mail( $to, $subject, $body, $headers );
			return $user_id;
		}else{
			return false;
		}
	}
}
