<?php
class Master_Metabox_Controller
{
	
	public function __construct()
	{
		add_action( 'add_meta_boxes', array($this,'add_metaboxes') );
		add_action( 'save_post', array($this, 'save_meatdata'));
		add_action( 'mc-class-category_add_form_fields', array($this,'metabox_taxonomy_add'), 10, 2 );
		add_action( 'mc-class-category_edit_form_fields', array($this,'metabox_taxonomy_edit'), 10, 2 );
		add_action( 'edited_mc-class-category', array($this,'save_tax_metabox'), 10, 2 );  
		add_action( 'create_mc-class-category', array($this,'save_tax_metabox'), 10, 2 );
        add_action( 'admin_head', array($this,'remove_default_category_description'));
        add_action( 'pre_insert_term',[$this,'block_class'],0,2);
        add_action('admin_footer',[$this,'scrollToTopClasstaxonomyArea']);
	}
    public function block_class( $term, $taxonomy )
    {
        $count=wp_count_terms($taxonomy);
        return ( 'mc-class-category' === $taxonomy && $count>=1)
        ? new WP_Error( 'term_addition_blocked', __( '<img src="'.MC_IMG.'/icon_lock.png" alt="master-class" style="float:left;padding: 2px;width :30px;"> <span class="master-class-notice"> &nbsp; TO ADD UNLIMITED CLASSES YOU WILL NEED TO GET THE <a href="https://classmakr.com/" target="_blank">pro version</a>.</span>') )
        : $term;
    }
    public function scrollToTopClasstaxonomyArea()
    {
        global $pagenow;
        if($pagenow==='edit-tags.php' && isset($_GET) && isset($_GET['taxonomy']) && $_GET['taxonomy']=='mc-class-category')
        {
            ?>
            <style>
                #ajax-response .error{display: flex;}
                #ajax-response .error p{display: block;width: 100%;}
                .master-class-notice{margin-top: 8px;display: block;text-transform: uppercase;font-weight: 600;}
            </style>
            <script>
                jQuery(function($){
                    $("#submit").click(function(){
                        $('html, body').animate({
                            scrollTop: $(".wp-heading-inline").offset().top
                        }, 2000);
                    });
                });
            </script>
            <?php
        }
    }
   

    
    public static function remove_default_category_description()
    {
        global $current_screen;
        if ( $current_screen->id == 'edit-mc-class-category' )
        {
        ?>
            <script type="text/javascript">
            jQuery(function($) {
                $('textarea#description').closest('tr.form-field').remove();
                $('textarea#tag-description').closest('div.form-field').remove();
                $(".wp-list-table thead").find("th#description").remove();
                $(".wp-list-table tfoot").find("th.column-description").remove();
                $(".wp-list-table tbody").find("td.description").remove();
            });
            </script>
        <?php
        }
    }

	public static function add_metaboxes(){
		// add_meta_box(
	 //        'mc-class-price-metabox',
	 //        __( 'Price', 'mc-lan' ),
	 //        array('Master_Metabox_Controller', 'price_html'),
	 //        'mc-class',
	 //        'side'
	 //    );

	    add_meta_box(
	        'mc-class-upload-metabox',
	        __( 'Upload Supportive Documents', 'mc-lan' ),
	        array('Master_Metabox_Controller', 'upload_documents_html'),
	        'mc-class',
	        'normal'
	    );

        add_meta_box(
            'mc-class-mcq-metabox',
            __( 'MCQ(Multiple Choice Question)', 'mc-lan' ),
            array('Master_Metabox_Controller', 'mcq_html'),
            'mc-class',
            'normal'
        );

        add_meta_box(
            'mc-class-video-metabox',
            __( 'Tutorial Video', 'mc-lan' ),
            array('Master_Metabox_Controller', 'tutorial_video_html'),
            'mc-class',
            'normal',
            'high'
        );

        add_meta_box(
            'mc-class-mcq-metabox',
            __( 'MCQ(Multiple Choice Question)', 'mc-lan' ),
            array('Master_Metabox_Controller', 'mcq_html'),
            'mc-class',
            'normal'
        );


	    // add_meta_box(
	    //     'mc-class-custom-settings-metabox',
	    //     __( 'Custom Settings', 'mc-lan' ),
	    //     array('Master_Metabox_Controller', 'custom_settings_html'),
	    //     'mc-class',
	    //     'side'
	    // );

        add_meta_box(
            'mc-class-payment-record-data',
            __( 'Records Data', 'mc-lan' ),
            array('Master_Metabox_Controller', 'payments_record_data'),
            'mc_class_payment',
            'normal'
        );

        add_meta_box(
            'mc-class-coupon-data',
            __( 'Coupon Details', 'mc-lan' ),
            array('Master_Metabox_Controller', 'coupon_data'),
            'mc_class_coupon',
            'normal'
        );
	}
    public static function tutorial_video_html(){
        $vid_type = get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_type',true) ? get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_type',true) : 'youtube';
       $scheduleType=get_post_meta(get_the_ID(),'_schedule_live_video_class_makr',true) ? get_post_meta(get_the_ID(),'_schedule_live_video_class_makr',true) : '';
       $scheduleTime=get_post_meta(get_the_ID(),'_schedule_live_video_class_makr_time')? get_post_meta(get_the_ID(),'_schedule_live_video_class_makr_time',true) : '';
       $liveStatus=Common_Functions_Controller::lessonLiveStatus( get_the_ID() );
                ?>
                <p></p><b><label>Video Type</label></b>
                <select name="_mc_lesson_tutorial_video_type" id="_mc_lesson_tutorial_video_type">
                    <optgroup label="3rd-Party Hosted">
                        <option value='whistia' <?php if($vid_type=='whistia'){echo 'selected=selected';} ?> ><?php _e('Whistia'); ?></option>
                        <option value='youtube' <?php if($vid_type=='youtube'){echo 'selected=selected';} ?> ><?php _e('YouTube'); ?></option>
                        <option value='youtube-live' <?php if($vid_type=='youtube-live'){echo 'selected=selected';} ?> ><?php _e('Live Youtube Stream'); ?></option>
                        <option value='vimeo' <?php if($vid_type=='vimeo'){echo 'selected=selected';} ?>><?php _e('Vimeo'); ?></option>
                    </optgroup>
                    <optgroup label="Self Hosted">
                        <option value='dropbox' <?php if($vid_type=='dropbox'){echo 'selected=selected';} ?>><?php _e('Dropbox'); ?></option>
                        <option value='googledrive' <?php if($vid_type=='googledrive'){echo 'selected=selected';} ?>><?php _e('Google Drive'); ?></option>
                        <option value='amazons3' <?php if($vid_type=='amazons3'){echo 'selected=selected';} ?>><?php _e('Amazon S3'); ?></option>
                        <option value='wpmedia' <?php if($vid_type=='wpmedia'){echo 'selected=selected';} ?>><?php _e('Wordpress Media Library'); ?></option>
                    </optgroup>
                </select>
                <div class="class-makr-schedule-live" style="<?php echo ($vid_type=='youtube-live'?'display:block;':'display:none;')?>">
                    <p></p><b><label>Schedule Live Video</label></b>&nbsp; 
                    <span style="padding:5px;">( <?php echo ($liveStatus=='active'?'On-Air':'Off Air')?> <span class="dashicons dashicons-cloud" style="<?php echo ($liveStatus=='active'?'color:green;':'color:red;')?>"></span> )</span>
                    <?php if($liveStatus=='active'):?><span><a href="#" class="class-makr-stop-live" style="font-size: 15px;font-weight: 500;color: red;">Go Off-Air Now</a></span><?php endif;?>
                    <fieldset>
					<legend class="screen-reader-text">New registrations settings</legend>
					<div id="class-makr-radiocb" onclick="classmakrcbclick(event)">
					<label><input name="_schedule_live_video_class_makr" type="checkbox" id="_schedule_live_video_class_makr_live_now" value="live-now" <?php checked($scheduleType,'live-now')?>> Go Live Now</label><br>
					<label><input name="_schedule_live_video_class_makr" type="checkbox" id="_schedule_live_video_class_makr_schedule" value="schedule-live" <?php checked($scheduleType,'schedule-live')?>> Schedule For Later</label><br>
					</div>
					<span id="timestamp-class-makr">
                        <?php _e( "Schedule:" ); ?> <b><?php echo($scheduleType=='schedule-live' && !empty($scheduleTime)?date('m-M d, Y @ H:i', $scheduleTime):'Now.');?></b>&nbsp; 
                    </span>
					</fieldset>
					<div class="class-makr-schedule-control" style="<?php echo ($scheduleType=='schedule-live'?'display:none;':'display:none;')?>">
					    <div id="timestampdiv">
                            <div class="timestamp-wrap">
                                <?php
                                global $wp_locale;

                                if(!empty($scheduleTime))
                                $time_adj=(!empty($scheduleTime)?$scheduleTime:current_time('timestamp'));
                                $cur_jj = gmdate( 'd', $time_adj );
                                $cur_mm = gmdate( 'm', $time_adj );
                                $cur_aa = gmdate( 'Y', $time_adj );
                                $cur_hh = gmdate( 'H', $time_adj );
                                $cur_mn = gmdate( 'i', $time_adj );

                                $month = "";
                                for ( $i = 1; $i < 13; $i = $i +1 ) {
                                    $monthnum = zeroise($i, 2);
                                    $month .= "\t\t\t" . '<option value="' . $monthnum . '"';
                                    if ( $i == $cur_mm )
                                        $month .= ' selected="selected"';
                                    /* translators: 1: month number (01, 02, etc.), 2: month abbreviation */
                                    $month .= '>' . sprintf( __( '%1$s-%2$s' ), $monthnum, $wp_locale->get_month_abbrev( $wp_locale->get_month( $i ) ) ) . "</option>\n";
                                }
                                ?>
                                <select id="class-mm" name="_class_makr_mm">
                                    <?php echo $month; ?>
                                </select>
                                <input type="number" id="class-jj" name="_class_makr_jj" value="<?php echo $cur_jj; ?>" size="2" maxlength="2" autocomplete="off" max="31" min="1" style="width:4em;">,
                                <input type="number" id="class-aa" name="_class_makr_aa" value="<?php echo $cur_aa; ?>" size="4" maxlength="4" autocomplete="off" min="<?php echo $cur_aa; ?>" style="width:5.4em;"> @
                                <input type="number" id="class-hh" name="_class_makr_hh" value="<?php echo $cur_hh; ?>" size="2" maxlength="2" autocomplete="off" max="24" min="0" style="width:4em;"> :
                                <input type="number" id="class-mn" name="_class_makr_mn" value="<?php echo $cur_mn; ?>" size="2" maxlength="2" autocomplete="off" max="60" min="0" style="width:4em;">
                            </div>
                            <p>
                                <a href="#edit_timestamp" class="class-makr-save-timestamp button"><?php _e( "Set", 'email-newsletter' ); ?></a>
                                <a href="#edit_timestamp" class="class-makr-cancel-timestamp"><?php _e( "Cancel/Unset", 'email-newsletter' ); ?></a>
                            </p>
                        </div>
					</div>
                </div>
                <p></p><b><label>Video URL</label></b>
                <input type="text" name="_mc_lesson_tutorial_video_url" id="_mc_lesson_tutorial_video_url" value="<?php echo get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_url',true); ?>" placeholder="Put video URL here"/>
                <script>
                    function classmakrcbclick(e){
                       e = e || event;
                       var cb = e.srcElement || e.target;
                       if (cb.type !== 'checkbox') {return true;}
                       var cbxs = document.getElementById('class-makr-radiocb').getElementsByTagName('input'), i=cbxs.length;
                        while(i--) {
                            if (cbxs[i].type && cbxs[i].type == 'checkbox' && cbxs[i].id !== cb.id) {
                             cbxs[i].checked = false;
                            }
                        }
                    }
                    jQuery(function($){
                        $("#_mc_lesson_tutorial_video_type").on("change",function(){
                            var val=$("#_mc_lesson_tutorial_video_type option:selected").val();
                            if(val=='youtube-live')
                            {
                                $(".class-makr-schedule-live").fadeIn();
                            }
                            else
                            {
                                $(".class-makr-schedule-live").fadeOut();
                            }
                        });
                        $("input[name='_schedule_live_video_class_makr']").on("change",function(){
                            var val=$("input[name='_schedule_live_video_class_makr']:checked").val();
                            if(val=="schedule-live")
                            {
                                $(".class-makr-schedule-control").fadeIn();
                            }
                            else
                            {
                                jQuery('#timestamp-class-makr b').html('Now.');
                                $(".class-makr-schedule-control").fadeOut();
                            }
                        });
                        jQuery('.class-makr-cancel-timestamp').click(function(e) {
                            e.preventDefault();
                            $(".class-makr-schedule-control").fadeOut();
                            $("input[name='_schedule_live_video_class_makr']").prop('checked', false); 
                            jQuery('#timestamp-class-makr b').html('Now.');
                            return false;
                        });
                        jQuery('.class-makr-save-timestamp').click(function (e) {
                            e.preventDefault();
                            var aa = jQuery('#class-aa').val();
                            var mm = jQuery('#class-mm').val();
                            var jj = jQuery('#class-jj').val();
                            var hh = jQuery('#class-hh').val();
                            var mn = jQuery('#class-mn').val();
                    
                            jQuery('#timestamp-class-makr b').html(
                                jQuery('option[value="' + jQuery('#class-mm').val() + '"]', '#class-mm').text() + ' ' +
                                jj + ', ' +
                                aa + ' @ ' +
                                hh + ':' +
                                mn
                            );
                             $(".class-makr-schedule-control").fadeOut();
                            
                            return false;
                        });
                        jQuery(".class-makr-stop-live").click(function(e){
                            e.preventDefault();
                            $("input[name='_schedule_live_video_class_makr']").prop('checked', false); 
                            $("#post").submit();
                        });
                    });
                </script>
                <p></p><b><label>Featured Video Thumb Image</label></b>
            <?php 
                $img_type = get_post_meta( get_the_ID(), '_mc_lesson_vid_thumb_image_type_term_meta', true ) ? get_post_meta( get_the_ID(), '_mc_lesson_vid_thumb_image_type_term_meta', true ) : 'default';
            ?>
                <select name="_mc_lesson_vid_thumb_image_type_term_meta" id="_mc_lesson_vid_thumb_image_type_term_meta">
                    <option value="default" <?php if($img_type=='default'){ echo "selected=selected"; } ?>>System Default Image</option>
                    <option value="new" <?php if($img_type=='new'){ echo "selected=selected"; } ?>>Upload New Image</option>
                </select>
                
                <span id="_mc_lesson_vid_thumb_image_term_meta_new">
                <?php
                    if($img_type=='new'){
                ?>
                    <br /><br />
                    <a href=<?php echo wp_get_attachment_url(get_post_meta(get_the_ID(),'_mc_lesson_vid_thumb_image_term_meta',true)); ?> download><?php echo get_the_title(get_post_meta(get_the_ID(),'_mc_lesson_vid_thumb_image_term_meta',true)); ?> </a>
                    <span class="dashicons dashicons-dismiss delete-video-feat-image-lesson" style="color: red;cursor: pointer;display: inline-block;text-decoration: none;"></span>
                <?php
                    }
                ?>
                </span>
                <input type="hidden" name="_mc_lesson_vid_thumb_image_term_meta" id="_mc_lesson_vid_thumb_image_term_meta" value="<?php echo get_post_meta(get_the_ID(),'_mc_lesson_vid_thumb_image_term_meta',true); ?>" />
                <?php
    }
    public static function mcq_html(){
        require 'gradation/metabox-mcq.php';
        Master_Metabox_MCQ_Controller::mcq_html();
    }

	public static function upload_documents_html(){
		?>
		<div id="document_list">
			<?php 
				$documents = get_post_meta(get_the_ID(),'_mc_documents',true); 
				
				if(is_array($documents)){
					foreach($documents as $doc_id){
						?>
						<p>
							<span class="dashicons dashicons-dismiss delete-documents"></span>&nbsp;&nbsp;&nbsp;
							<a href=<?php echo wp_get_attachment_url($doc_id); ?> download><?php echo get_the_title($doc_id); ?></a>
							<input type="hidden" name="mc_documents[]" value="<?php echo $doc_id; ?>" />
						</p>
						<br/>
						<?php
					}
				}
			?>
		</div>
		<a href="javascript:void(0);" id="upload_new_documents" class="button button-primary button-large btn-position">Upload New Documents</a>
		<?php
	}

	public static function metabox_taxonomy_add(){
		?>
            <div class="form-field">
                
                <label for="term_meta[mc_grad_term_meta]"><?php _e( 'Gradation Type', 'mc-lan' ); ?></label>
                <?php
            		$grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
            	?>
            	<select name="term_meta[mc_grad_term_meta]" id="term_meta[mc_grad_term_meta]">
            		<option value="none" <?php if( $grad == 'none' ){ echo 'selected=selected'; } ?>>None</option>
            		<option value="mcq" <?php if( $grad == 'mcq' ){ echo 'selected=selected'; } ?>>Multiple Choice Question (MCQ)</option>
            		<option value="confident" <?php if( $grad == 'confident' ){ echo 'selected=selected'; } ?>>Confident Score (Checkbox)</option>
                    <option value="checkmark" <?php if( $grad == 'checkmark' ){ echo 'selected=selected'; } ?>>Checkmark</option>
            	</select>
                
                <p class="description"><?php _e( '<p><b>Note:</b> To use the "Multiple Choice Question" option you need to make sure to the questions and answers within your Lesson pages.</p>','mc-lan' ); ?></p>

                <label for="term_meta[mc_cat_cover_term_meta]"><?php _e( 'Featured Image', 'mc-lan' ); ?></label>
                <a href="javascript:void(0);" id="mc-class-upload-button" class="button button-secondary">Upload</a>
                <span id="mc-cat-display"></span>
                <input type="hidden" name="term_meta[mc_cat_cover_term_meta]" id="term_meta_mc_cat_cover_term_meta" />
                <p class="description"><?php _e( 'This is the image that will show up within your website within the category listing area..</p>','mc-lan' ); ?></p>

                <label for="term_meta[mc_cat_vid_type_term_meta]"><?php _e( 'Sells Video Type', 'mc-lan' ); ?></label>
                <?php
            		$vid_type = esc_attr( $term_meta['mc_cat_vid_type_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_type_term_meta'] ) : 'youtube';
            	?>
                <select name="term_meta[mc_cat_vid_type_term_meta]" id="term_meta[mc_cat_vid_type_term_meta]" class="class-makr-video-choice">
                    <optgroup label="3rd-Party Hosted">
                        <option value='whistia'><?php _e('Whistia'); ?></option>
                        <option value='youtube'><?php _e('YouTube'); ?></option>
                        <option value='vimeo'><?php _e('Vimeo'); ?></option>
                    </optgroup>
                    <optgroup label="Self Hosted">
                        <option value='dropbox'><?php _e('Dropbox'); ?></option>
                        <option value='googledrive'><?php _e('Google Drive'); ?></option>
                        <option value='amazons3'><?php _e('Amazon S3'); ?></option>
                        <option value='wpmedia'><?php _e('Wordpress Media Library'); ?></option>
                    </optgroup>
            	</select>
            	<p class="description"><?php _e( '<p>Choose the type of video you would like to embed.</p>','mc-lan' ); ?></p>

            	<label for="term_meta[mc_cat_vid_url_term_meta]"><?php _e( 'Featured Video URL', 'mc-lan' ); ?></label>
                <?php
            		$vid_url = esc_attr( $term_meta['mc_cat_vid_url_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_url_term_meta'] ) : '';
            	?>
                <input type="text" name="term_meta[mc_cat_vid_url_term_meta]" id="term_meta[mc_cat_vid_url_term_meta]" value="<?php echo $vid_url; ?>" />
            	<p class="description"><?php _e( '<p>Make sure to paste the video URL above and not the embed code</p>','mc-lan' ); ?></p>
                <p class="description"><a href="https://classmakr.com/add-youtube-video" target="_blank" id="class-makr-tut-link">Click here to watch a video tutorial on how to set this up.</a></p>
                <script>
                    jQuery(function($){
                        var linkLocation={};
                        linkLocation["YouTube"]="https://classmakr.com/add-youtube-video";
                        linkLocation["Whistia"]="https://classmakr.com/add-a-whistia-video";
                        linkLocation["Vimeo"]="https://classmakr.com/add-a-vimeo-video";
                        linkLocation["Dropbox"]="https://classmakr.com/add-a-dropbox-video";
                        linkLocation["Google Drive"]="https://classmakr.com/add-a-google-drive-video/";
                        linkLocation["Amazon S3"]="https://classmakr.com/add-an-amazon-s3-video/";
                        linkLocation["Wordpress Media Library"]="https://classmakr.com/add-a-wordpress-media-library-video/";
                        jQuery(".class-makr-video-choice").on("change",function(){
                            var val=jQuery(".class-makr-video-choice option:selected").text();
                            jQuery("#class-makr-tut-link").attr("href",linkLocation[val]);
                        });
                    });
                </script>
                <label for="term_meta[mc_cat_price_term_meta]"><?php _e( 'Price', 'mc-lan' ); ?> <span style="color: red;"><?php _e( '(Charge for your classes by getting the <a style="color:red;" href="https://classmakr.com/" target="_blank">pro version</a>)', 'mc-lan' ); ?></span></label>
                <?php
                    $price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '0';
                ?>
                <input type="number" min="0" readonly name="term_meta[mc_cat_price_term_meta]" id="term_meta[mc_cat_price_term_meta]" value="<?php echo $price; ?>" />

                <label for="term_meta[mc_cat_price_btn_txt_term_meta]"><?php _e( 'Button price text', 'mc-lan' ); ?></label>
                <?php
                    $price_button_txt = esc_attr( $term_meta['mc_cat_price_btn_txt_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_btn_txt_term_meta'] ) : 'Get full access';
                ?>
                <input type="text" name="term_meta[mc_cat_price_btn_txt_term_meta]" id="term_meta[mc_cat_price_btn_txt_term_meta]" value="<?php echo $price_button_txt; ?>" />

                <p>NOTE: In order to add text descriptions for your classes, you will need to create the class first then click on the “edit” button for that class.</p>
            </div>
        <?php
	}
	public function metabox_taxonomy_edit($term) {

        $t_id = $term->term_id;
        $term_meta = get_option( "taxonomy_$t_id" );
       ?>
       <tr class="form-field">
            <th scope="row" valign="top"><label for="term_meta[mc_short_desc_term_meta]"><?php _e( 'Short Description (Used for class details page)', 'mc-lan' ); ?></label></th>
            <td>
                <?php 
                    $settings = array( 'textarea_name' => 'term_meta[mc_short_desc_term_meta]' );
                    $content = stripslashes($term_meta['mc_short_desc_term_meta']);

                    wp_editor( $content, 'mc_short_desc_term_meta', $settings ); 
                ?>
            </td>
        </tr>
        <tr class="form-field">
            <th scope="row" valign="top"><label for="term_meta[mc_long_desc_term_meta]"><?php _e( 'Long Description (Used for class payment page)', 'mc-lan' ); ?></label></th>
            <td>
                <?php 
                    $settings = array( 'textarea_name' => 'term_meta[mc_long_desc_term_meta]' );
                    $content = stripslashes($term_meta['mc_long_desc_term_meta']);

                    wp_editor( $content, 'mc_long_desc_term_meta', $settings ); 
                ?>
            </td>
        </tr>
        <tr class="form-field">
        	<th scope="row" valign="top"><label for="term_meta[mc_grad_term_meta]"><?php _e( 'Gradation Type', 'mc-lan' ); ?></label></th>
            <td>
            	<?php
            		$grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
            	?>
            	<select name="term_meta[mc_grad_term_meta]" id="term_meta[mc_grad_term_meta]">
            		<option value="none" <?php if( $grad == 'none' ){ echo 'selected=selected'; } ?>>None</option>
            		<option value="mcq" <?php if( $grad == 'mcq' ){ echo 'selected=selected'; } ?>>Multiple Choice Question (MCQ)</option>
            		<option value="confident" <?php if( $grad == 'confident' ){ echo 'selected=selected'; } ?>>Confident Score (Checkbox)</option>
                    <option value="checkmark" <?php if( $grad == 'checkmark' ){ echo 'selected=selected'; } ?>>Checkmark</option>
            	</select>
                
                <p class="description"><?php _e( '<p><b>Note:</b> To use the "Multiple Choice Question" option you need to make sure to the questions and answers within your Lesson pages.</p>','mc-lan' ); ?></p>
            </td>
        </tr>
        
        <tr class="form-field">
        	<th scope="row" valign="top">
        		<label for="term_meta[mc_cat_cover_term_meta]"><?php _e( 'Featured Image', 'mc-lan' ); ?></label>
        	</th>
        	<td>
        		<a href="javascript:void(0);" id="mc-class-upload-button" class="button button-secondary">Upload</a>
        		<span id="mc-cat-display">
        		<?php
                	if($term_meta['mc_cat_cover_term_meta']){
                ?>
                	<br /><br />
                	<a href=<?php echo wp_get_attachment_url($term_meta['mc_cat_cover_term_meta']); ?> download><?php echo get_the_title($term_meta['mc_cat_cover_term_meta']); ?> </a>
                    <span onclick="deleteCoverImage()" class="dashicons dashicons-no-alt" style="color: red;cursor: pointer;display: inline-block;text-decoration: none;"></span>
                <?php
                	}
                ?>
                </span>
                <input type="hidden" name="term_meta[mc_cat_cover_term_meta]" id="term_meta_mc_cat_cover_term_meta" value="<?php echo $term_meta['mc_cat_cover_term_meta']; ?>"/>
                <p class="description"><?php _e( '<p>This is the image that will show up within your website within the category listing area..</p>','mc-lan' ); ?></p>

        	</td>
        </tr>
        <tr class="form-field">
            <th scope="row" valign="top">
                <label for="term_meta[mc_cat_cover_term_recomended_id]"><?php _e( 'Recommended Class(es)', 'mc-lan' ); ?></label>
            </th>

            <td>
                <?php
                    $wcatTerms = get_terms('mc-class-category', array('hide_empty' => 0));
                ?>
                <select multiple name="term_meta[mc_cat_cover_term_recomended_id][]" >
                    <?php
                    foreach($wcatTerms as $wcatTerm) {
                        if( $wcatTerm->term_id != $t_id ){
                    ?>
                        <option value="<?php echo $wcatTerm->term_id; ?>" <?php if(in_array($wcatTerm->term_id, $term_meta['mc_cat_cover_term_recomended_id'])){ echo "selected=selected";} ?>><?php echo $wcatTerm->name; ?></option>
                    <?php
                        }
                    }
                    ?>
                </select>
            </td>
        </tr>
        <script type="text/javascript">
            function deleteCoverImage(){
                if (confirm('Do you want to remove current cover image?')) {
                    jQuery("#mc-cat-display").remove();
                    jQuery("#term_meta_mc_cat_cover_term_meta").val('');
                }
            }
        </script>
        <tr class="form-field">
        	<th scope="row" valign="top">
        		<label for="term_meta[mc_cat_vid_type_term_meta]"><?php _e( 'Featured Video Type', 'mc-lan' ); ?></label>
        	</th>
        	<td>
                <?php
            		$vid_type = esc_attr( $term_meta['mc_cat_vid_type_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_type_term_meta'] ) : 'youtube';
            	?>
                <select name="term_meta[mc_cat_vid_type_term_meta]" id="term_meta[mc_cat_vid_type_term_meta]" class="class-makr-video-choice">
                    <optgroup label="3rd-Party Hosted">
                        <option value='whistia' <?php if($vid_type=='whistia'){echo 'selected=selected';} ?> ><?php _e('Whistia'); ?></option>
                		<option value='youtube' <?php if($vid_type=='youtube'){echo 'selected=selected';} ?> ><?php _e('YouTube'); ?></option>
                		<option value='vimeo' <?php if($vid_type=='vimeo'){echo 'selected=selected';} ?>><?php _e('Vimeo'); ?></option>
                    </optgroup>
                    <optgroup label="Self Hosted">
                        <option value='dropbox' <?php if($vid_type=='dropbox'){echo 'selected=selected';} ?>><?php _e('Dropbox'); ?></option>
                        <option value='googledrive' <?php if($vid_type=='googledrive'){echo 'selected=selected';} ?>><?php _e('Google Drive'); ?></option>
                        <option value='amazons3' <?php if($vid_type=='amazons3'){echo 'selected=selected';} ?>><?php _e('Amazon S3'); ?></option>
                        <option value='wpmedia' <?php if($vid_type=='wpmedia'){echo 'selected=selected';} ?>><?php _e('Wordpress Media Library'); ?></option>
                    </optgroup>
            	</select>
            	<p class="description"><?php _e( '<p>Make sure to paste the video URL above and not the embed code.</p>','mc-lan' ); ?></p>
                <p class="description"><a href="https://classmakr.com/add-youtube-video" target="_blank" id="class-makr-tut-link">Click here to watch a video tutorial on how to set this up.</a></p>
                <script>
                    jQuery(function($){
                        var linkLocation={};
                        linkLocation["YouTube"]="https://classmakr.com/add-youtube-video";
                        linkLocation["Whistia"]="https://classmakr.com/add-a-whistia-video";
                        linkLocation["Vimeo"]="https://classmakr.com/add-a-vimeo-video";
                        linkLocation["Dropbox"]="https://classmakr.com/add-a-dropbox-video";
                        linkLocation["Google Drive"]="https://classmakr.com/add-a-google-drive-video/";
                        linkLocation["Amazon S3"]="https://classmakr.com/add-an-amazon-s3-video/";
                        linkLocation["Wordpress Media Library"]="https://classmakr.com/add-a-wordpress-media-library-video/";
                        
                        jQuery(document).ready(function(){
                            var val=jQuery(".class-makr-video-choice option:selected").text();
                            jQuery("#class-makr-tut-link").attr("href",linkLocation[val]);
                        });
                        
                        
                        jQuery(".class-makr-video-choice").on("change",function(){
                            var val=jQuery(".class-makr-video-choice option:selected").text();
                            jQuery("#class-makr-tut-link").attr("href",linkLocation[val]);
                        });
                    });
                </script>
        	</td>
        </tr>

        <tr class="form-field">
        	<th scope="row" valign="top">
        		<label for="term_meta[mc_cat_vid_type_term_meta]"><?php _e( 'Featured Video URL', 'mc-lan' ); ?></label>
        	</th>
        	<td>
                <?php
            		$vid_url = esc_attr( $term_meta['mc_cat_vid_url_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_url_term_meta'] ) : '';
            	?>
                <input type="text" name="term_meta[mc_cat_vid_url_term_meta]" id="term_meta[mc_cat_vid_url_term_meta]" value="<?php echo $vid_url; ?>" />
            	<p class="description"><?php _e( '<p>Put the URL here.</p>','mc-lan' ); ?></p>
        	</td>
        </tr>
        <tr class="form-field">
            <th scope="row" valign="top">
                <label for="term_meta[mc_cat_vid_thumb_image_type_term_meta]"><?php _e( 'Featured Video Thumb Image', 'mc-lan' ); ?></label>
            </th>
            <?php 
                $img_type = esc_attr( $term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) : 'default';
            ?>
            <td>
                <select name="term_meta[mc_cat_vid_thumb_image_type_term_meta]" id="mc_cat_vid_thumb_image_type_term_meta">
                    <option value="default" <?php if($img_type=='default'){ echo "selected=selected"; } ?>>System Default Image</option>
                    <option value="featured" <?php if($img_type=='featured'){ echo "selected=selected"; } ?>>Class Featured Image</option>
                    <option value="new" <?php if($img_type=='new'){ echo "selected=selected"; } ?>>Upload New Image</option>
                </select>
                <span id="mc_cat_vid_thumb_image_term_meta_featured" <?php if($img_type!='featured') echo 'style="display: none;"';?>><?php _e('<p class="description">If featured image is not uploaded till yet, please upload from above <b>Featured Image</b> field, otherwise System Default Image will be shown as <b>Featured Video Thumb Image</b>.</p>'); ?></span>
                <span id="mc_cat_vid_thumb_image_term_meta_new">
                <?php
                    if($img_type=='new'){
                ?>
                    <br /><br />
                    <a href=<?php echo wp_get_attachment_url($term_meta['mc_cat_vid_thumb_image_term_meta']); ?> download><?php echo get_the_title($term_meta['mc_cat_vid_thumb_image_term_meta']); ?> </a>
                    <span class="dashicons dashicons-dismiss delete-video-feat-image" style="color: red;cursor: pointer;display: inline-block;text-decoration: none;"></span>
                <?php
                    }
                ?>
                </span>
                <input type="hidden" name="term_meta[mc_cat_vid_thumb_image_term_meta]" id="mc_cat_vid_thumb_image_term_meta" value="<?php echo $term_meta['mc_cat_vid_thumb_image_term_meta']; ?>">
            </td>
        </tr>
        <tr class="form-field">
            <th scope="row" valign="top">
                <label for="term_meta[mc_cat_price_term_meta]"><?php _e( 'Price', 'mc-lan' ); ?></label>
            </th>
            <td>
                <?php
                    $price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '0';
                ?>
                <input type="hidden" name="term_meta[mc_cat_price_term_meta]" id="term_meta[mc_cat_price_term_meta]" value="0">
                <input type="number" readonly min="0" name="mc_cat_price_term_meta" id="mc_cat_price_term_meta" value="<?php echo $price; ?>" />
                <p style="color: red;"><?php _e( '(Charge for your classes by getting the <a style="color:red;" href="https://classmakr.com/" target="_blank">pro version</a>)', 'mc-lan' )?></p>
            </td>
        </tr>
        <tr class="form-field">
            <th scope="row" valign="top">
                <label for="term_meta[mc_cat_price_btn_txt_term_meta]"><?php _e( 'Button price text', 'mc-lan' ); ?></label>
                <?php
                    $price_button_txt = esc_attr( $term_meta['mc_cat_price_btn_txt_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_btn_txt_term_meta'] ) : 'Get full access';
                ?>
            </th>
            <td>
                <input type="text" name="term_meta[mc_cat_price_btn_txt_term_meta]" id="term_meta[mc_cat_price_btn_txt_term_meta]" value="<?php echo $price_button_txt; ?>" />
            </td>
        </tr>
    <?php
    }

    public function save_tax_metabox( $term_id ) {
        if ( isset( $_POST['term_meta'] ) ) {

            $t_id = $term_id;
            $term_meta = get_option( "taxonomy_$t_id" );
            $cat_keys = array_keys( $_POST['term_meta'] );
            foreach ( $cat_keys as $key ) {
                if ( isset ( $_POST['term_meta'][$key] ) ) {
                    $term_meta[$key] = $_POST['term_meta'][$key];
                }
            }
            // Save the option array.
            update_option( "taxonomy_$t_id", $term_meta );
        }

    }

	public static function save_meatdata($post_id){
		
        //echo '<pre>'; print_r($_POST); echo '</pre>'; die;
        if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
			return $post_id;

		if ( !current_user_can( 'edit_post', $post_id ))
    		return;

		if ( get_post_type( $post_id ) != 'mc-class' && get_post_type( $post_id ) != 'mc_class_coupon' )
			return $post_id;



		update_post_meta( $post_id, '_mc_regular_price', $_POST['mc_regular_price']);
		update_post_meta( $post_id, '_mc_sale_price', $_POST['mc_sale_price']);
		update_post_meta( $post_id, '_mc_lerner_cmnts', $_POST['mc_lerner_cmnts'] );
		update_post_meta( $post_id, '_mc_documents', $_POST['mc_documents']);
        update_post_meta( $post_id, '_mc_question_answer_set', $_POST['ques_ans']);
        update_post_meta( $post_id, '_mc_lesson_tutorial_video_type', $_POST['_mc_lesson_tutorial_video_type']);
        update_post_meta( $post_id, '_mc_lesson_tutorial_video_url', $_POST['_mc_lesson_tutorial_video_url']);

        update_post_meta( $post_id, '_mc_lesson_vid_thumb_image_type_term_meta', $_POST['_mc_lesson_vid_thumb_image_type_term_meta']);
        update_post_meta( $post_id, '_mc_lesson_vid_thumb_image_term_meta', $_POST['_mc_lesson_vid_thumb_image_term_meta']);

        update_post_meta( $post_id, '_mc_coupon_code', $_POST['_mc_coupon_code']);
        update_post_meta( $post_id, '_mc_coupon_type', $_POST['_mc_coupon_type']);
        update_post_meta( $post_id, '_mc_coupon_amount', $_POST['_mc_coupon_amount']);

        $schedule=$_POST['_schedule_live_video_class_makr'];
        update_post_meta( $post_id, '_schedule_live_video_class_makr', $schedule);
        if(isset($_POST['_schedule_live_video_class_makr']))
        {
            
            if($_POST['_schedule_live_video_class_makr']=='schedule-live')
            {
                $time_str = $_REQUEST['_class_makr_aa'].'-'.$_REQUEST['_class_makr_mm'].'-'.$_REQUEST['_class_makr_jj'].' '.($_REQUEST['_class_makr_hh']-get_option('gmt_offset')).':'.$_REQUEST['_class_makr_mn'].':00 GMT';
                $start_time = strtotime($time_str);
                update_post_meta( $post_id, '_schedule_live_video_class_makr_time', $start_time);
            }
            if($_POST['_schedule_live_video_class_makr']=='live-now')
            {
                global $wp_locale;
                $time_adj = current_time('timestamp');
                $time_str = gmdate( 'Y', $time_adj ).'-'.gmdate( 'm', $time_adj ).'-'.gmdate( 'd', $time_adj ).' '.(gmdate( 'H', $time_adj )-get_option('gmt_offset')).':'.gmdate( 'i', $time_adj ).':00 GMT';
                $start_time = strtotime($time_str);
                update_post_meta( $post_id, '_schedule_live_video_class_makr_time', $start_time);
            }
            
        }
	}
    public static function payments_record_data(){
        ?>
        <style type="text/css">
            #mc-class-payment-record-data .ui-sortable-handle, #mc-class-payment-record-data .handlediv{
                display: none;
            }
            .mc_payment_data_payment_details li i{
                width: 150px;
                display: inline-block;
            }
            .mc_payment_data_class_details ul li i{
                width: 150px;
                display: inline-block;
            }
        </style>
        <div id="mc_payment_data" class="panel">
            <h2 style="font-size: 20px; font-weight: 300">Payment Record #<?php echo get_the_ID(); ?> details</h2>
            <p style="padding: 8px 12px;">Paid on <i><?php echo get_the_date( 'l F j, Y, @ h:m:s', get_the_ID() ); ?></i>
            <div class="mc_payment_data_payment_details">
                <h2><b>Payment Details</b></h2>
                <ul style="padding: 8px 12px;">
                    <li><i>Payment Through:</i><?php echo get_post_meta( get_the_ID(), '_mc_pay_through', true ); ?></li>
                    <li></li>
                    <li><i><?php echo get_post_meta( get_the_ID(), '_mc_pay_through', true ); ?> Transacion ID:</i><?php echo get_post_meta( get_the_ID(), '_mc_pay_tran_id', true ); ?></li>
                    <li></li>
                    <li><i>System Transaction ID:</i><?php echo get_post_meta( get_the_ID(), '_mc_pay_system_tran_id', true ); ?></li>
                    <li></li>
                    <?php
                        $mc_cls_currency = get_post_meta( get_the_ID(), '_mc_pay_currency', true );
                        $currency_arr    = explode( "-", $mc_cls_currency);
                        $currency        = strtoupper($currency_arr[0]);
                    ?>
                    <?php if(get_post_meta( get_the_ID(), '_mc_pay_coupon_code', true ) != '') { ?>
                    <li style="color: #b90000;"><i>Coupon Code:</i><?php echo get_post_meta( get_the_ID(), '_mc_pay_coupon_code', true ); ?></li>
                    <li style="color: #b90000;"><i>Subtotal:</i><?php echo $currency_arr[1].''.get_post_meta(get_the_ID(), '_mc_pay_actual_price', true).' '.$currency; ?></li>
                    <li style="color: #b90000;"><i>Coupon Amount:</i><?php echo $currency_arr[1].''.get_post_meta(get_the_ID(), '_mc_pay_discount_amount', true).' '.$currency; ?></li>    
                    <?php } ?> 
                    <li><i>Amount:</i><?php
                        if(get_post_meta( get_the_ID(), '_mc_pay_through', true ) == 'Stripe'){
                            echo $currency_arr[1].''.get_post_meta( get_the_ID(), '_mc_pay_total_amount', true )/100;
                            echo ' '.$currency;
                        }else{
                            echo $currency_arr[1].''.get_post_meta( get_the_ID(), '_mc_pay_total_amount', true ).' '.$currency;
                        }   
                        ?>
                    </li>          
                </ul>
            </div>
            <div class="mc_payment_data_class_details">
                <h2><b>Subscribed Class Details</b></h2>
                <ul style="padding: 8px 12px;">
                    <li><i>Class Name:</i>
                    <?php 
                        $term_id = get_post_meta( get_the_ID(), '_mc_pay_course_id', true );
                        $bundle_id = get_option( '_mc_class_bundle_id' );
                        if( $term_id == $bundle_id ){
                            $mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
                            $details_cls_name = '';
                            $count = 1;
                            foreach( $mc_cls_bundle_package_product as $pack_pr ){
                                
                                if( $count != 1 ){
                                    $details_cls_name .= ", ";
                                }
                                $bundle_term_data = get_term_by( 'id', $pack_pr , 'mc-class-category' );
                                $details_cls_name .= '<a href="'.admin_url('term.php?taxonomy=mc-class-category&tag_ID='.$pack_pr.'&post_type=mc-class').'">'.$bundle_term_data->name.'</a>';
                                $count++;
                            }

                            $term_data_name = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
                            echo $term_data_name .' ( '.$details_cls_name.' )';
                        }else{
                            $term_data = get_term_by( 'id', $term_id , 'mc-class-category' );
                            ?>
                            <a href="<?php echo admin_url('term.php?taxonomy=mc-class-category&tag_ID='.$term_id.'&post_type=mc-class'); ?>" target="_blank;">
                                <?php echo $term_data->name; ?>
                            </a>
                            <?php
                        }
                        
                        //print_r($term_data);
                    ?>

                    
                        
                    </li>
                    <li></li>
                </ul>
            </div>
            <div class="mc_payment_data_class_details">
                <h2><b>User Details</b></h2>
                <ul style="padding: 8px 12px;">
                    <?php 
                        $user_id = get_post_meta( get_the_ID(), '_mc_pay_user_id', true );
                        $user_data = get_user_by( 'id', $user_id ); 
                        //print_r($user_data);
                    ?>
                    <li><i>ID:</i><a href="<?php echo admin_url('user-edit.php?user_id='.$user_id); ?>" target="_blank;"><?php echo $user_data->ID; ?></a></li>
                    <li><i>Name:</i><?php echo $user_data->display_name; ?>
                    </li>
                    <li><i>Email:</i><?php echo $user_data->user_email; ?>
                    </li>
                    <li><i>Registered:</i><?php echo $user_data->user_registered; ?>
                    </li>
                </ul>
                
            </div>
        </div>
         
        <?php
    }

    public static function coupon_data(){
        ?>
        <style type="text/css">
            #mc-class-coupon-data{
                height: 330px;
            }
            #mc-class-coupon-data .ui-sortable-handle, #mc-class-payment-record-data .handlediv{
                display: none;
            }
            #post-preview, #view-post-btn{display: none;}
            #mc-class-coupon-data p{
                margin:10px;
                padding: 10px;
            }
            #mc-class-coupon-data p label{
                width: 100%;
                font-size: medium;
                display: block;
                float: left;
            }
            #mc-class-coupon-data p input, #mc-class-coupon-data p select{
                width: 100%;
                display: block;
                float: left;
                margin-bottom:20px;
                height: 30px;
            }
        </style>
        <div id="mc_coupon_data" class="panel">
            <h2 style="font-size: 20px; font-weight: 300">Coupon Details</h2>
            <p>
                <label>Code</label>
                <input type="text" name="_mc_coupon_code" value="<?php echo get_post_meta( get_the_ID(), '_mc_coupon_code', true); ?>">
            </p>
            <p>
                <label>Type</label>
                <select name="_mc_coupon_type">
                    <option value="fixed" <?php if( get_post_meta( get_the_ID(), '_mc_coupon_type', true) == 'fixed'){ echo 'selected=selected';} ?>>Fixed</option>
                    <option value="percentage" <?php if( get_post_meta( get_the_ID(), '_mc_coupon_type', true) == 'percentage'){ echo 'selected=selected';} ?>>Percentage</option>
                </select>
            </p>
            <p>
                <label>Amount</label>
                <input type="number" step="any" name="_mc_coupon_amount" value="<?php echo get_post_meta( get_the_ID(), '_mc_coupon_amount', true); ?>">
            </p>
        </div>
        <?php
    }
}