<?php
class MC_My_Account_Controller
{

	public function __construct()
	{
		add_filter( 'display_post_states', function ( $states, $post ) {
		  	if ( intval( get_option( '_mc_class_account_page_id' ) ) === $post->ID ) {
		        $states[] = __( 'MC User Dashboard Page' );
		    }

		    return $states;
		}, 10, 2 );


		add_action( 'wp_enqueue_scripts', array($this,'add_css_js') );
		add_action( 'wp_ajax_mc_learner_account_update', array($this,'mc_learner_account_update_callback') );
		add_action('wp_ajax_classMakrAvatarSupport',[$this,'classMakrAvatarSupport']);
		add_action('wp_ajax_nopriv_classMakrAvatarSupport',[$this,'classMakrAvatarSupport']);
		add_action( 'after_setup_theme', [$this,'wpdocs_theme_setup'] );
		add_action('wp_ajax_classmakrUpdateDisplay',[$this,'classmakrUpdateDisplay']);
		add_action('wp_ajax_nopriv_classmakrUpdateDisplay',[$this,'classmakrUpdateDisplay']);

	}
	public function classmakrUpdateDisplay()
	{
	    global $wpdb;
	    $data=$_POST['data'];
	    $info=array();
	    parse_str($data,$info);
	    $userId=$info['class-makr-display-src'];
	    $name=$info['class_makr_display_name'];
	    $nameInfo=explode(" ",$name);
	    
        $authorData=get_user_by('id',$userId);
        wp_update_user( array( 'ID' => $userId, 'first_name'=>$name,'display_name'=>$name ) );
            echo $name;
	    
	    die;
	}
	public function wpdocs_theme_setup()
	{
	    add_image_size( 'class-makr-avatar', 80, 80, array( 'left', 'top' ) );
	}
	public function classMakrAvatarSupport()
	{
	    
	     $userId=$_POST['src'];
	     $uploadedfile = $_FILES['file'];
	   
	      
	      if (!function_exists('wp_handle_upload')) {
           require_once(ABSPATH . 'wp-admin/includes/file.php');
            }
          
          
          $upload_overrides = array('test_form' => false);
          $movefile = wp_handle_upload($uploadedfile, $upload_overrides);
          if ( $movefile && ! isset( $movefile['error'] ) ) {
              $upload_id = wp_insert_attachment( array(
        		'guid'           => $movefile['file'], 
        		'post_mime_type' => $movefile['type'],
        		'post_title'     => preg_replace( '/\.[^.]+$/', '', $uploadedfile['name'] ),
        		'post_content'   => '',
        		'post_status'    => 'inherit'
        	), $movefile['file'] );
        	require_once( ABSPATH . 'wp-admin/includes/image.php' );
        	wp_update_attachment_metadata( $upload_id, wp_generate_attachment_metadata( $upload_id, $movefile['file'] ) );
        	  $currentavatarID = get_user_meta( $userId, '_classmakr_avatar_id' , true );
              if($currentavatarID!=NULL)
              {
                  wp_delete_attachment($currentavatarID,true);
              }
             update_user_meta( $userId, '_classmakr_avatar_id' , $upload_id );
             echo wp_get_attachment_image_src( $upload_id, 'class-makr-avatar')[0];
          }
          else
          {
              echo'error';
          }
      
          
	    die;
	}
	public static function mc_learner_account_update_callback(){
		$user_id = $_POST['user_id'];
		$user_login = $_POST['username'];
		$first_name = $_POST['name'];

		$user_id = wp_update_user( array( 'ID' => $_POST['user_id'], 'user_login' => $_POST['username'], 'user_email' => $_POST['username'], 'first_name' => $_POST['name'], 'display_name' => $_POST['name']) );

		if( $_POST['password'] ){
			wp_set_password( $_POST['password'], $user_id );
		}
		die;
	}
	public static function add_css_js() {

		wp_enqueue_script( 'mc-front-js', MC_JS . '/mc-front.js', array( 'jquery' ) );
		wp_localize_script( 'mc-front-js', 'control',
            array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ,'loader' =>MC_IMG.'/5.gif' ,'default'=>MC_IMG.'/default.jpeg') );
	}
	public static function account_navigation(){

		?>
		<div class="mcUserAccNavUL">
			<div class="mcUserAccNavLI currentMcTab" data-tab="mcUserAccTab-1">My Dashboard</div>
			<div class="mcUserAccNavLI" data-tab="mcUserAccTab-3">My Courses</div>
			<div class="mcUserAccNavLI" data-tab="mcUserAccTab-2">My Account</div>
			<div class="mcUserAccNavLI" data-tab="mcUserAccTab-4">My Billing</div>
		</div>
		<?php
	}
	public static function account_dashboard(){
		if(!is_user_logged_in()){
			?>
			<script type="text/javascript">
				window.location.replace("<?php echo site_url(); ?>/mc-login/?login=success");
			</script>
			<?php
			exit;
		}
		MC_My_Account_Controller::account_navigation();
		global $current_user;
		get_currentuserinfo();


		?>

		<div class="mcAccWelcome mcUserAcc currentMcTab" id="mcUserAccTab-1">
			<?php
			$avatarID = get_user_meta( $current_user->ID, '_classmakr_avatar_id' , true );
			$img_url = ($avatarID!=NULL?wp_get_attachment_image_src( $avatarID, 'class-makr-avatar')[0]:MC_IMG.'/default.jpeg');

			if( isset($_GET['payment']) && !isset($_GET['pro'])){

				?>
				<div class="mcAccSuccessMsg" style="font-family: Raleway; padding: 30px;">
				    <img src="<?php echo MC_IMG.'/dashboard-tick.jpg';?>" alt="class-makr-payment-success"><br/>
					<b>Your payment has been accepted!</b>
					<br/>An email receipt has been sent you with.
					<br/>To access your class kindly go to your <a href="#" class="class-makr-my-course-txt" data-tab="mcUserAccTab-3"><b>"My Courses"</b></a>
				</div>
				<div class="mcAcclogoutAction"><a href="<?php echo wp_logout_url(home_url().'/mc-login/?logout=success'); ?>">Click here to logout</a></div>
				<style type="text/css">
					#mc-msg-inline-my-course, #mc-msg-inline-my-billing{
						text-decoration: underline;
						cursor: pointer;
						font-weight: 500;
					}
				</style>
				<script type="text/javascript">
				    jQuery(".class-makr-my-course-txt").click(function(e){
				        e.preventDefault();
				        jQuery("[data-tab=mcUserAccTab-3]").click();
				    });
					jQuery("#mc-msg-inline-my-course").click(function(){
						jQuery("[data-tab=mcUserAccTab-3]").click();
					});

					jQuery("#mc-msg-inline-my-billing").click(function(){
						jQuery("[data-tab=mcUserAccTab-4]").click();
					});
				</script>
				<?php
			}
			else
			{
			    ?>
			    <form class="class-makr-avatar-setup" method="post" action="" enctype="multipart/form-data">
			    <input type="hidden" name="class-makr-avatar-src" value="<?php echo $current_user->ID?>">
			    <input id="class-makr-avatar-upload" type="file" style="display:none" name="class-amkr-avatar-upload" onchange="ValidateSize(this)">
			    </form>
			    <img src="<?php echo $img_url; ?>" id="class-makr-act-avatar-upload"/>
			    <a href="#" class="class-makr-avatar-upload-msg">Edit</a>
			    <span class="class-makr-avatar-upload-ajax-error"></span><br/>
			    <span class="classmakr-display-name">Chat Display Name : <span class="classmakr-display-name-val"><?php echo Common_Functions_Controller::userDisplayName(get_current_user_id());?></span>
			    <a href="#" class="class-makr-edit-display"><img src="<?php echo MC_IMG.'/edit-tools.png'?>" alt="class-makr-display-edit"></a></span>
			    
			    <form class="classmakr-display-name-action" method="post" action="" style="display:none;">
			        <input type="hidden" name="class-makr-display-src" value="<?php echo $current_user->ID?>">
			        <label>Chat Display Name </label><input type="text" name="class_makr_display_name" value="<?php echo Common_Functions_Controller::userDisplayName(get_current_user_id());?>">
			        <input type="submit" value="Update" class="mcAccCancelSubscription">
			        <input type="button" value="Cancel" class="mcAccCancelSubscription" onclick="cancelCalaamakrUpdateDisplayName()">
			        <img src="<?php echo MC_IMG.'/5.gif'?>" alt="class-makr-loader" class="class-makr-display-loader" style="display:none;">
			    </form>
			    
			   <div class="mcAcclogoutAction"><a href="<?php echo wp_logout_url(home_url().'/mc-login/?logout=success'); ?>">Click here to logout</a></div>
			    <?php
			}
			?>
		</div>
		<div class="mcAccEditAcc mcUserAcc" id="mcUserAccTab-2">
			<div class="mcRegLoginDiv forMcuser">
				<div class="mcLogInForm">
					<?php MC_My_Account_Controller::edit_account( $current_user ); ?>
				</div>
			</div>
		</div>
		<div class="mcAccCourseAcc mcUserAcc" id="mcUserAccTab-3">
			
				<?php MC_My_Account_Controller::my_courses( $current_user ); ?>
		</div>
		<div class="mcAccBill mcUserAcc" id="mcUserAccTab-4">
			<?php MC_My_Account_Controller::my_billing( $current_user ); ?>
		</div>
		<?php
	}
	public static function edit_account( $current_user ){
		?>
		<div class="mcUserAccLegend">My Account</div>
		<form name="user_edit_acount" id="user_edit_acount">
			<div class="mcLabelInput">
		    	<input type="text" name="mc_user_edit_acc_name" id="mc-user-edit-acc-name" value="<?php echo $current_user->display_name ? $current_user->display_name : null;?>" placeholder="Name">
		    	<div class="mcLabelInputSpan"></div>
					<i class="fas fa-users"></i>
		    </div>
		    <div class="mcLabelInput">
		    	<input type="text" name="mc_user_edit_acc_email" id="mc-user-edit-acc-email" value="<?php echo $current_user->user_email ? $current_user->user_email : null;?>" placeholder="Email Address">
		    	<div class="mcLabelInputSpan"></div>
					<i class="fas fa-envelope"></i>
		    </div>
		    <div class="mcLabelInput">
		    	<input type="password" name="mc_user_edit_acc_pass" id="mc-user-edit-acc-pass" value="" placeholder="Password">
					<div class="mcLabelInputSpan"></div>
					<i class="fas fa-unlock"></i>
		    </div>
				<div class="mc-user-edit-acc-pass-desc">Keep it blank, not to change the password.</div>
		    <input type="hidden" name="userID" value="<?php echo $current_user->ID; ?>" id="mc-acc-update-userId"/>
				<div class="mcBtncent">
					<a id="mc-acc-update-button" class="button">Update</a>
				</div>
		</form>
		<div class="mc-acc-update-msg">Your information successfully updated.</div>
		<script type="text/javascript">
			var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
		    jQuery( "#mc-acc-update-button" ).click( function( ) {
		    	var username = $("#mc-user-edit-acc-email").val();
			  	var password = $("#mc-user-edit-acc-pass").val();
			  	var name = $("#mc-user-edit-acc-name").val();

		    	var emailReg = /^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i;

			    if( !$.trim(name) ){
			      	$("#mc-user-edit-acc-name").focus();
			      	$("#mc-user-edit-acc-name").addClass('mc-update-error-exists');
			      	return false;
			  	}

			    if(!emailReg.test( username ))
			    {
			        $("#mc-user-edit-acc-email").focus();
			        $("#mc-user-edit-acc-email").addClass('mc-update-error-exists');
			        return false;
			    }
			    var data = {
			      action: 'mc_learner_account_update',
			      user_id: jQuery("#mc-acc-update-userId").val(),
			      username: username,
			      name: name,
			      password: password
			    };
			    jQuery("#mc-acc-update-button").html('<i>Submitting...</i>');
			    $.post( ajaxurl, data, function( response ) {
			    	jQuery("#mc-acc-update-button").html('Update');
			    	jQuery('.mc-acc-update-msg').fadeIn('slow');
					jQuery('.mc-acc-update-msg').delay(3000).fadeOut('slow');
					return false;

			    });
			});
		</script>
		<?php
	}

	public static function my_courses( $current_user ){
		$args = array(
			'posts_per_page'   => -1,
			'post_type'        => 'mc_class_payment',
			'post_status'      => 'publish',
			'meta_query'       =>array('relation'=>'AND',
			                            array('key'=>'_mc_pay_user_id','value'=>get_current_user_id(),'compare'=>'=')
			                           )
		);

		$payments_array = get_posts( $args );
		foreach ($payments_array as $payment){
		    $stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
		    $stat2=get_post_meta($payment->ID,'_mc_order_status',true);
		    $orderStat=array();
            
            if(strlen($stat)>0)
	        {
	            $orderStat[]=$stat;
	        }
	        
	        if(strlen($stat2)>0)
	        {
	            $orderStat[]=$stat2;
	        }
		    if(! in_array('cancelled',$orderStat))
		    {
		       $course_id_arr[] =  get_post_meta( $payment->ID, '_mc_pay_course_id', true );
		    }
		
			
		}
		//echo "<pre>"; print_r($course_id_arr); echo "</pre>";

		?>
		<?php
			$mc_tag_bck_clr = get_option('mc_tag_bck_clr') ? get_option('mc_tag_bck_clr') : "#dd0808";
		?>
		<style type="text/css">
			.mcClassSingleCoverPer{
				background-color: <?php echo $mc_tag_bck_clr; ?> !important;
			}
			.mcClassSingleCoverPer:before{
				border-right-color: <?php echo $mc_tag_bck_clr; ?> !important;
			}
		</style>
		<div class="mcUserAccLegend">My Courses</div>
		<div class="mc-class-Cate">
			<?php
			$showCount=0;
				foreach ($payments_array as $payment)
				{
					$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
					$bundle_id = get_option( '_mc_class_bundle_id' );

					if( $term_id == $bundle_id ){
					    
					    $stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
    					if($stat!='cancelled'){
    										 
					    
						$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
	                    foreach( $mc_cls_bundle_package_product as $pack_pr ){
	                    	
	                    	if( in_array($pack_pr, $course_id_arr) )
	                    		continue;

	                    	$term_data = get_term_by( 'id', $pack_pr , 'mc-class-category' );
		                	$term_meta = get_option( "taxonomy_$pack_pr" );
		                	$cover_id = $term_meta['mc_cat_cover_term_meta'];
		                	$class_permalink = get_term_link( $term_data->slug, $term_data->taxonomy );
		                
		                	$class_name = $term_data->name;
		                	if( $cover_id ){
		                		$cover_url = wp_get_attachment_url($cover_id);
		                	}else{
		                		$cover_url = MC_IMG.'/image-no.png';
		                	}
	                    	?>
	                    	
		                    	<div class="mcClassSingle mcClassSingleAlt">
									<div class="mcClassSingleMain">
										<a href="<?php echo $class_permalink; ?>"> </a>
											<div class="mcClassSingleCover">
												<img src="<?php echo $cover_url; ?>">
											</div>
											<div class="mcClassSingleCoverTxt"><?php echo $class_name ; ?></div>
											<?php
											$grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
											if( $grad && $grad != 'none' ){

												$args = array(
												    'post_type' => 'mc-class',
												    'post_status' => 'publish',
												    'tax_query' => array(
												        array(
												            'taxonomy' => 'mc-class-category',
												            'field'    => 'term_id',
												            'terms'    => array( $pack_pr )
												        )
												    )
												);
												$lessons = get_posts( $args );
												if( $lessons ){
													$count = 0;
													$score = 0;
													foreach ($lessons as $lesson) {
														$key = 'mc_score_for_'.$lesson->ID.'_based_on_'.$grad;
														$score = $score+(get_user_meta( get_current_user_id(), $key, true ));
														$count++;
													}
													//echo "Score: ".$score." Count: ".$count." ";
													?>
													<div class="mcClassSingleCoverPer"><?php echo ($score)/($count).'%';?></div>

													<?php
												}
											}
										?>

									</div>
								</div>
							
	                    	<?php
	                    }
	                    $showCount++;
    					}
	                    
					}else
					{
						
						$stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
						$stat2=get_post_meta($payment->ID,'_mc_order_status',true);
				        
				        $orderStat=array();
				        
				        if(strlen($stat)>0)
				        {
				            $orderStat[]=$stat;
				        }
				        
				        if(strlen($stat2)>0)
				        {
				            $orderStat[]=$stat2;
				        }
				        
						if(! in_array('cancelled',$orderStat)){
						
						$term_data = get_term_by( 'id', $term_id , 'mc-class-category' );
	                	$term_meta = get_option( "taxonomy_$term_id" );
	                	$cover_id = $term_meta['mc_cat_cover_term_meta'];
	                	$class_permalink = get_term_link( $term_data->slug, $term_data->taxonomy );
	          
	                	$class_name = $term_data->name;
	                	if( $cover_id ){
	                		$cover_url = wp_get_attachment_url($cover_id);
	                	}else{
	                		$cover_url = MC_IMG.'/image-no.png';
	                	}

						?>
						<div class="mcClassSingle mcClassSingleAlt">
							<div class="mcClassSingleMain">
								<a href="<?php echo $class_permalink; ?>"> </a>
									<div class="mcClassSingleCover">
										<img src="<?php echo $cover_url; ?>">
									</div>
									<div class="mcClassSingleCoverTxt"><?php echo $class_name ; ?></div>
									<?php
										$grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
										if( $grad && $grad != 'none' ){

											$args = array(
											    'post_type' => 'mc-class',
											    'post_status' => 'publish',
											    'tax_query' => array(
											        array(
											            'taxonomy' => 'mc-class-category',
											            'field'    => 'term_id',
											            'terms'    => array( $term_id )
											        )
											    )
											);
											$lessons = get_posts( $args );
											if( $lessons ){
												$count = 0;
												$score = 0;
												foreach ($lessons as $lesson) {
													$key = 'mc_score_for_'.$lesson->ID.'_based_on_'.$grad;
													$score = $score+(get_user_meta( get_current_user_id(), $key, true ));
													$count++;
												}
												//echo "Score: ".$score." Count: ".$count." ";
												?>
												<div class="mcClassSingleCoverPer"><?php echo ($score)/($count).'%';?></div>

												<?php
											}
										}
									?>


							</div>
						</div>


					<?php
					    $showCount++;
						}
					}
				}
				if($showCount<1)
				{
				    echo'<center>No course Found.</center>';
				}
			?>
		</div>
		<?php
	}

	public static function my_billing( $current_user ){
		?>
		<div class="mcUserAccLegend">My Billing</div>
		<?php
		$args = array(
			'posts_per_page'   => -1,
			'meta_key'         => '_mc_pay_user_id',
			'meta_value'       => get_current_user_id(),
			'post_type'        => 'mc_class_payment',
			'post_status'      => 'publish',
		);
		$payments_array = get_posts( $args );
		?>
		<table id="mcAccMyBillingTable">
			<?php
				$i = 0;
				foreach ($payments_array as $payment) {
					$payThrough=get_post_meta( $payment->ID, '_mc_pay_through', true );
				
					$mc_cls_currency = get_post_meta( $payment->ID, '_mc_pay_currency', true );
	                $currency_arr    = explode( "-", $mc_cls_currency);
	                $currency        = strtoupper($currency_arr[0]);
	                
	                $totalAmount=get_post_meta( $payment->ID, '_mc_pay_total_amount', true );
	                
	                $flagStatus=array();
	                $flagStatus[]=get_post_meta($payment->ID,'_mc_order_payment_status',true);
	                $flagStatus[]=get_post_meta($payment->ID,'_mc_order_status',true);
	                
	                
	                $displayAmt= '@'.$currency_arr[1].''.$totalAmount.' '.$currency;
	                
			?>
			<tr class="<?php if (0 == $i % 2) { echo 'mc-billing-even-row'; }else{ echo 'mc-billing-odd-row'; } ?>" >
				<td><b>#<?php echo $payment->ID; ?></b></td>
				<td>on <?php echo $payment->post_date; ?></td>
				<td><?php echo (in_array('cancelled',$flagStatus)?'<del>'.$displayAmt.'</del>':$displayAmt);?></td>
                <td>
                	<?php
                       	$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
                       	$bundle_id = get_option( '_mc_class_bundle_id' );
                       	if( $term_id == $bundle_id ){
                       		echo get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
                       		$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
                       		$count = 1;
                       		?>
                       		<span class="mcBillinBundleClsTog">
                       			<span class="dashicons dashicons-arrow-up-alt2" style="display: none;"></span>
                       			<span class="dashicons dashicons-arrow-down-alt2"></span>
                       		</span>
                       		<span class="mcBillinBundleCls">
                       			<?php foreach( $mc_cls_bundle_package_product as $pack_pr ){
                       				if( $count != 1 ){
                       					echo "<br/>";
                       				}
                       				$bundle_term_data = get_term_by( 'id', $pack_pr , 'mc-class-category' );
                       				echo $bundle_term_data->name;
                       				$count++;
                       			}?>

	                       	</span>
                       		<?php
                       }else{
                       		$term_data = get_term_by( 'id', $term_id , 'mc-class-category' );
                       		echo $term_data->name;
                       }


                    ?>
                </td>
                <td>
                	<button class="mcAccViewInvoice">View invoice</button>
                	<div class="mc_invoice_data" style="display: none;">
			            <h6>Invoice Of Payment Record #<?php echo $payment->ID; ?></h6>
			            <div class="mc_invloce_payment_left">
				            <div class="mc_invloce_payment_data_payment_details">
				                <h2><b>Payment Details</b></h2>
				                <ul>
				                	<li><b>Date:</b>&nbsp; <?php echo get_the_date( 'l F j, Y, @ h:m:s', $payment->ID ); ?></li>
				                    <li><b>Payment Through:</b>&nbsp; <?php echo get_post_meta( $payment->ID, '_mc_pay_through', true ); ?></li>
				                    <li><b>Transacion ID:</b>&nbsp; <?php echo get_post_meta( $payment->ID, '_mc_pay_system_tran_id', true ); ?></li>

				                    <?php if(get_post_meta( $payment->ID, '_mc_pay_coupon_code', true ) != '') { ?>
				                    <li><b>Coupon Code:</b>&nbsp; <?php echo get_post_meta( $payment->ID, '_mc_pay_coupon_code', true ); ?></li>
				                    <li><b>Subtotal:</b>&nbsp; <?php echo $currency_arr[1].''.get_post_meta($payment->ID, '_mc_pay_actual_price', true).' '.$currency; ?></li>
				                    <li><b>Coupon Amount:</b>&nbsp; <?php echo $currency_arr[1].''.get_post_meta($payment->ID, '_mc_pay_discount_amount', true).' '.$currency; ?></li>    
				                    <?php } ?> 
				                    <li><b>Amount:</b>&nbsp;   
				                        <?php echo $currency_arr[1].''.$totalAmount.' '.$currency;?>
				                    </li>
				                </ul>
				            </div>
				            <div class="mc_invloce_payment_data_class_details">
				                <h2><b>Subscribed Class Details</b></h2>
				                <ul>
				                	<?php
				                		$bundle_id = get_option( '_mc_class_bundle_id' );
				                       	if( $term_id == $bundle_id ){
				                       		$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
				                       		$details_cls_name = '';
				                       		$count = 1;
				                       		foreach( $mc_cls_bundle_package_product as $pack_pr ){

			                       				if( $count != 1 ){
			                       					$details_cls_name .= ", ";
			                       				}
			                       				$bundle_term_data = get_term_by( 'id', $pack_pr , 'mc-class-category' );
			                       				$details_cls_name .= $bundle_term_data->name;
			                       				$count++;
			                       			}

				                       		$term_data_name = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
				                       		$term_data_name .= ' ( '.$details_cls_name.' )';
				                       }else{
				                       		$term_data = get_term_by( 'id', $term_id , 'mc-class-category' );
				                       		$term_data_name = $term_data->name;
				                       }
				                       	$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
				                        $term_data = get_term_by( 'id', $term_id , 'mc-class-category' );
				                        //print_r($term_data);
				                    ?>
				                    <li><b>Class Name:</b>&nbsp;<?php echo $term_data_name; ?></li>
				                    
				                </ul>
				            </div>
				        </div>
				        <div class="mc_invloce_payment_right">
				            <div class="mc_invloce_payment_data_class_details">
				                <h2><b>User Details</b></h2>
				                <ul>
				                	<?php
				                        $user_id = get_post_meta( $payment->ID, '_mc_pay_user_id', true );
				                        $user_data = get_user_by( 'id', $user_id );
				                    ?>
				                    <li><b>Name:</b>&nbsp; <?php echo $user_data->display_name; ?></li>
				                    <li><b>Email:</b>&nbsp;<?php echo $user_data->user_email; ?></li>
				                    <li><b>Registered On:</b>&nbsp;<?php echo $user_data->user_registered; ?></li>
				                </ul>
				            </div>
				        </div>
			        </div>
                </td>
			</tr>
			<?php
					$i++;
				}
			?>
		</table>
		<link rel="stylesheet" type="text/css" media="print" href="<?php echo MC_CSS.'/print.css'; ?>">
		<div class="mcAccInvoiceGeneral">
			<div class="mcAccInvoiceGeneralContent">
				<div class="mcAccInvoiceBody" id="mcPrint">


				</div>
				<div class="mcAccInvoiceFooter">
					<div class="mcAccInvoiceFooterLeft">
						<button id="mcPrintInvoice">Print</button>
					</div>
					<div class="mcAccInvoiceFooterRight">
						<button id="mcCloseInvoice">Close</button>
					</div>
				</div>

			</div>

		</div>

		<script type="text/javascript">
			function printData()
			{
			   var divToPrint=document.getElementById("mcPrint");
			   newWin= window.open("");
			   newWin.document.write(divToPrint.outerHTML);
			   newWin.print();
			   newWin.close();
			}

			jQuery('#mcPrintInvoice').on('click',function(){
				printData();
			})
		</script>
		<?php
	}


}?>
