<?php
class MC_Payment_Controller
{
	public function __construct()
	{
		add_action( 'admin_head-edit.php', array($this,'highlight_payment_menu_item' ));
		
		add_filter( 'manage_mc_class_payment_posts_columns', array($this,'set_custom_payment_records_columns' ));
		add_action( 'manage_mc_class_payment_posts_custom_column' , array($this,'custom_payment_records_column_value'), 10, 2 );
	}

	public function set_custom_payment_records_columns( $old_columns ){
		$new_columns['cb'] = '';
		$new_columns['mc_record_id'] = __( 'ID', 'wordpress' );
		$new_columns['title'] = __( 'Title', 'wordpress' );
		$new_columns['mc_record_amount'] = __( 'Amount', 'wordpress' );

		$column = array_merge( $new_columns,$old_columns );

    	return $column;
	}
	public function highlight_payment_menu_item()
	{
	    global $current_screen;

	    if( 'mc_class_payment' != $current_screen->post_type )
	        return;

	        ?>
	        <style type="text/css">
	        	#mc_record_id{
	        		width: 10%;
	        	}
	        	.mc_record_id{
	        		font-weight: 900;
	        	}
	        	.mc_record_amount{
	        		font-size: 16px !important;
	        	}
	        	th.sortable a span, th.sorted a span{
	        		float: none;
	        	}
	        	.sorting-indicator{
	        		display: none !important;
	        	}
	        	.column-date, .column-mc_record_amount, .type-mc_class_payment td.title, th.sortable a, th.sorted a{
	        		text-align: center !important;
	        	}
	        </style>
	        <?php
	}

	public function custom_payment_records_column_value( $column, $post_id ){
		switch ( $column ) {

	        case 'mc_record_id' :
	            echo '#'.$post_id;
	            break;

	       	case 'mc_record_amount':
                $mc_cls_currency = get_post_meta( $post_id, '_mc_pay_currency', true );
                $currency_arr    = explode( "-", $mc_cls_currency);
                $currency        = strtoupper($currency_arr[0]);
			 	if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
                    echo $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
                    echo ' '.$currency;
                }else{
                    echo $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true ).' '.$currency;
                }
	       		break;

	    }
	}

	
	public static function process_payment($post, $user_id){



		/*echo '<pre>';
		print_r($post);
		echo '</pre>';*/
		//die;

		//if( !$post['mc_payment_method'] ){
			?>
			<!--<div class="mcErrorUl" style="color: red;">No payment method found, try to contact with site administrator.</div>-->
			<?php
	//	}
		
		switch ($post['mc_payment_method']) {
			case 'stripe':
				MC_Payment_Controller::stripe($user_id);
				break;

			/*case 'paypal_standard':
				MC_Payment_Controller::paypal_standard();
				break;*/

			case 'auth':
				MC_Payment_Controller::authorize();
				break;
			
		}
		
		
	}
	
	public static function authorize(){


		$auth_loginId 	= get_option('mc_cls_auth_api_login_id');
		$auth_tran_key 	= get_option('mc_cls_auth_tran_key');
		$auth_mode 		= get_option('mc_cls_auth_mode') ? get_option('mc_cls_auth_mode') : 'sandbox';

		if( $auth_loginId && $auth_tran_key){
			define("AUTHORIZENET_API_LOGIN_ID", $auth_loginId);
			define("AUTHORIZENET_TRANSACTION_KEY", $auth_tran_key);
			if($auth_mode=='live')
			{
				define("AUTHORIZENET_SANDBOX", false);
			}
			else
			{
				define("AUTHORIZENET_SANDBOX", true);
			}

			$card_num 		= trim($_POST['credit_card_no']);
			$card_exp_date 	= $_POST['credit_card_month'].'/'.$_POST['credit_card_year']; 
			$fname 			= $_POST['fname'];
			$cemail 		= $_POST['email'];

			$courseid = $_POST['courseId'];
	        

			$bundle_id = get_option( '_mc_class_bundle_id' );

	    	if( $courseid == $bundle_id ){
	    		$price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
	    		$courseid = $bundle_id;
	    		$invoice_num 	= $courseid.'-'.time();
	    	}else{
	    		$term_meta = get_option( "taxonomy_$courseid" );
				$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
				$invoice_num = $courseid.'-'.time();
	    	}


			$coupon_code = '';
			$actual_price = '';
			$dis_amount = '';
			if( isset($_POST['mc_applied_coupon_amount']) ){
				$price 			= $_POST['mc_applied_coupon_amount'];
				$coupon_code 	= $_POST['mc_applied_coupon_code'];
				$actual_price	= $_POST['mc_actual_price_before_coupon_code'];
				$dis_amount		= $_POST['mc_discount_amount'];
			}

			/*$sale = new AuthorizeNetAIM;
			$sale->amount = $price;
			$sale->card_num = $card_num;
			$sale->exp_date = $card_exp_date;*/

			$sale = new AuthorizeNetAIM;
            	$sale->setFields(
                    array(
                        'amount'        => $price,
                        'card_num'      => $card_num,
                        'exp_date'      => $card_exp_date,
                        'first_name'    => $fname,
                        'email_customer' => $cemail,
                        'email'			=> $cemail,
                        'invoice_num'   => $invoice_num
                    )
                );

			$response 		= $sale->authorizeAndCapture();

			$appr_status 	= $response->approved;
			$dec_status 	= $response->declined;
			$tran_id 		= $response->transaction_id;


			$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
        	

			if( $tran_id ){
				MC_Payment_Controller::save_payment_data($_POST['_mc_user_logged_in_id'],'none',$tran_id,$courseid,$price,$currency,$coupon_code,$actual_price,$dis_amount,'Authorize.NET');
			}else{
				?>
				<div class="mcErrorUl clas1" style="color:red;">Payment processing error occurred! Please try again after sometime</div>
				<?php
			}
    

		}else{
			?>
			<div class="mcErrorUl clas2" style="color:red;">Payment processing error occurred! Please try again after sometime</div>
			<?php
		}
		
	}

	public static function stripe($user_id){
		try{
		    $publish_key = get_option('mc_cls_stripe_publish_key');

    		Stripe::setApiKey( $publish_key );
    
            $result = Stripe_Token::create(
                        array(
                            "card" => array(
                                "number" => trim($_POST['credit_card_no']),
                                "exp_month" => $_POST['credit_card_month'],
                                "exp_year" => $_POST['credit_card_year'],
                                "cvc" => $_POST['credit_card_cvv']
                            )
                        )
                    );
                    
            $token = $result['id'];
           
    
            $secret_key 	 = get_option('mc_cls_stripe_private_key');
            $mc_cls_currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
            $currency_arr 	 = explode( "-", $mc_cls_currency);
            $currency 		 = strtoupper($currency_arr[0]);
    
            Stripe::setApiKey( $secret_key );
    
            $courseid 	= $_POST['courseId'];
            $term_meta 	= get_option( "taxonomy_$courseid" );
    		$price 		= esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
    
    		$bundle_id 	= get_option( '_mc_class_bundle_id' );
    		$fname 		= $_POST['fname'];
    		$cemail 	= $_POST['email'];
    
        	if( $courseid == $bundle_id ){
        		$price 	= get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
        		$invoice_num = $courseid.'-'.time();
        	}else{
        		$term_meta = get_option( "taxonomy_$courseid" );
    			$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
    			$invoice_num = $courseid.'-'.time();
        	}
    
    		$coupon_code = '';
    		$actual_price = '';
    		$dis_amount = '';
    		if( isset($_POST['mc_applied_coupon_amount']) ){
    			$price 			= $_POST['mc_applied_coupon_amount'];
    			$coupon_code 	= $_POST['mc_applied_coupon_code'];
    			$actual_price	= $_POST['mc_actual_price_before_coupon_code'];
    			$dis_amount		= $_POST['mc_discount_amount'];
    		}
    
    		/*$customer = Stripe_Customer::create(
    			array(
    				'description' => $courseid,
    				'email'	=> $cemail
    			),
    			$secret_key
    		);*/
    
            $amount = $price*100;
    		$charge = Stripe_Charge::create(
    		    array(
    		        'amount' 			=> $amount,
    		        'currency' 			=> $currency,
    		        'source' 			=> $token,	
    		        //'description' 		=> 'Custom descriptor',
    		        'metadata' => array('name' => $fname, 'email' => $cemail, 'invoice'	=> $invoice_num, 'customer'	=> $fname, 'courseid' => $courseid, 'coupon_code' => $coupon_code, 'actual_price' => $actual_price, 'discount_amount' => $dis_amount),
    		    ),
    		    $secret_key
    		);
    	
    
    		$id = $charge['id'];
    		$tran_id = $charge['balance_transaction'];
    		if( $id ){
    			MC_Payment_Controller::save_payment_data($_POST['_mc_user_logged_in_id'],$id,$tran_id,$courseid,$amount,$mc_cls_currency,$coupon_code,$actual_price,$dis_amount,'Stripe');
    		}else{
    			?>
    			<div class="mcErrorUl" style="color:red;">Payment processing error occurred! Please try again after sometime</div>
    			<?php
    		}
		}
		catch(Stripe_CardError $e) {
		      $body = $e->getJsonBody();
              $err  = $body['error'];
              print('<center><span class="class-makr-stripe-err" style="color:red">' . $err['message'] . "</span></center>");
		}
        catch (Stripe_InvalidRequestError $e) {
         $body = $e->getJsonBody();
              $err  = $body['error'];
             print('<center><span class="class-makr-stripe-err" style="color:red">' . $err['message'] . "</span></center>");
        } catch (Stripe_AuthenticationError $e) {
          $body = $e->getJsonBody();
              $err  = $body['error'];
              print('<center><span class="class-makr-stripe-err" style="color:red">' . $err['message'] . "</span></center>");
        } catch (Stripe_ApiConnectionError $e) {
         $body = $e->getJsonBody();
              $err  = $body['error'];
              print('<center><span class="class-makr-stripe-err" style="color:red">' . $err['message'] . "</span></center>");
        } catch (Stripe_Error $e) {
              $body = $e->getJsonBody();
              $err  = $body['error'];
              print('<center><span class="class-makr-stripe-err" style="color:red">' . $err['message'] . "</span></center>");
        } catch (Exception $e) {
              $body = $e->getJsonBody();
              $err  = $body['error'];
             print('<center><span class="class-makr-stripe-err" style="color:red">' . $err['message'] . "</span></center>");
        }
	}


	public static function save_payment_data($user_id,$charge_id='',$tran_id='',$course_id,$course_amount,$currency,$coupon_code,$actual_price,$dis_amount,$payment_through=''){
		$post_data = array(
		    'post_title' => 'Class Makr Payment @'.date('l, F d y h:i:s'),
		    'post_name' => 'master-class-payment-'.date('y-m-d-h-m-s'),
		    'post_type' => 'mc_class_payment',
		    'post_status' => 'publish'
		);

		$post_id = wp_insert_post( $post_data );
		update_post_meta( $post_id, '_mc_pay_user_id', $user_id );
		update_post_meta( $post_id, '_mc_pay_total_amount', $course_amount );
		update_post_meta( $post_id, '_mc_pay_currency', $currency );
		update_post_meta( $post_id, '_mc_pay_course_id', $course_id );
		update_post_meta( $post_id, '_mc_pay_charge_id', $charge_id );
		update_post_meta( $post_id, '_mc_pay_tran_id', $tran_id );
		update_post_meta( $post_id, '_mc_pay_coupon_code', $coupon_code );
		update_post_meta( $post_id, '_mc_pay_actual_price', $actual_price );
		update_post_meta( $post_id, '_mc_pay_discount_amount', $dis_amount );		
		update_post_meta( $post_id, '_mc_pay_through', $payment_through );



		$sys_tran_id = str_replace(' ', '-', strtolower(str_replace(" ", "", $payment_through))).strtotime("now").rand().$post_id;
		update_post_meta( $post_id, '_mc_pay_system_tran_id', $sys_tran_id );

		$user_info = get_userdata( $user_id );
		$to = $user_info->user_email;

		$bundle_id = get_option( '_mc_class_bundle_id' );
        if( $course_id == $bundle_id ){
        	$class_name = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
            $mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
            $count = 1;
            foreach( $mc_cls_bundle_package_product as $pack_pr ){
   				if( $count != 1 ){
   					$details_cls_name .= ", ";
   				}
   				$bundle_term_data = get_term_by( 'id', $pack_pr , 'mc-class-category' );
   				$details_cls_name .= $bundle_term_data->name;
   				$count++;
   			}
   			$class_name .= ' ( '.$details_cls_name.' )';
        }else{
        	$term_data = get_term_by( 'id', $course_id , 'mc-class-category' );
			$class_name = $term_data->name;
        }

	   	//$body = 'Hi '.$user_info->display_name.', <br/>You successfully subscribed <b><a href="'.get_term_link( $term_data->slug, $term_data->taxonomy ).'">'.$term_data->name.'</a></b><br/>Please <a href="'.site_url().'/mc-login/?login=success">login to your account</a> and access your all subscribed classes from "My Courses" section. <br/><br/>Thanks';

		$body = (get_option( 'mc_eml_cust_body_three' )) ? get_option( 'mc_eml_cust_body_three' ) : 'Hi [DISPLAYNAME],<br/>You successfully subscribed <b>[CLASSNAME].</b><br/><p>Kindly <a href="[LOGINURL]">LogIn</a> to your account and access all classes.</p><p>Note that your classes are within the "My Courses" section.</p><br/><br/>Thanks,<br/>Class Makr.';	   	$mc_cls_currency = get_post_meta( $post_id, '_mc_pay_currency', true ) ? get_post_meta( $post_id, '_mc_pay_currency', true ) : 'usd-$';
	   	$currency_arr 	 = explode( "-", $mc_cls_currency);
        $currency 		 = strtoupper($currency_arr[0]);

	   	$receipt = '';
        $receipt .= '<h2><b>Payment Details</b></h2>';
		$receipt .=	'<ul>';
		$receipt .= '<li><i>Date:</i>&nbsp;&nbsp;&nbsp; '.get_the_date( "l F j, Y, @ h:m:s", $post_id ).'</li>';
		$receipt .= '<li><i>Payment Through:</i>&nbsp;&nbsp;&nbsp; '.get_post_meta( $post_id, "_mc_pay_through", true ).'</li>';
		$receipt .= '<li><i>Transacion ID:</i>&nbsp;&nbsp;&nbsp; '.get_post_meta( $post_id, "_mc_pay_system_tran_id", true ).'</li>';

		if( get_post_meta( $post_id, '_mc_pay_coupon_code', true ) != '' ){
			$receipt .= '<li><i>Coupon Code:</i>&nbsp;&nbsp;&nbsp;'.get_post_meta( $post_id, "_mc_pay_coupon_code", true).'</li>'; 
			$receipt .= '<li><i>Subtotal:</i>&nbsp;&nbsp;&nbsp;'.$currency_arr[1].''.get_post_meta( $post_id, "_mc_pay_actual_price", true ).' '.$currency.'</li>';
			$receipt .= '<li><i>Coupon Amount:</i>&nbsp;&nbsp;&nbsp;'.$currency_arr[1].''.get_post_meta( $post_id, "_mc_pay_discount_amount", true ).' '.$currency.'</li>';
		}

		$receipt .=	'<li><i>Amount:</i>&nbsp;&nbsp;&nbsp;';
		if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
            $receipt .= $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
        }else{
            $receipt .= $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true );
        }
		$receipt .= ' '.$currency.'</li>';

		$receipt .=		'</ul>';
		
		if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
            $amt = $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
        }else{
            $amt = $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true );
        }
        $paidWith=get_post_meta($post_id, "_mc_pay_through", true );
		$date=get_the_date( "l F j, Y, @ h:m:s", $post_id );
		
	   	$body = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$body);
		$body = str_replace('[USERNAME]',$user_info->user_email,$body);
		$body = str_replace('[CLASSNAME]',$class_name,$body);
		$body = str_replace('[USEREMAIL]',$user_info->user_email,$body);
		$body = str_replace('[DISPLAYNAME]',$user_info->display_name,$body);
		$body = str_replace('[PAYRECEIPT]',$receipt,$body);
		$body = str_replace('[AMOUNT]',$amt,$body);
		$body = str_replace('[PAIDWITH]',$paidWith,$body);
		$body = str_replace('[DATE]',$date,$body);
		$body = str_replace('[INVOICELINK]',home_url().'/mc-dashboard/',$body);
		$body = str_replace('[SITEURL]',get_site_url(),$body);
		$body = str_replace('[DOMAIN]',$_SERVER['SERVER_NAME'],$body);

		$body = MC_Email_Template_Controller::general_email_template($body);


		$subject = (get_option( 'mc_eml_cust_sub_three' )) ? get_option( 'mc_eml_cust_sub_three' ) : 'Subscribed Class: [CLASSNAME]';
		$subject = str_replace('[USERNAME]',$user_info->user_email,$subject);
		$subject = str_replace('[CLASSNAME]',$class_name,$subject);
		$subject = str_replace('[USEREMAIL]',$user_info->user_email,$subject);
		$subject = str_replace('[DISPLAYNAME]',$user_info->display_name,$subject);


		$headers = array('Content-Type: text/html; charset=UTF-8');
		 
		wp_mail( $to, $subject, $body, $headers );


		
		$to2 = get_option('admin_email');
		//$body2 = 'Hi Admin, <br/><b><a href="'.get_term_link( $term_data->slug, $term_data->taxonomy ).'">'.$term_data->name.'</a></b> is subscribed by '.$user_info->display_name.' ( '.$user_info->user_email.' ). <br/>Payment Record ID: #'.$post_id.'   <br/>To know more <a href="'.site_url().'/wp-admin/post.php?post='.$post_id.'&action=edit">Click Here.</a><br/><br/>Thanks';

		$default='Hi Admin,';
        $default.='<br>Congratulations! A new person has signed up for your class.';
        $default.='<br><strong>Customer name:</strong> [DISPLAYNAME]';
        $default.='<br><strong>Email:</strong> [USEREMAIL]';
        $default.='<br><strong>Class name:</strong> [CLASSNAME]';
        $default.='<br><strong>Amount paid:</strong> [AMOUNT]';
        $default.='<br><strong>Paid with:</strong> [PAIDWITH]';
        $default.='<br>Date [DATE]';
                    
        $default.='<br>Click <a href="[INVOICELINK]">here</a> to see the customer’s details. ';
        $default.='<br><a href="[SITEURL]">[DOMAIN]</a>';
		
		$body2 = (get_option( 'mc_eml_cust_body_seven' )) ? get_option( 'mc_eml_cust_body_seven' ) : $default;
		$body2 = str_replace('[USERNAME]',$user_info->user_email,$body2);
		$body2 = str_replace('[CLASSNAME]',$class_name,$body2);
		$body2 = str_replace('[USEREMAIL]',$user_info->user_email,$body2);
		$body2 = str_replace('[DISPLAYNAME]',$user_info->display_name,$body2);
        $body2 = str_replace('[PAYRECEIPT]',$receipt,$body2);
        $body2 = str_replace('[AMOUNT]',$amt,$body2);
		$body2 = str_replace('[PAIDWITH]',$paidWith,$body2);
		$body2 = str_replace('[DATE]',$date,$body2);
		$body2 = str_replace('[INVOICELINK]',get_admin_url().'post.php?post='.$post_id.'&action=edit',$body2);
		$body2 = str_replace('[SITEURL]',get_site_url(),$body2);
		$body2 = str_replace('[DOMAIN]',$_SERVER['SERVER_NAME'],$body2);
        
        
        
		$body2 = MC_Email_Template_Controller::general_email_template($body2);

		//$subject2 = $term_data->name.' is subscribed by '.$user_info->user_email;

		$subject2 = (get_option( 'mc_eml_cust_sub_seven' )) ? get_option( 'mc_eml_cust_sub_seven' ) : 'Class Makr Subscription Notification';
		$subject2 = str_replace('[USERNAME]',$user_info->user_email,$subject2);
		$subject2 = str_replace('[CLASSNAME]',$class_name,$subject2);
		$subject2 = str_replace('[USEREMAIL]',$user_info->user_email,$subject2);
		$subject2 = str_replace('[DISPLAYNAME]',$user->display_name,$subject2);


		$headers2 = array('Content-Type: text/html; charset=UTF-8');
		 
		wp_mail( $to2, $subject2, $body2, $headers2 );

		if( is_user_logged_in() ){
		    $price=get_post_meta( $post_id, '_mc_pay_total_amount', true );
		    $redirect=($price>0?'/mc-dashboard/?payment=true':'/mc-dashboard/?payment=true&pro=free');
			?>
			<script type="text/javascript">window.location.replace("<?php echo site_url(). $redirect; ?>");</script>
			<?php
		}else{
			?>
			<script type="text/javascript">window.location.replace("<?php echo site_url(). '/mc-login/?payment=true&register=true'; ?>");</script>
			<?php
		}
	}
}

