<?php
class Master_Register_Controller
{
	
	public function __construct()
	{
		add_action( 'init', array($this,'custom_post'));
		add_action( 'init', array($this,'custom_taxonomy'));

		add_action( 'admin_menu',array($this,'rearrange_class_menus'),0);
		add_action('admin_notices',[$this,'masterClass_admin_notice']);
		add_action( 'admin_footer', [$this,'append_taxonomy_descriptions_metabox'] );
	}
	public function masterClass_admin_notice()
	{
		$screen = get_current_screen();
	    if( $screen->id =='edit-mc_class_coupon' ):
			?>
		 <div class="error">
	        <div style="padding: 5px;">
	        	<?php _e( '<img src="'.MC_IMG.'/icon_lock.png" style="float:left;padding: 2px;width: 30px;" alt="master-class"><p style="text-transform: uppercase;font-weight: 600;"> &nbsp; Want to charge your users? Unlock this feature by getting the <a href="https://classmakr.com/" target="_blank">Pro version</a></p>', 'mc-lan' )?>
	        </div>
	      </div>
		<?php
		endif;
		if( $screen->id =='edit-mc_class_payment'):
			?>
		 <div class="error">
	        <div style="padding: 5px;">
	        	<?php _e( '<img src="'.MC_IMG.'/icon_lock.png" style="float:left;padding: 2px;width: 30px;" alt="master-class"><p style="text-transform: uppercase;font-weight: 600;"> &nbsp; TO RECEIVE ORDERS YOU WILL NEED TO GET THE <a href="https://classmakr.com/" target="_blank">Pro version</a></p>', 'mc-lan' )?>
	        </div>
	      </div>
		<?php
		endif;
		if( $screen->id =='edit-mc-class-category' && $screen->base == 'term'):
			?>
		 <div class="error">
	        <div style="padding: 5px;">
	        	<?php _e( '<img src="'.MC_IMG.'/icon_lock.png" style="float:left;padding: 2px;width: 30px;" alt="master-class"><p style="text-transform: uppercase;font-weight: 600;"> &nbsp; TO ADD UNLIMITED CLASSES YOU WILL NEED TO GET THE <a href="https://classmakr.com/" target="_blank">Pro version</a></p>', 'mc-lan' )?>
	        </div>
	      </div>
		<?php
		endif;


	}
	
	public static function custom_post(){

		$labels = array(
			'name'               => _x( 'Class Makr', 'mc-lan'),
			'singular_name'      => _x( 'Class Makr', 'mc-lan' ),
			'add_new'            => _x( 'Add a New Lesson', 'mc-lan' ),
			'add_new_item'       => __( 'Add a New Lesson' ),
			'edit_item'          => __( 'Edit Lesson', 'mc-lan' ),
			'new_item'           => __( 'New Lesson', 'mc-lan' ),
			'all_items'          => __( 'Lessons', 'mc-lan' ),
			'search_items'       => __( 'Search Lesson', 'mc-lan' ),
			'not_found'          => __( 'No lesson found', 'mc-lan' ),
			'not_found_in_trash' => __( 'No lesson found in the trash', 'mc-lan' ),
			'parent_item_colon'  => '',

		);
		$args = array(
			'labels'      => $labels,
			'public'  => true,
			'show_ui' => true,
			'has_archive' => true,
			'publicly_queryable'  => true,
			'with_front' => true,
			'menu_icon'		=> MC_IMG.'/icon.png',
			'supports'           => array( 'title', 'editor' ),
		);
		register_post_type( 'mc-class', $args );

		$labels = array(
			'name'               => _x( 'Class Makr Orders', 'mc-lan'),
			'singular_name'      => _x( 'Class Makr Orders', 'mc-lan' ),
			'add_new'            => _x( 'Add New Class Makr Orders', 'mc-lan' ),
			'add_new_item'       => __( 'Add New Class Makr Orders' ),
			'edit_item'          => __( 'Edit Class Makr Orders', 'mc-lan' ),
			'new_item'           => __( 'New Class Makr Orders', 'mc-lan' ),
			'all_items'          => __( 'Orders', 'mc-lan' ),
			'search_items'       => __( 'Search Class Makr Orders', 'mc-lan' ),
			'not_found'          => __( 'No Class Makr Orders found', 'mc-lan' ),
			'not_found_in_trash' => __( 'No Class Makr Orders found in the trash', 'mc-lan' ),
			'parent_item_colon'  => '',

		);
		$args = array(
			'labels'      => $labels,
			'public'  => false,
			'show_ui' => true,
			'has_archive' => true,
			'publicly_queryable'  => false,
			'with_front' => false,
			'supports'   => array('title' ),
			'capability_type' => 'post',
			'capabilities' => array(
				'create_posts' => 'do_not_allow', 
			),
			'map_meta_cap' => true,
			'show_in_menu' => 'edit.php?post_type=mc-class'
		);
		register_post_type( 'mc_class_payment', $args );

		
		$labels = array(
			'name'               => _x( 'Class Makr Coupon', 'mc-lan'),
			'singular_name'      => _x( 'Class Makr Coupon', 'mc-lan' ),
			'add_new'            => _x( 'Add New Class Makr Coupon', 'mc-lan' ),
			'add_new_item'       => __( 'Add New Class Makr Coupon' ),
			'edit_item'          => __( 'Edit Class Makr Coupon', 'mc-lan' ),
			'new_item'           => __( 'New Class Makr Coupon', 'mc-lan' ),
			'all_items'          => __( 'Coupons', 'mc-lan' ),
			'search_items'       => __( 'Search Class Makr Coupon', 'mc-lan' ),
			'not_found'          => __( 'No Class Makr Coupon found', 'mc-lan' ),
			'not_found_in_trash' => __( 'No Class Makr Coupon found in the trash', 'mc-lan' ),

		);
		$args = array(
			'labels'      => $labels,
			'public'  => true,
			'show_ui' => true,
			'has_archive' => true,
			'publicly_queryable'  => true,
			'with_front' => false,
			'supports'   => array('title' ),
			'capability_type' => 'post',
			'capabilities' => array(
			    'create_posts' => 'do_not_allow',
			  ),
			'map_meta_cap' => true,
			'show_in_menu' => 'edit.php?post_type=mc-class'
		);
		register_post_type( 'mc_class_coupon', $args );
	}
	public static function custom_taxonomy(){
		$labels = array(
			'name'              => _x( 'Class', 'Class', 'mc-lan' ),
			'singular_name'     => _x( 'Class', 'Class', 'mc-lan' ),
			'search_items'      => __( 'Search Class', 'mc-lan' ),
			'all_items'         => __( 'All Class', 'mc-lan' ),
			'edit_item'         => __( 'Edit Class', 'mc-lan' ),
			'update_item'       => __( 'Update Class', 'mc-lan' ),
			'add_new_item'      => __( 'Add New Class', 'mc-lan' ),
			'new_item_name'     => __( 'New Class Name', 'mc-lan' ),
			'menu_name'         => __( 'Classes', 'mc-lan' ),
		);

		$args = array(
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array( 'slug' => 'mc-class-category' ),
		);

		register_taxonomy( 'mc-class-category', array( 'mc-class' ), $args );
	}

	public static function rearrange_class_menus(){
		global $submenu;
	  	$found = FALSE;
	  	$before = $after = array();
	  	$tax_slug = 'mc-class-category';
	  	$custom_post_menu = $submenu['edit.php?post_type=mc-class'];

	  	$category = array_pop($custom_post_menu);
		$add_new_lessons = array_pop($custom_post_menu);
		$all_lesson = array_pop($custom_post_menu);
		$add_new_lesson = array_pop($custom_post_menu);
		$orders = array_pop($custom_post_menu);
		$coupons = array_pop($custom_post_menu);
		$email_customizer = array_pop($custom_post_menu);
		$general_settings = array_pop($custom_post_menu);
		$users = array_pop($custom_post_menu);
		$email_campaign = array_pop($custom_post_menu);

		array_push($custom_post_menu, $category);
		array_push($custom_post_menu, $all_lesson);
		array_push($custom_post_menu, $add_new_lessons);
		array_push($custom_post_menu, $orders);
		array_push($custom_post_menu, $coupons);
		array_push($custom_post_menu, $email_customizer);
		array_push($custom_post_menu, $email_campaign);
		array_push($custom_post_menu, $users);
		array_push($custom_post_menu, $general_settings);

	  	$submenu['edit.php?post_type=mc-class'] = $custom_post_menu;
	}
	public function append_taxonomy_descriptions_metabox() {
        $post_types = array( 'mc-class-category' ); 
        global $pagenow;
       
            if(isset($_GET['taxonomy']) && $_GET['taxonomy']=='mc-class-category' &&  $pagenow=='edit-tags.php')
            {
                ?>
                <script type="text/javascript">
                    jQuery(function($){
                        $("ducument").ready(function(){
                            $("#tag-name").parent().find("p").html("This is your class name title.");
                            $("#tag-slug").parent().find("p").html('The "slug" is a URL-friendly address of a specific page liked <a href="http://domain.com/" target="_blank">domain.com/</a><b>class-name/</b> It is usually all lowercase and contains only letters, numbers, and hyphens.');
                         
                            
                        });
                    });
                 </script>
                <?php
            }
            if(isset($_GET['taxonomy']) && $_GET['taxonomy']=='mc-class-category' &&  $pagenow=='term.php')
            {
                ?>
                <script type="text/javascript">
                    jQuery(function($){
                        $("ducument").ready(function(){
                            $("#name").parent().find("p").html("This is your class name title.");
                            $("#slug").parent().find("p").html('The "slug" is a URL-friendly address of a specific page liked <a href="http://domain.com/" target="_blank">domain.com/</a><b>class-name/</b> It is usually all lowercase and contains only letters, numbers, and hyphens.');
                         
                         });
                    });
                 </script>
                <?php
            }
     }
	
}