<?php
class Master_Shortcode_Controller
{

	public function __construct()
	{
		add_shortcode('MASTER_CLASS', array($this,'all_mc_class_category'));
		//add_shortcode('NEXT_NAV', array($this, 'next_lesson_link_output'));
		//add_shortcode('PREV_NAV', array($this, 'previous_lesson_link_output'));

		add_shortcode('MASTERCLASS_LOGIN',array($this, 'add_login_form'));
		add_shortcode('MASTERCLASS_REGISTRATION',array($this, 'add_registration_form'));
		add_shortcode('MASTERCLASS_DASHBOARD',array($this, 'user_dashboard'));

		add_shortcode('MASTERCLASS_BUNDLE',array($this, 'bundle_class_view'));

	}


	public static function all_mc_class_category(){
		ob_start();
		$wcatTerms = get_terms('mc-class-category', array('hide_empty' => 0));
		?>
		<div class="mcContMainWrapper">
			<div class="mcContSubWrapper">
				<div class="mc-class-Cate clearfixMCclass">
					<?php foreach($wcatTerms as $wcatTerm) : ?>
					   	<div class="mcClassSingle">
								<div class="mcClassSingleMain">
							      	<a href="<?php echo get_term_link( $wcatTerm->slug, $wcatTerm->taxonomy ); ?>"></a>
							      		<?php
							      			$t_id = $wcatTerm->term_id;
					        				$term_meta = get_option( "taxonomy_$t_id" );
					        				$cover_id = $term_meta['mc_cat_cover_term_meta'];
					        				$mc_grad_term_meta = $term_meta['mc_grad_term_meta'];
							      		?>
							      		<div class="mcClassSingleCover">
													<div class="mcClassSingleCoverMain">
							      			<?php
							      				if( wp_get_attachment_url($cover_id) ){
							      					$img_url = wp_get_attachment_url($cover_id);

							      				}else{
							      					$img_url = MC_IMG.'/image-no.png';
							      				}
							      			?>
							      			<img src="<?php echo $img_url; ?>" />
													</div>
							      		</div>
							      		<div class="mcClassSingleCoverTxt">
							      			<h3><?php echo $wcatTerm->name; ?></h3>
													<!-- <h4>Sub Title Here</h4> -->

							      		</div>

										<?php
												$price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : 'FREE';
				                    			$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : '';
				                    			$currency_arr = explode("-",$currency);
				                    			if( $price == 'FREE' ){
				                    				echo '<div class="mcClassSingleCoverPer">'.$price.'</div>';
				                    			}else{
				                    				echo '<div class="mcClassSingleCoverPer">'.$currency_arr[1].$price.'</div>';
				                    			}
					      				?>

							   	</div>
							</div>
							<?php
								 $mc_tag_bck_clr = get_option('mc_tag_bck_clr') ? get_option('mc_tag_bck_clr') : "#0076CC";
							?>

					<?php endforeach; ?>
					<?php
						$mc_cls_bundle_on_class_listing = get_option('mc_cls_bundle_on_class_listing') ? get_option('mc_cls_bundle_on_class_listing') : 'disable';
						$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
						$mc_cls_bundle_title = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
						$mc_cls_bundle_price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : 'FREE';

						if( $mc_cls_bundle_on_class_listing == 'enable' && is_array($mc_cls_bundle_package_product) ){
							$img_url_arr = array();
							foreach( $mc_cls_bundle_package_product as $pack_product ){
								$pack_term_meta = get_option( "taxonomy_$pack_product" );
					        	$pack_cover_id = $pack_term_meta['mc_cat_cover_term_meta'];
					        	if( wp_get_attachment_url($pack_cover_id) ){
			      					$pack_img_url = wp_get_attachment_url($pack_cover_id);

			      				}else{
			      					$pack_img_url = MC_IMG.'/image-no.png';
			      				}
			      				$img_url_arr[] = $pack_img_url;
							}
							?>
							<div class="mcClassSingle">
								<div class="mcClassSingleMain">
									<a href="<?php echo site_url().'/mc-bundle'; ?>"></a>
										<div class="mcClassSingleCover">
											<div class="mcClassSingleCoverMain">
											<?php
												$count = 1;
												foreach( $img_url_arr as $img_url ){
													if( $count == 2 ){ echo "<div class='mcBundleAssImg'> "; }
											?>
												<img src="<?php echo $img_url; ?>" />
											<?php
												$count++;
												}
												if( $count >=2 ){ echo "</div> "; }
											?>
											</div>
										</div>
										<div class="mcClassSingleCoverTxt">
											<h3><?php echo $mc_cls_bundle_title; ?></h3>
										</div>
										<?php
											$currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : '';
											$currency_arr = explode("-",$currency);
											if( $mc_cls_bundle_price == 'FREE' ){
												echo '<div class="mcClassSingleCoverPer">'.$mc_cls_bundle_price.'</div>';
											}else{
												echo '<div class="mcClassSingleCoverPer">'.$currency_arr[1].$mc_cls_bundle_price.'</div>';
											}
										?>
								</div>
							</div>
							<?php
						}

					?>
					<style type="text/css">
						.mcClassSingleCoverPer{
							background-color: <?php echo $mc_tag_bck_clr; ?> !important;
						}
						.mcClassSingleCoverPer:before{
							border-right-color: <?php echo $mc_tag_bck_clr; ?> !important;
						}
					</style>
				</div>
			</div>
		</div>
		<?php
    	return ob_get_clean();
	}

	public static function add_registration_form(){
		ob_start();
		MC_Login_Register_Controller::login_register_form_html('registration');
		return ob_get_clean();
	}

	public static function add_login_form(){
    
       if(is_user_logged_in())
       {
           ob_start();
           ?>
           <center>You are already logged in. Go to <a href="<?php echo get_permalink(get_option('_mc_class_account_page_id'))?>">dashboard</a></center>
           <?php
           return ob_get_clean();
       }
    
		ob_start();
		if( !$_GET ){
			$show = 'login';
		}else{
			$show = '';
		}
		MC_Login_Register_Controller::login_register_form_html($show);
		if( $show == 'login' ){
		?>
		<script type="text/javascript">
			if (history.pushState) {
				var newurl = window.location.protocol + "//" + window.location.host + window.location.pathname + '?login=success';
				window.history.pushState({path:newurl},'',newurl);
			}
		</script>
		<?php
		}
		return ob_get_clean();
	}

	public static function user_dashboard(){
		if(!is_admin())
		{
			ob_start();
			MC_My_Account_Controller::account_dashboard();
			return ob_get_clean();
		}
	}

	public static function bundle_class_view(){
		ob_start();
		MC_Bundle_Controller::display_bundle_html();
		return ob_get_clean();
	}

}