<?php
class MC_Square_Payment_Controller
{
	public function __construct()
	{

		add_action('wp_enqueue_scripts', array($this, 'mc_form_script_style'));


		add_action('wp_ajax_wpep_submit_payment2', array($this, 'wpep_submit_payment2'));
        add_action('wp_ajax_nopriv_wpep_submit_payment2', array($this, 'wpep_submit_payment2'));
	}

	public function wpep_submit_payment2() {

        if(!$_POST['user_id']){

			if( !$_POST['email'] && !$_POST['password'] ){
				$result = array('status' => 'error', 'message' => __('User details not found', 'mc-lan'));
			}else{
				if ( email_exists( $_POST['email'] ) ) {
			    	$result = array('status' => 'error', 'message' => __('Email already exists', 'mc-lan'));
				}else{
					$username   =   sanitize_user( $_POST['email'] );
					$password   =   esc_attr( $_POST['password'] );
					$email      =   sanitize_email( $_POST['email'] );
					$first_name =   sanitize_text_field( $_POST['fname'] );
					$userdata = array(
				        'user_login'    =>   $username,
				        'user_email'    =>   $email,
				        'user_pass'     =>   $password,
				        'first_name'    =>   $first_name,
				        'role'			=>   'mc_learner'
			        );
			        $user_id = wp_insert_user( $userdata );
			        $add_to_email_campaign = Master_Email_API_Controller::save_to_campaign($email,$first_name);
				}
			}
			

			
		}else{
			$user_id = $_POST['user_id'];
		}

        $result = array('status' => '', 'message' => '');
      	$courseid = $_POST['courseId'];
		        
		$bundle_id = get_option( '_mc_class_bundle_id' );

    	if( $courseid == $bundle_id ){
    		$amount = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
    		$courseid = $bundle_id;
    	}else{
    		$term_meta = get_option( "taxonomy_$courseid" );
			$amount = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
    	}

    	$coupon_code = '';
    	$actual_price = '';
		$dis_amount = '';
		if( isset($_POST['mc_applied_coupon_amount']) ){
			$amount = $_POST['mc_applied_coupon_amount'];
			$coupon_code = $_POST['mc_applied_coupon_code'];
			$actual_price	= $_POST['mc_actual_price_before_coupon_code'];
			$dis_amount		= $_POST['mc_discount_amount'];
		}

        $card_nonce = $_POST['nonce'];
        $buyerVerification = $_POST['buyerVerify'];

        if( $user_id ){
	        if ($amount > 0 && $card_nonce) {
	            //get square settings
	            $mode = get_option('mc_cls_square_mode') ? get_option('mc_cls_square_mode') : 'sandbox';
	            $token = get_option('mc_cls_square_access_token');
	            $location_id = get_option('mc_cls_square_loc_id');

	            if ($mode == 'sandbox') {

	                $access_token = $token  ;
	                # setup authorization
	                $api_config = new \SquareConnect\Configuration();
	                $api_config->setHost("https://connect.squareupsandbox.com");
	                $api_config->setAccessToken($access_token);
	                $api_client = new \SquareConnect\ApiClient($api_config);
	                # create an instance of the Location API
	                $locations_api = new \SquareConnect\Api\LocationsApi($api_client);

	            } else {

	                $api_config = new \SquareConnect\Configuration();
	                $api_config->setHost("https://connect.squareup.com");
	                $api_config->setAccessToken($token);
	                $api_client = new \SquareConnect\ApiClient($api_config);
	                $locations_api = new \SquareConnect\Api\LocationsApi($api_client);

	            }
	            

	            if ($token && $location_id) {
	                try {

	                    $note_fields = 'Class Makr payment from '.site_url().' for course ID: '.$_POST['courseId'];
	                    $mc_cls_currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : 'USD-$';
		                $currency_arr    = explode( "-", $mc_cls_currency);
		                $currency        = strtoupper($currency_arr[0]);
	                    
	                    $payments_api = new \SquareConnect\Api\PaymentsApi($api_client);
	                    $body = new \SquareConnect\Model\CreatePaymentRequest();
	                    $amountMoney = new \SquareConnect\Model\Money();
	                    $amountMoney->setAmount((int) round($amount, 2) * 100);
	                    
	                    $amountMoney->setCurrency($currency);
	                    $body->setSourceId($card_nonce);
	                    $body->setAmountMoney($amountMoney);
	                    $body->setLocationId($location_id);
	                    $body->setIdempotencyKey((string) time());
	                    $body->setVerificationToken($buyerVerification);
	                    $body->setNote($note_fields);

	                    $transaction = $payments_api->createPayment($body);

	                    $transactionData = json_decode($transaction, true);

	                    if (isset($transactionData['payment']['id'])) {
	                        $transactionId = $transactionData['payment']['id'];

	                        MC_Square_Payment_Controller::save_square_payment_data($user_id,'none',$transactionId,$courseid,$amount,$mc_cls_currency,$coupon_code,$actual_price,$dis_amount,'Square');
							if( is_user_logged_in() ){
								$redirect = site_url(). '/mc-dashboard/?payment=true';
							}else{
								$redirect = site_url(). '/mc-login/?payment=true&register=true';
							}

		                	$result = array('status' => 'success', 'message' => __('PAYMENT SUCCESSFUL', 'mc-lan'),'redirect'=>$redirect);

	                    }
	                } catch (Exception $ex) {
	                    $errors = $ex->getResponseBody()->errors;

			            $message = '';
			            foreach ($errors as $error) {
			                $message = $error->detail;
			                if (isset($error->field))
			                    //$message = $error->field . ' - ' . $error->detail; //For Developer Only
			                    $message = $error->detail;
			            }
			            $result = array('status' => 'error', 'message' => $message);
	                   
	                }
	            } else {
	                $result = array('status' => 'error', 'message' => __('Invalid square token or location id.', 'mc-lan'));
	            }
	        }
	    }else{
	    	$result = array('status' => 'error', 'message' => __('Error occurs in user creation. Payment is not successful.', 'mc-lan'));
	    }
        echo json_encode($result);
        wp_die();
    }


    public function mc_form_script_style() {
		global $post;
		$enable_mode = get_option('mc_cls_square_status');
		$mode = get_option('mc_cls_square_mode');
		if($enable_mode == 'enable'){
			if ($mode == 'sandbox') {
			    wp_register_script('mc-square-paymentform', 'https://js.squareupsandbox.com/v2/paymentform', '', '', true);
			    wp_register_script('mc-square-paymentform2', 'https://connect.squareupsandbox.com/v2/paymentform', '', '', true);
			}else{
			    wp_register_script('mc-square-paymentform', 'https://js.squareup.com/v2/paymentform', '', '', true);
			}
		}
    }

	public static function square_process_payment(){
		// //echo "<pre>"; print_r($_POST); echo "</pre>";
		if(!$_POST['user_id']){

			if( !$_POST['email'] && !$_POST['password'] ){
				$result = array('status' => 'error', 'message' => __('User details not found', 'mc-lan'));
			}else{
				if ( email_exists( $_POST['email'] ) ) {
			    	$result = array('status' => 'error', 'message' => __('Email already exists', 'mc-lan'));
				}else{
					$username   =   sanitize_user( $_POST['email'] );
					$password   =   esc_attr( $_POST['password'] );
					$email      =   sanitize_email( $_POST['email'] );
					$first_name =   sanitize_text_field( $_POST['fname'] );
					$userdata = array(
				        'user_login'    =>   $username,
				        'user_email'    =>   $email,
				        'user_pass'     =>   $password,
				        'first_name'    =>   $first_name,
				        'role'			=>   'mc_learner'
			        );
			        $user_id = wp_insert_user( $userdata );
				}
			}
			

			
		}else{
			$user_id = $_POST['user_id'];
		}
		
		if( $user_id ){

			$token = get_option('mc_cls_square_access_token');
	        $location_id = get_option('mc_cls_square_loc_id');
	        $card_nonce = $_POST['nonce'];
	        if ($token && $location_id) {
		        try {
		            
		            $transaction_api = new \SquareConnect\Api\TransactionApi();
		            $idempotencyKey = time();
		            
		            $mc_cls_currency = get_option('mc_cls_currency') ? get_option('mc_cls_currency') : 'USD-$';
		    		$currency_arr    = explode( "-", $mc_cls_currency);
		    		$currency        = strtoupper($currency_arr[0]);

		    		$courseid = $_POST['courseId'];
		        
					$bundle_id = get_option( '_mc_class_bundle_id' );

			    	if( $courseid == $bundle_id ){
			    		$amount = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : '';
			    		$courseid = $bundle_id;
			    	}else{
			    		$term_meta = get_option( "taxonomy_$courseid" );
						$amount = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : '';
			    	}

			    	$coupon_code = '';
					$actual_price = '';
					$dis_amount = '';
					if( isset($_POST['mc_applied_coupon_amount']) ){
						$amount = $_POST['mc_applied_coupon_amount'];
						$coupon_code = $_POST['mc_applied_coupon_code'];
						$actual_price	= $_POST['mc_actual_price_before_coupon_code'];
						$dis_amount		= $_POST['mc_discount_amount'];
					}

		            $args = array(
		                'idempotency_key' => (string) $idempotencyKey,
		                'amount_money' => array(
		                    'amount' => round($amount, 2) * 100,
		                    'currency' => $currency
		                ),
		                'card_nonce' => $card_nonce,
		                'reference_id' => (string) $idempotencyKey
		            );
					$args['note'] = __('Class Makr Payment','mc-lan');
					$transaction = $transaction_api->charge($token, $location_id, $args);
		            $transactionData = json_decode($transaction, true);
		            if (isset($transactionData['transaction']['id'])) {
		                $transactionId = $transactionData['transaction']['id'];

				    	

						MC_Square_Payment_Controller::save_square_payment_data($user_id,'none',$transactionId,$courseid,$amount,$mc_cls_currency,$coupon_code,$actual_price,$dis_amount,'Square');
						if( is_user_logged_in() ){
							$redirect = site_url(). '/mc-dashboard/?payment=true';
						}else{
							$redirect = site_url(). '/mc-login/?payment=true&register=true';
						}

		                $result = array('status' => 'success', 'message' => __('PAYMENT SUCCESSFUL', 'mc-lan'),'redirect'=>$redirect);
		            }
		        } catch (Exception $ex) {
		            $errors = $ex->getResponseBody()->errors;

		            $message = '';
		            foreach ($errors as $error) {
		                $message = $error->detail;
		                if (isset($error->field))
		                    //$message = $error->field . ' - ' . $error->detail; //For Developer Only
		                    $message = $error->detail;
		            }
		            $result = array('status' => 'error', 'message' => $message);
		        }
		    } else {
		        $result = array('status' => 'error', 'message' => __('Invalid square token or location id.', 'mc-lan'));
		    }
		}else{
			$result = array('status' => 'error', 'message' => __('Error occurs in user creation. Payment is not successful.', 'mc-lan'));
		}
		echo json_encode($result);
        wp_die();
	}

	
	public static function save_square_payment_data($user_id,$charge_id='',$tran_id='',$course_id,$course_amount,$currency,$coupon_code,$actual_price,$dis_amount,$payment_through=''){
		$post_data = array(
		    'post_title' => 'Class Makr Payment @'.date('l, F d y h:i:s'),
		    'post_name' => 'master-class-payment-'.date('y-m-d-h-m-s'),
		    'post_type' => 'mc_class_payment',
		    'post_status' => 'publish'
		);

		$post_id = wp_insert_post( $post_data );
		update_post_meta( $post_id, '_mc_pay_user_id', $user_id );
		update_post_meta( $post_id, '_mc_pay_total_amount', $course_amount );
		update_post_meta( $post_id, '_mc_pay_currency', $currency );
		update_post_meta( $post_id, '_mc_pay_course_id', $course_id );
		update_post_meta( $post_id, '_mc_pay_charge_id', $charge_id );
		update_post_meta( $post_id, '_mc_pay_tran_id', $tran_id );
		update_post_meta( $post_id, '_mc_pay_coupon_code', $coupon_code );
		update_post_meta( $post_id, '_mc_pay_actual_price', $actual_price );
		update_post_meta( $post_id, '_mc_pay_discount_amount', $dis_amount );
		update_post_meta( $post_id, '_mc_pay_through', $payment_through );

		$sys_tran_id = str_replace(' ', '-', strtolower(str_replace(" ", "", $payment_through))).strtotime("now").rand().$post_id;
		update_post_meta( $post_id, '_mc_pay_system_tran_id', $sys_tran_id );

		$user_info = get_userdata( $user_id );
		$to = $user_info->user_email;

		$bundle_id = get_option( '_mc_class_bundle_id' );
        if( $course_id == $bundle_id ){
        	$class_name = get_option('mc_cls_bundle_title') ? get_option('mc_cls_bundle_title') : 'Class Package' ;
            $mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
            $count = 1;
            foreach( $mc_cls_bundle_package_product as $pack_pr ){
   				if( $count != 1 ){
   					$details_cls_name .= ", ";
   				}
   				$bundle_term_data = get_term_by( 'id', $pack_pr , 'mc-class-category' );
   				$details_cls_name .= $bundle_term_data->name;
   				$count++;
   			}
   			$class_name .= ' ( '.$details_cls_name.' )';
        }else{
        	$term_data = get_term_by( 'id', $course_id , 'mc-class-category' );
			$class_name = $term_data->name;
        }

		$body = (get_option( 'mc_eml_cust_body_three' )) ? get_option( 'mc_eml_cust_body_three' ) : 'Hi [DISPLAYNAME],<br/>You successfully subscribed <b>[CLASSNAME].</b><br/><p>Kindly <a href="[LOGINURL]">LogIn</a> to your account and access all classes.</p><p>Note that your classes are within the "My Courses" section.</p><br/><br/>Thanks,<br/>Class Makr.';
	   	$mc_cls_currency = get_post_meta( $post_id, '_mc_pay_currency', true ) ? get_post_meta( $post_id, '_mc_pay_currency', true ) : 'usd-$';
	   	$currency_arr 	 = explode( "-", $mc_cls_currency);
        $currency 		 = strtoupper($currency_arr[0]);

	   	$receipt = '';
        $receipt .= '<h2><b>Payment Details</b></h2>';
		$receipt .= '<ul>';
		$receipt .= '<li><i>Date:</i>&nbsp;&nbsp;&nbsp; '.get_the_date( "l F j, Y, @ h:m:s", $post_id ).'</li>';
		$receipt .= '<li><i>Payment Through:</i>&nbsp;&nbsp;&nbsp; '.get_post_meta( $post_id, "_mc_pay_through", true ).'</li>';
		$receipt .= '<li><i>Transacion ID:</i>&nbsp;&nbsp;&nbsp; '.get_post_meta( $post_id, "_mc_pay_system_tran_id", true ).'</li>';

		if( get_post_meta( $post_id, '_mc_pay_coupon_code', true ) != '' ){
			$receipt .= '<li><i>Coupon Code:</i>&nbsp;&nbsp;&nbsp;'.get_post_meta( $post_id, "_mc_pay_coupon_code", true).'</li>'; 
			$receipt .= '<li><i>Subtotal:</i>&nbsp;&nbsp;&nbsp;'.$currency_arr[1].''.get_post_meta( $post_id, "_mc_pay_actual_price", true ).' '.$currency.'</li>';
			$receipt .= '<li><i>Coupon Amount:</i>&nbsp;&nbsp;&nbsp;'.$currency_arr[1].''.get_post_meta( $post_id, "_mc_pay_discount_amount", true ).' '.$currency.'</li>';
		}
		$receipt .=	'<li><i>Amount:</i>&nbsp;&nbsp;&nbsp;';
		if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
            $receipt .= $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
        }else{
            $receipt .= $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true );
        }
		$receipt .= ' '.$currency.'</li>';

		$receipt .=		'</ul>';
		
		if(get_post_meta( $post_id, '_mc_pay_through', true ) == 'Stripe'){
            $amt = $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true )/100;
        }else{
            $amt = $currency_arr[1].''.get_post_meta( $post_id, '_mc_pay_total_amount', true );
        }
        $paidWith=get_post_meta($post_id, "_mc_pay_through", true );
		$date=get_the_date( "l F j, Y, @ h:m:s", $post_id );
		
		
	   	$body = str_replace('[LOGINURL]',site_url().'/mc-login/?login=success',$body);
		$body = str_replace('[USERNAME]',$user_info->user_email,$body);
		$body = str_replace('[CLASSNAME]',$class_name,$body);
		$body = str_replace('[USEREMAIL]',$user_info->user_email,$body);
		$body = str_replace('[DISPLAYNAME]',$user_info->display_name,$body);
		$body = str_replace('[PAYRECEIPT]',$receipt,$body);
		$body = str_replace('[AMOUNT]',$amt,$body);
		$body = str_replace('[PAIDWITH]',$paidWith,$body);
		$body = str_replace('[DATE]',$date,$body);
		$body = str_replace('[INVOICELINK]',home_url().'/mc-dashboard/',$body);
		$body = str_replace('[SITEURL]',get_site_url(),$body);
		$body = str_replace('[DOMAIN]',$_SERVER['SERVER_NAME'],$body);

		$body = MC_Email_Template_Controller::general_email_template($body);


		$subject = (get_option( 'mc_eml_cust_sub_three' )) ? get_option( 'mc_eml_cust_sub_three' ) : 'Subscribed Class: [CLASSNAME]';
		$subject = str_replace('[USERNAME]',$user_info->user_email,$subject);
		$subject = str_replace('[CLASSNAME]',$class_name,$subject);
		$subject = str_replace('[USEREMAIL]',$user_info->user_email,$subject);
		$subject = str_replace('[DISPLAYNAME]',$user_info->display_name,$subject);


		$headers = array('Content-Type: text/html; charset=UTF-8');
		 
		wp_mail( $to, $subject, $body, $headers );


		
		$to2 = get_option('admin_email');
    
        $default='Hi Admin,';
        $default.='<br>Congratulations! A new person has signed up for your class.';
        $default.='<br><strong>Customer name:</strong> [DISPLAYNAME]';
        $default.='<br><strong>Email:</strong> [USEREMAIL]';
        $default.='<br><strong>Class name:</strong> [CLASSNAME]';
        $default.='<br><strong>Amount paid:</strong> [AMOUNT]';
        $default.='<br><strong>Paid with:</strong> [PAIDWITH]';
        $default.='<br>Date [DATE]';
                    
        $default.='<br>Click <a href="[INVOICELINK]">here</a> to see the customer’s details. ';
        $default.='<br><a href="[SITEURL]">[DOMAIN]</a>';
    
		$body2 = (get_option( 'mc_eml_cust_body_seven' )) ? get_option( 'mc_eml_cust_body_seven' ) :$default;
		$body2 = str_replace('[USERNAME]',$user_info->user_email,$body2);
		$body2 = str_replace('[CLASSNAME]',$class_name,$body2);
		$body2 = str_replace('[USEREMAIL]',$user_info->user_email,$body2);
		$body2 = str_replace('[DISPLAYNAME]',$user_info->display_name,$body2);
        $body2 = str_replace('[PAYRECEIPT]',$receipt,$body2);
		$body2 = str_replace('[AMOUNT]',$amt,$body2);
		$body2 = str_replace('[PAIDWITH]',$paidWith,$body2);
		$body2 = str_replace('[DATE]',$date,$body2);
		$body2 = str_replace('[INVOICELINK]',get_admin_url().'post.php?post='.$post_id.'&action=edit',$body2);
		$body2 = str_replace('[SITEURL]',get_site_url(),$body2);
		$body2 = str_replace('[DOMAIN]',$_SERVER['SERVER_NAME'],$body2);
		
		
		$body2 = MC_Email_Template_Controller::general_email_template($body2);

		$subject2 = (get_option( 'mc_eml_cust_sub_seven' )) ? get_option( 'mc_eml_cust_sub_seven' ) : 'Class Makr Subscription Notification';
		$subject2 = str_replace('[USERNAME]',$user_info->user_email,$subject2);
		$subject2 = str_replace('[CLASSNAME]',$class_name,$subject2);
		$subject2 = str_replace('[USEREMAIL]',$user_info->user_email,$subject2);
		$subject2 = str_replace('[DISPLAYNAME]',$user->display_name,$subject2);


		$headers2 = array('Content-Type: text/html; charset=UTF-8');
		 
		wp_mail( $to2, $subject2, $body2, $headers2 );

		
	}
}