<?php
class MC_User_Details_Controller
{

	public function __construct()
	{
	    add_filter( 'manage_users_columns', array($this,'mc_user_column_value' ));

		add_filter( 'manage_users_custom_column', array($this,'mc_user_table_row_value'), 10, 3 );
		
		add_action ('admin_footer',array($this,'add_custom_css_user_column'));
		
		add_action( 'wp_ajax_active_suspend_account', array($this,'active_suspend_account_callback') );

		add_action( 'admin_menu', array($this,'add_users_link'));

		//add_action( 'admin_head-edit.php', array($this,'admin_user_edit_screen' ));

		add_action( 'show_user_profile', array($this,'learner_user_profile_fields'), 10, 1 );
		
		add_action( 'edit_user_profile', array($this,'learner_user_profile_fields'), 10, 1 );

		add_action('personal_options_update', array($this,'learner_account_status_update'));

		add_action('edit_user_profile_update', array($this,'learner_account_status_update'));

		
	}

	public function learner_account_status_update( $user_id ){
		if ( current_user_can('edit_user',$user_id) )
        	update_user_meta($user_id, 'mc_is_learner_active', $_POST['mc_is_learner_active']);
	}

	public function learner_user_profile_fields( $profileuser ) {
	?>
		<table class="form-table">
			<tr>
			  	<th>
			    	<label for="user_location"><?php esc_html_e( 'Account Status' ); ?></label>
			  	</th>
			  	<td>
			  		<?php $user_status = get_user_meta( $profileuser->ID, 'mc_is_learner_active', true) ? get_user_meta( $profileuser->ID, 'mc_is_learner_active', true) : 'no'; ?>
			    	<select name="mc_is_learner_active" class="regular-text" id="mc_is_learner_active">
			    		<option value="no" <?php if($user_status=='no'){ echo "selected=selected"; } ?>>Suspend</option>
			    		<option value="yes" <?php if($user_status=='yes'){ echo "selected=selected"; } ?>>Active</option>
			    	</select>
			  	</td>
			</tr>
		</table>
	<?php
	}

	public function add_users_link() {
		global $submenu;
		$link = admin_url( 'users.php?role=mc_learner' );
		 
		$submenu['edit.php?post_type=mc-class'][] = array( 'Users', 'manage_options', $link );
	}

	public function active_suspend_account_callback(){
		global $wpdb;
		check_ajax_referer( 're-un-subscribe-user', 'security' );
		$user_id = intval( $_POST['user_id'] );
		if( $_POST['method'] == 'suspend'){
			update_user_meta ( $user_id, 'mc_is_learner_active', 'no' );
		}

		if( $_POST['method'] == 'active'){
			update_user_meta ( $user_id, 'mc_is_learner_active', 'yes' );
		}

		die(); // this is required to return a proper result
	}
	
	public function add_custom_css_user_column(){
		$ajax_nonce = wp_create_nonce( "re-un-subscribe-user" );
		?>
		<style type="text/css">
			.column-learner_acc_status{ vertical-align:middle !important; }
			.mc-learn-active{ text-align:center; background-color:green; color:white; padding: 10px;margin: 26px;border-radius:10px; cursor: pointer; }
			.mc-learn-active:hover { background-color: darkgreen; }
			.mc-learn-inactive{ text-align:center; background-color:red; color:white; padding: 10px;margin: 26px;border-radius:10px; cursor: pointer; }
			.mc-learn-inactive:hover { background-color: darkred; }

			#your-profile > h2:first-child { display:none; }
		</style>
		<script type="text/javascript">
			function suspend_user(user_id){
				var warning = 'Are you want to Suspend this account?';
				var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
				if (confirm(warning)) {
				    jQuery( document ).ready( function( $ ) {
				    var data = {
				      action: 'active_suspend_account',
				      security: '<?php echo $ajax_nonce; ?>',
				      user_id: user_id,
				      method: 'suspend'
				    };
				    jQuery("#suspendbtn-"+user_id).html('<i>Please Wait...</i>');
				    jQuery("#suspendbtn-"+user_id).css('background-color','#bfbdbd');
				    $.post( ajaxurl, data, function( response ) {
				    	jQuery("#suspendbtn-"+user_id).html('<i>DONE</i>');
				      	alert("Successfully Updated");
				      	location.reload();
				    });
				  });
				}
			}
			function activate_user(user_id){
				var warning = 'Are you want to Activate this account?';
				var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
				if (confirm(warning)) {
				    jQuery( document ).ready( function( $ ) {
					    var data = {
					      action: 'active_suspend_account',
					      security: '<?php echo $ajax_nonce; ?>',
					      user_id: user_id,
					      method: 'active'
					    };
					    jQuery("#activebtn-"+user_id).html('<i>Please Wait...</i>');
					    jQuery("#activebtn-"+user_id).css('background-color','#bfbdbd');
					    $.post( ajaxurl, data, function( response ) {
					      jQuery("#activebtn-"+user_id).html('<i>DONE</i>');
					      alert("Successfully Updated");
					      location.reload();
					    });
					  });
				}
			}
		</script>
		<?php
	}
	public function mc_user_column_value( $column ) {
	    $column['learner_acc_status'] = 'Account Status';
	    return $column;
	}

	public function mc_user_table_row_value( $val, $column_name, $user_id ) {
	    global $wpdb;
		$cap = get_user_meta( $user_id, $wpdb->get_blog_prefix() . 'capabilities', true );
		if ( is_array( $cap ) && !empty( $cap['administrator'] ) ) { return '--'; }
	    switch ($column_name) {
	        case 'learner_acc_status' :
	            if( get_user_meta( $user_id, 'mc_is_learner_active', true) == 'yes'){
	            	return '<span id="suspendbtn-'.$user_id.'" onclick="suspend_user('.$user_id.')" class="mc-learn-active">Active</span>';
	            }else{
	            	return '<span id="activebtn-'.$user_id.'" onclick="activate_user('.$user_id.')" class="mc-learn-inactive">Suspend</span>';
	            }
	            return 'Great';
	            break;
	        default:
	    }
	    return $val;
	}
}?>