<?php
namespace ElementorModal\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;
use Elementor\Scheme_Typography;
use Elementor\Scheme_Color;
use Elementor\Group_Control_Border;
use Elementor\Group_Control_Background;
use Elementor\Group_Control_Box_Shadow;
use Elementor\Frontend;
use WP_Query;


if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class ElementorModal extends Widget_Base {
	
	protected $_has_template_content = false;
	
	public function get_name() {
		return 'popup';
	}
	public function get_title() {
		return __( 'All Class Listing', 'elementor' );
	}
	public function get_icon() {
		return 'fa fa-medium';
	}
	public function get_categories() {
		return [ 'master-class-elements' ];
	}
	public static function get_button_sizes() {
		return [
			'xs' => __( 'Extra Small', 'modal-for-elementor' ),
			'sm' => __( 'Small', 'modal-for-elementor' ),
			'md' => __( 'Medium', 'modal-for-elementor' ),
			'lg' => __( 'Large', 'modal-for-elementor' ),
			'xl' => __( 'Extra Large', 'modal-for-elementor' ),
		];
	}
	protected function get_popups() {
		$popups_query = new WP_Query( array(
			'post_type' => 'elementor-popup',
			'posts_per_page' => -1,
		) );

		if ( $popups_query->have_posts() ) {
			$popups_array = array();
			$popups = $popups_query->get_posts();
			
			$i = 0;
			foreach( $popups as $popap ) {
				$popups_array[$popap->ID] = $popap->post_title;
				if($i === 0)
					$selected = $popap->ID;
				$i++;
			}
			
			$popups = array(
				'first_popup' => $selected,
				'popups' => $popups_array,
			);
			return $popups;
		}
	}
	protected function _register_controls() {
		
		$this->start_controls_section(
			'section_popup',
			[
				'label' => __( 'Class Makr Shortcode', 'elementor' ),
			]
		);
		
		
		$this->add_control(
			'elementor_master_class_all',
			[
				'label' => __( 'Class Makr Shortcode', 'elementor' ),
				'type' => Controls_Manager::TEXTAREA,
				'default' => '[MASTER_CLASS]',
				'return_value' => 'yes',
				'description' => __( '', 'elementor' ),
			]
		);
        
        
		$this->end_controls_section();         

	}
	protected function render() {
		$settings 	= $this->get_settings();
		
		if( $settings['elementor_master_class_all'] ){
			echo do_shortcode($settings['elementor_master_class_all']);
		}

		
	}
	protected function _content_template() {}

}