<?php

// Tested on PHP 5.2, 5.3

// This snippet (and some of the curl code) due to the Facebook SDK.
if (!function_exists('curl_init')) {
  throw new Exception('Stripe needs the CURL PHP extension.');
}
if (!function_exists('json_decode')) {
  throw new Exception('Stripe needs the JSON PHP extension.');
}


abstract class Stripe
{
  public static $apiKey;
  public static $apiBase = 'https://api.stripe.com/v1';
  public static $verifySslCerts = true;
  const VERSION = '1.6.1';

  public static function getApiKey()
  {
    return self::$apiKey;
  }

  public static function setApiKey($apiKey)
  {
    self::$apiKey = $apiKey;
  }

  public static function getVerifySslCerts() {
    return self::$verifySslCerts;
  }

  public static function setVerifySslCerts($verify) {
    self::$verifySslCerts = $verify;
  }
}


// Utilities
require(dirname(__FILE__) . '/Stripe-lib/Util.php');
require(dirname(__FILE__) . '/Stripe-lib/Util/Set.php');

// Errors
require(dirname(__FILE__) . '/Stripe-lib/Error.php');
require(dirname(__FILE__) . '/Stripe-lib/ApiError.php');
require(dirname(__FILE__) . '/Stripe-lib/ApiConnectionError.php');
require(dirname(__FILE__) . '/Stripe-lib/AuthenticationError.php');
require(dirname(__FILE__) . '/Stripe-lib/CardError.php');
require(dirname(__FILE__) . '/Stripe-lib/InvalidRequestError.php');

// Plumbing
require(dirname(__FILE__) . '/Stripe-lib/Object.php');
require(dirname(__FILE__) . '/Stripe-lib/ApiRequestor.php');
require(dirname(__FILE__) . '/Stripe-lib/ApiResource.php');

// Stripe API Resources
require(dirname(__FILE__) . '/Stripe-lib/Charge.php');
require(dirname(__FILE__) . '/Stripe-lib/Customer.php');
require(dirname(__FILE__) . '/Stripe-lib/Invoice.php');
require(dirname(__FILE__) . '/Stripe-lib/InvoiceItem.php');
require(dirname(__FILE__) . '/Stripe-lib/Plan.php');
require(dirname(__FILE__) . '/Stripe-lib/Token.php');
require(dirname(__FILE__) . '/Stripe-lib/Coupon.php');
require(dirname(__FILE__) . '/Stripe-lib/Event.php');
